--活动面板配置相关API
--活动列表数据 提高效率
local activityList = {}

function InitActivityConfig()
	
	local pfile = core.getScripEngine():GetCsvScript("Activity")
	local row 	= pfile:Bound()
	
	for k=1, row-1 do
		local pRow = pfile:GetData(k)
		if pRow:IsInvalid() == false then
			local activityID 		= pRow:GetCol('activityID'):GetInt32()

			local activityDay 		= {}
			local activityDayCount  = pRow:GetCol('activityDay'):GetTableSize()
			for i=1, activityDayCount do
				table.insert(activityDay, pRow:GetCol('activityDay'):GetTableValue(i-1))
			end

			local activityTime		= {}
			local activityTimeCount = pRow:GetCol('activityTime'):GetTableSize()
			for i=1, activityTimeCount do
				table.insert(activityTime, pRow:GetCol('activityTime'):GetTableValue(i-1))
			end

			local activityLevel		= {}
			local activityLevelCount = pRow:GetCol('activityLevel'):GetTableSize()
			for i=1, activityLevelCount do
				table.insert(activityLevel, pRow:GetCol('activityLevel'):GetTableValue(i-1))
			end

			local activityName		= pRow:GetCol('activityName'):GetString()
			local activityType 		= pRow:GetCol('activityType'):GetInt32()
			local activityCount		= pRow:GetCol('activityCount'):GetInt32()
			
			local activityReward 	= {}
			local activityRewardCount = pRow:GetCol('activityRewardID'):GetTableSize()
			for i=1, activityRewardCount do
				local rewardInfo 	= GetRewardInfo(pRow:GetCol('activityRewardID'):GetTableValue(i-1))
				table.insert(activityReward, rewardInfo)
			end

			local activityMapICON 	= pRow:GetCol('activityMapICON'):GetString()
			local activityDesc 		= api_getCsvVar("ActivityDesc",activityID, "activityDesc"):GetString()
			local activityRewardDesc= api_getCsvVar("ActivityDesc",activityID, "activityRewardDesc"):GetString()
			local activityPriority 	= pRow:GetCol('activityPriority'):GetInt32()
			local activityExpLevel 	= pRow:GetCol('activityExpLevel'):GetInt32()
			local activityGoodsLevel= pRow:GetCol('activityGoodsLevel'):GetInt32()
			local activityPlace 	= pRow:GetCol('activityPlace'):GetString()
			local activityMonsterID= pRow:GetCol('activityMonsterID'):GetInt32()
			local activityWeek 		= {}
			local activityWeekCount = pRow:GetCol('activityWeek'):GetTableSize()
			for i=1, activityWeekCount do
				table.insert(activityWeek, pRow:GetCol('activityWeek'):GetTableValue(i-1))
			end

			local activityInfo = {
							activityID 			= activityID 		,
							activityDay			= activityDay		,
							activityTime		= activityTime		,
							activityName		= activityName		,
							activityLevel		= activityLevel		,
							activityType		= activityType		,
							activityCount		= activityCount		,
							activityReward		= activityReward	,
							activityMapICON 	= activityMapICON 	,
							activityDesc 		= activityDesc 		,
							activityRewardDesc 	= activityRewardDesc,
							activityPriority 	= activityPriority	,
							activityExpLevel 	= activityExpLevel	,
							activityGoodsLevel 	= activityGoodsLevel,
							activityPlace 		= activityPlace,
							activityMonsterID	= activityMonsterID,
							activityWeek 		= activityWeek,
						}
			table.insert(activityList, activityInfo)
		end
	end
	
end

--按照活动id获取活动/副本信息
function GetActivityInfoByActivityID(activityID)
	for k, v in pairs(activityList) do
		if v.activityID == activityID then
			return v
		end
	end
	return nil
end

--按照活动类型获取活动或者副本的信息
function GetAllActivityInfoByActivityType(actType)
	local activityInfoList = {}
	local pfile = core.getScripEngine():GetCsvScript("Activity")
	local row 	= pfile:Bound()

	for k, v in pairs(activityList) do
		--API_Trace(cjson.encode(v))
		if actType ~= nil and actType ~= v.activityType then
			--如果指定了类型 类型不匹配则不返回 
			--不指定则返回所有活动和副本
		else
			--API_Trace("insert"..activityID)
			table.insert(activityInfoList, v)
		end
	end
	return activityInfoList
end

--返回指定等级可以参加的活动
function GetAllActivityInfoByLevel(lv)
	local activityInfoList = {}
	
	for k, v in pairs(activityList) do
		--API_Trace(cjson.encode(activityInfo))
		if lv >= v.activityLevel[1] and (v.activityLevel[2] == -1 or lv <= v.activityLevel[2]) then
			table.insert(activityInfoList, v)
		end
	end
	API_Trace(cjson.encode(activityInfoList))
	return activityInfoList
end

--根据rewardID 返回奖励的信息（图片名和tooltipid）
function GetRewardInfo(rewardID)
	local pRow = api_getCsvRow("ActivityRewardDesc", rewardID)
	if pRow:IsInvalid() then
		API_TraceError('wrong rewardID:'..rewardID)
		return
	end

	local rewardID 			= rewardID
	local rewardICON 		= pRow:GetCol('activityRewardICON'):GetInt32()
	local rewardToolTipID	= pRow:GetCol('activityToolTipID'):GetInt32()
	local rewardQuality		= pRow:GetCol('activityRewardQuality'):GetInt32()

	local rewardInfo 		= {
							rewardID			= rewardID ,
							rewardICON			= rewardICON ,
							rewardToolTipID		= rewardToolTipID ,
							rewardQuality 		= rewardQuality,
							}

	return rewardInfo
end

function GetGameGuideByID(guideID)
	local pRow = api_getCsvRow("GameGuide", guideID)
	if pRow:IsInvalid() then
		API_TraceError('wrong GameGuideID:'..guideID)
		return
	end

	local gameGuideInfo = {}

	gameGuideInfo.guideID 		= guideID
	gameGuideInfo.guideTitle 	= pRow:GetCol('guideTitle'):GetString()
	gameGuideInfo.guideContent 	= pRow:GetCol('guideContent'):GetString()


	return gameGuideInfo
end

--返回游戏指南的列表信息
function GetGameGuideList()
	local guideList = {}
	local pfile = core.getScripEngine():GetCsvScript("GameGuide")
	local row 	= pfile:Bound()
	
	for k=1, row-1 do
		local rowData = pfile:GetData(k)
		if rowData:IsInvalid() == false then
			local guideID 		= rowData:GetCol('guideID'):GetInt32()
			local gameGuideInfo = GetGameGuideByID(guideID)
			table.insert(guideList, gameGuideInfo)
		end
	end

	return guideList
end


------------------------------------------
InitActivityConfig()

