﻿---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\LUA\DeathPrompts.lua
--版  权:	(C)盛游
--日  期:	2013.5.16
--描  述:	死亡信息的提示的否决,以及一些其它的判断
----------------------------------------------------------------------------------------------------------------------

--死了之后不进行死亡提示的地图
local noPromptMaps =
{
	201,--锁妖塔一层	
	202,--锁妖塔二层	
	203,--锁妖塔三层		
	205,--血魔窟二层	
	206,--琅环阁一层	
	207,--琅环阁二层	
	208,--琅环阁三层	
	209,--琅环阁四层	
	210,--勇闯五行阵	
	211,--试炼谷	
	212,--试炼谷	
	213,--试炼谷	
	214,--试炼谷	
	215,--试炼谷	
	216,--试炼谷	
	217,--试炼谷	
	218,--试炼谷	
	219,--试炼谷	
	220,--试炼谷	
	221,--直捣魔窟	
	301,--魔族来袭一	
	302,--魔族来袭二
	222,--热血沙场	
	224,--天梯赛	
	225,--竞技场	
	226,--竞技场	
	227,--仙界争霸战
	405,--宠物乐园
}

--死了之后不弹出复活框的地图
local noPopRelive =
{	
	224,--天梯赛	
	225,--竞技场	
	226,--竞技场
	211,--试炼谷	
	212,--试炼谷	
	213,--试炼谷	
	214,--试炼谷	
	215,--试炼谷	
	216,--试炼谷	
	217,--试炼谷	
	218,--试炼谷	
	219,--试炼谷	
	220,--试炼谷	
	405,--宠物乐园
}

--需要强制显示遥感和强制隐藏其它窗口的地图，退出此地图的时候可见性将自动变回默认设置
local mustSetUI =
{	
	224,--天梯赛	
	225,--竞技场	
	226,--竞技场
}

--不显示那堆launch的地图
notShowLaunchGroupMap ={
	224,--天梯赛	
	225,--竞技场	
	226,--竞技场
	227,--仙界争霸战
	403,--雪人狂欢活动的副本
}


--当帧率小于该值时提示玩家修改显示设置以节省带宽
local needTipFps = 5

--判断是否显示死亡提示，如果是在特定的副本那么就不提示
function Whether_Death_Prompts(actorAtMapID)

	for i,noPromptMapID in pairs(noPromptMaps) do 
		if noPromptMapID==actorAtMapID then
			return false
		end
	end
	
	return true
end

--判断是否显示复活框，如果是在特定的副本那么就不显示
function Whether_Relive_pop(actorAtMapID)

	for i,noPoMapID in pairs(noPopRelive) do 
		if noPoMapID==actorAtMapID then
			if noPoMapID >= 211 and noPoMapID <= 220 then
				API_ShowShiLianGuDieWnd()
			end
			return false
		end
	end
	
	return true
end

--判断是否显示那堆launch
function Whether_ShowIconSet(actorAtMapID)

	for i,v in pairs(notShowLaunchGroupMap) do 
		if v==actorAtMapID then
			return false
		end
	end
	
	return true
end

--判断是否强制显示
function Whether_SetUI(actorAtMapID)

	for i,v in pairs(mustSetUI) do 
		if v==actorAtMapID then
			return true
		end
	end
	
	return false
end


--判断是否提示帧率太低，隐藏掉一些东西以节省带宽
function Whether_Tip_FPS(curfps)
	return needTipFps>curfps
end

