local s_module_list={};
local packet_listen_wnd_list = {}--监听背包双击事件调用函数报

function api_reg_module_msg_handler(module_name, handler)
	s_module_list[module_name] = handler;
end

function api_dispatch_script_msg(msgstring)
	local msgobj = cjson.decode(msgstring);
	local module_name = msgobj.module
	local handler = s_module_list[module_name]
	if(handler ~= nil) then
		handler(msgobj);
	else 
		--API_TraceError("fail to find module "..module_name);
	end
end

function api_call_function(fun_name,...)
	local fun = nil
	if type(fun_name) == "function" then
		fun = fun_name
	elseif type(fun_name) == "string" then
		fun = loadstring("return "..fun_name)()
	else
		fun = nil
	end
	if fun ~= nil and type(fun) == "function" then
		return fun(unpack(arg))
	else
		API_TraceError("api_call_function fail to call "..tostring(fun_name));
		return false
	end
end

--注册背包物品双击监听
function api_reg_packet_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	packet_listen_wnd_list[#packet_listen_wnd_list+1] = listen_fun
end
--玩家双击背包中某物品
--参数一，该物品的UID
--返回值，如果这里返回true表示已经处理了(比如双击背包某装备放到拍卖行中的viewbox)，那么背包就不会继续处理了(比如把这件装备穿在身上)
--注，先于IGoodsClient::AddPacketListenWnd()执行
function api_packet_add_goods(uid)
	--API_Trace(uid:ToString())
	for i=1,#packet_listen_wnd_list do
		local fun =packet_listen_wnd_list[i]
		if fun~=nil and fun(uid) == true then
			return true
		end
	end
	
	return false
end

--注册背包物品获得监听
local packet_add_listen_wnd_list = {}
function api_reg_packet_add_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	packet_add_listen_wnd_list[#packet_add_listen_wnd_list+1] = listen_fun
end
--玩家双击背包中某物品
--参数一，该物品的IContainerGoods * 
function api_packet_add_goods2(CGoods)
	for i=1,#packet_add_listen_wnd_list do
		local fun =packet_add_listen_wnd_list[i]
		if fun~=nil and fun(CGoods) == true then
			return true
		end
	end
	
	return false
end

--玩家切换场景监听注册
local hero_all_data_ready_listen_list = {}
--注册数据全下发事件
function api_reg_hero_all_data_ready_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	hero_all_data_ready_listen_list[#hero_all_data_ready_listen_list+1] = listen_fun
end
--取消注册
function api_unreg_hero_all_data_ready_listen(listen_fun)
	for i=1,#hero_all_data_ready_listen_list do
		local fun = hero_all_data_ready_listen_list[i]
		if fun == listen_fun then
			hero_all_data_ready_listen_list[i] = nil
			break
		end
	end
end

--玩家切换场景并且数据初始化完成
function On_HeroAllDataReady()
	for i=1,#hero_all_data_ready_listen_list do
		local fun =hero_all_data_ready_listen_list[i]
		if fun ~= nil then
			fun()
		end
	end
end



--systemwnd WE_SYSTEM_BAR_POS
local system_bar_pos_listen_list = {}
function api_reg_system_bar_pos_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	system_bar_pos_listen_list[#system_bar_pos_listen_list+1] = listen_fun
end
--取消注册
function api_unreg_system_bar_pos_listen(listen_fun)
	for i=1,#system_bar_pos_listen_list do
		local fun = system_bar_pos_listen_list[i]
		if fun == listen_fun then
			system_bar_pos_listen_list[i] = nil
			break
		end
	end
end

--systemwnd 显示或者关闭监听
function On_SystemBarPosChange()	
	for i=1,#system_bar_pos_listen_list do
		local fun =system_bar_pos_listen_list[i]
		if fun ~= nil then
			fun()
		end
	end
end


--背包容器变化监听
local packet_container_update_listen_list = {}
function api_reg_packet_container_update_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	packet_container_update_listen_list[#packet_container_update_listen_list+1] = listen_fun
end
--背包容器变化
function On_PacketContainerUpdate()
	for i=1,#packet_container_update_listen_list do
		local fun =packet_container_update_listen_list[i]
		fun()
	end
end


--背包容器被锁定监听
local packet_container_lock_listen_list = {}
function api_reg_packet_container_lock_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	packet_container_lock_listen_list[#packet_container_lock_listen_list+1] = listen_fun
end
--背包容器锁定
function On_PacketContainerLock()
	for i=1,#packet_container_lock_listen_list do
		local fun =packet_container_lock_listen_list[i]
		fun()
	end
end


--装备容器变化监听
local equip_container_update_listen_list = {}
function api_reg_equip_container_update_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	equip_container_update_listen_list[#equip_container_update_listen_list+1] = listen_fun
end
--装备容器变化
function On_EquipContainerUpdate()
	for i=1,#equip_container_update_listen_list do
		local fun =equip_container_update_listen_list[i]
		fun()
	end
end


--装备容器锁定监听
local equip_container_lock_listen_list = {}
function api_reg_equip_container_lock_listen(listen_fun)
	--这里暂时不考虑重复注册的情况
	equip_container_lock_listen_list[#equip_container_lock_listen_list+1] = listen_fun
end
--装备容器锁定
function On_EquipContainerLock()
	for i=1,#equip_container_lock_listen_list do
		local fun =equip_container_lock_listen_list[i]
		fun()
	end
end

--这里维护一个通用消息码用于和服务端交互
do
	api_reg_module_msg_handler("CommonMsg", function(msg)
			if(msg.msg_code=="OpenWnd") then
				WndSystem:GetInstance():ShowWnd(msg.wndID,0)
				WndSystem:GetInstance():ShowWnd(msg.wndID,1)
			else
				API_TraceError("unknown cmd ".. msg.msg_code);
			end	
		end
	);
end

