---------------------------------------------------------------------------------------------------------------------
--文件名:	WorkskillSys.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.12
--版  本:	1.0
--描  述:	炼器系统。
--			主要功能：
--			1.所有炼器的消息码从这里统一收发，这样做的一个好处是以后可以加些通用的判断流程。比如发送炼器消息码的时候可
--			以补个客户端的当前时间等。
--			2.定制一些通用函数供子模块使用，比如背包里有没有符合某炼器技能的道具。
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("FestivalBoss",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
modName = "FestivalBoss"
totalRankWnd = nil
dailyRankLaunch = nil
dailyRankWnd = nil

occNames		=
{
	[enActorOccupation_Paladin]				= "魔羽",
    [enActorOccupation_SwordKnightErrant] 	= "神剑",
	[enActorOccupation_Assassin] 			= "鬼影",
    [enActorOccupation_Tao]					= "仙乐",
}
--*常量 end**********************************************************--


--*3 变量************************************************************--
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
function init()
--累计积分奖励窗口
	totalRankWnd = core.createWindow('Data/Scp/Windows/Windows_FestivalBoss.scp',2000)
	
	--关闭按钮
	totalRankWnd:GetButton('btn_close'):SetClickEventHandler2(function()
				totalRankWnd:SetVisible(false)
			end)
			
			
--活动中排行Launch
	dailyRankLaunch = core.createWindow('Data/Scp/Windows/Windows_FestivalBoss.scp',2001)
	--切图不隐藏
	dailyRankLaunch:SetWndTraits(0x1000, true)
	dailyRankLaunch:SetShowEventHandler2(function()
		LaunchAdjwinpos()
	end)
	
	--屏幕变化
	dailyRankLaunch:SetClientRectChangedCallback("FestivalBossLaunchAdjwinpos")
	
	--排行启动按钮
	local btn_rank = dailyRankLaunch:GetButton("btn_rank")
	--排行启动按钮
	btn_rank:SetClickEventHandler2(function()
		--WndSystem:GetInstance():ToggleWnd(2002)
		local msg = {}
		msg.module   = modName
		msg.msg_code = "OpenDailyRankWnd"
		local jsonstr = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(jsonstr)
	end)
	
	
--活动中排行窗口		
	dailyRankWnd = core.createWindow('Data/Scp/Windows/Windows_FestivalBoss.scp',2002)
	--关闭按钮
	dailyRankWnd:GetButton('btn_close'):SetClickEventHandler2(function()
				dailyRankWnd:SetVisible(false)
			end)
			
	--listbox初始化
	local rankListbox = dailyRankWnd:GetListBox("listbox")
	rankListbox:SetColCount(5);
	rankListbox:SetColFormat(0,120);
	rankListbox:SetColAlign(0, 1);
	rankListbox:SetColFormat(1,225);
	rankListbox:SetColAlign(1, 1);
	rankListbox:SetColFormat(2,136);
	rankListbox:SetColAlign(2, 1);
	rankListbox:SetColFormat(3,130);
	rankListbox:SetColAlign(3, 1);
	rankListbox:SetColFormat(4,130);
	rankListbox:SetColAlign(4, 1);
	rankListbox:SetLineHeight(28)
		
--服务端发来的消息
	api_reg_module_msg_handler(modName,MsgHandler)
end

function LaunchAdjwinpos()
	local desk = XDesktop:GetInstance()
	local xoff = 211
	local yoff = 80
	XWinUtil:AlignWindow(desk, dailyRankLaunch, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, xoff, 0, yoff, 0, false)
end


--接网络消息
function MsgHandler(msg)
	if(msg.msg_code=="OpenTotalRankWnd") then 
		OpenTotalRankWnd(msg)
	elseif(msg.msg_code=="Launch") then --服务端通知显示或隐藏"排行"launch
		Launch(msg)
	elseif(msg.msg_code=="OpenDailyRankWnd") then 
		OpenDailyRankWnd(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end
	
function OpenTotalRankWnd(msg)
	--倒计时
	local lfLabel = totalRankWnd:GetLabel("倒计时")
	if msg.lfMin < 60 then
		lfLabel:setText(string.format("%d分钟",msg.lfMin))
	elseif msg.lfMin < 60*24 then
		local m = msg.lfMin%60
		local h = (msg.lfMin - m)/60
		lfLabel:setText(string.format("%d时%d分",h,m))
	else
		local m = msg.lfMin%60
		local h = ((msg.lfMin - m)/60)%24
		local d = (msg.lfMin - h*60 - m)/(60*24)
		lfLabel:setText(string.format("%d天%d时%d分",d,h,m))
	end
	
	--前十名
	local panelMgr = totalRankWnd:GetScrollMgr('滚动管理'):GetPanelMgr('礼包列表')
	for i=1,panelMgr:GetPanelCount() do
		local panel =panelMgr:GetPanelWnd(i-1)
		local item = msg.totalRank[i]
		if item == nil then
			panel:SetVisible(false)
		else
			panel:SetVisible(true)
			
			--名次
			local noHtml =  panel:GetHtml("排名")
			noHtml:Clear()
			noHtml:ParseContext(tostring(i))
			
			--名字
			local nameHtml =  panel:GetHtml("角色名")
			nameHtml:Clear()
			nameHtml:ParseContext(item.name)
			
			--职业
			local occStr = occNames[item.occ] or "未知职业"
			local occHtml =  panel:GetHtml("职业")
			occHtml:Clear()
			occHtml:ParseContext(occStr)
			
			--累计积分
			local scoreHtml =  panel:GetHtml("积分")
			scoreHtml:Clear()
			scoreHtml:ParseContext(tostring(item.score))
			
			--奖励
			local vbmgr = panel:GetViewBoxMgr("奖励管理器")
			for i = 1, vbmgr:GetSize() do
				local vb = vbmgr:GetViewBox(i-1)
				local rewardItem = item.goods[i]
				if rewardItem ~= nil then
					vb:SetVisible(true)
					if rewardItem.quality ~= nil then
						vb:SetItem(rewardItem.goodsId,rewardItem.num,false,rewardItem.quality)
					else
						vb:SetItem(rewardItem.goodsId,rewardItem.num)
					end
				else
					vb:SetVisible(false)
				end				
			end					
		end
	end
	
	--自己
	local selfScoreLabel = totalRankWnd:GetLabel("self_score_value")
	selfScoreLabel:setText(tostring(msg.selfInfo.score))
	local vbmgr = totalRankWnd:GetViewBoxMgr("我的奖励")
	for i = 1, vbmgr:GetSize() do
		local vb = vbmgr:GetViewBox(i-1)
		local rewardItem = msg.selfInfo.goods[i]
		if rewardItem ~= nil then
			vb:SetVisible(true)
			if rewardItem.quality ~= nil then
				vb:SetItem(rewardItem.goodsId,rewardItem.num,false,rewardItem.quality)
			else
				vb:SetItem(rewardItem.goodsId,rewardItem.num)
			end
		else
			vb:SetVisible(false)
		end				
	end	
	
	totalRankWnd:SetVisible(true)
end

function Launch(msg)
	if msg.show then
		WndSystem:GetInstance():ShowWnd(2001, 1)
	else
		WndSystem:GetInstance():ShowWnd(2001, 0)
	end
end

function OpenDailyRankWnd(msg)
	--积分进度
	local progress 	= dailyRankWnd:GetProgressBar("total_score_progress")
	progress:SetRange(0, msg.maxScore)
	progress:SetPos(msg.curScore)
	
	--排行
	local rankListbox = dailyRankWnd:GetListBox("listbox")
	rankListbox:RemoveAll()
	for i,v in ipairs(msg.dailyRank) do
		local n = rankListbox:AddItem(tostring(i))
		rankListbox:SetItem(n, 1, v.name)
		rankListbox:SetItem(n, 2, occNames[v.occ] or "未知职业")
		rankListbox:SetItem(n, 3, tostring(v.score))
		rankListbox:SetItem(n, 4, "", v.money, enMoneyType_Voucher)
	end
	
	--我的积分
	local selfScoreLabel 	= dailyRankWnd:GetLabel("self_score_value")
	local selfMoneyML 	= dailyRankWnd:GetMoneyLabel("self_money_value")
	selfScoreLabel:setText(tostring(msg.selfInfo.score))
	selfMoneyML:SetMoney(msg.selfInfo.money)

	dailyRankWnd:SetVisible(true)
end

--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
rawset(_G,"FestivalBossLaunchAdjwinpos",LaunchAdjwinpos)--把函数设置成全局的
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
--*加载子模块 end****************************************************--

