---------------------------------------------------------------------------------------------------------------------
--文件名:	WorkskillSys.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.12
--版  本:	1.0
--描  述:	炼器系统。
--			主要功能：
--			1.所有炼器的消息码从这里统一收发，这样做的一个好处是以后可以加些通用的判断流程。比如发送炼器消息码的时候可
--			以补个客户端的当前时间等。
--			2.定制一些通用函数供子模块使用，比如背包里有没有符合某炼器技能的道具。
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("SnowManAct",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "SnowManAct"
local thisWnd = nil
local counterLabel = nil
local mapId = 403
--*常量 end**********************************************************--


--*3 变量************************************************************--
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
function init()
	--创建各个窗口并初始化
	thisWnd = core.createWindow('Data/Scp/Windows/Windows_SnowMan.scp',1070)
	
	--剩余计数标签
	counterLabel= thisWnd:GetLabel("剩余计数")
	
	--离开按钮
	thisWnd:GetButton("离开按钮"):SetClickEventHandler2(Leave)
	
	--规则按钮
	thisWnd:GetButton("规则按钮"):SetClickEventHandler2(function()
				WndSystem:GetInstance():ShowWnd(1071,1)
			end)
			
	--监听玩家切换场景
	api_reg_hero_all_data_ready_listen(ChangScene)
	
	--屏幕尺寸变化调用
	rawset(_G,"SnowManChangScene",ChangScene)--把函数设置成全局的
	thisWnd:SetClientRectChangedCallback("SnowManChangScene")
	
	--服务端发来的消息
	api_reg_module_msg_handler(modName,MsgHandler)
	
	--规则窗口-------------------------
	local tipwnd = core.createWindow('Data/Scp/Windows/Windows_SnowMan.scp',1071)
	local html_tip = tipwnd:GetHtml("tip1")
	local tip_txt = "1、#(color,yellow)参加条件#(color,restore)：等级 ≥ 35#(br,1)"
	tip_txt = tip_txt.."2、#(color,yellow)活动时间#(color,restore)："
	tip_txt = tip_txt.."#(br,1)    11：00-11：20"
	tip_txt = tip_txt.."#(br,1)    14：00-14：20"
	tip_txt = tip_txt.."#(br,1)    18：00-18：20"
	tip_txt = tip_txt.."#(br,1)    22：00-22：20"	
	tip_txt = tip_txt.."#(br,1)3、#(color,yellow)玩法介绍#(color,restore)："
	tip_txt = tip_txt.."#(br,1)    打败2000个小雪人后，刷新10只雪怪，打败10只雪怪后刷新雪人王，打败雪人王30秒后副本关闭。打败小雪人、雪怪、雪人王都可以获得大量经验和道具。"

	html_tip:Clear()
	html_tip:ParseContext(tip_txt)
	tipwnd:GetButton('btn_close'):SetClickEventHandler2( function ( wnd, event) 	
										WndSystem:GetInstance():ShowWnd(1071,0)
										end)
	--规则窗口 end---------------------
end

function ChangScene()
	--判断在不在仙界争霸战副本
	local hero = core.getHero()
	if hero == nil then  thisWnd:SetVisible(false) return end
	local curMapId = g_pGlobal:GetClientWorld():GetMapID()
	if curMapId ~= mapId then	
		thisWnd:SetVisible(false)
		return
	end	
	
	--如果是有配置掉落的场景那么就显示图标
	ResetPos()
	thisWnd:SetVisible(true)	
end

function ResetPos()		
	local desktop = WndSystem:GetInstance():GetGameDesktop()
	XWinUtil:AlignWindow(desktop, thisWnd, XWinUtil.enXUAlign_RIGHT_RIGHT, XWinUtil.enXUAlign_TOP_TOP, 0, 0, 4, 0, false)
end

--点击离开按钮
function Leave()
	local msg = {}
	msg.module   = modName
	msg.msg_code = "Leave"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--接网络消息
function MsgHandler(msg)
	if(msg.msg_code=="counterMsg") then --玩家在副本中想要离开
		counterLabel:setText(msg.counterMsg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
--*加载子模块 end****************************************************--

