﻿local achievement_wnd_ID	= 1037
local achievement_launch_ID = 1038

local moduleName = "achievement"
local achievement_wnd = nil
local achievement = {}

local dayBtnList 		= {}			----切换页 button
local conditionsHtmList = {}			----任务条件描述 html
local viewboxmgrList	= {}			----物品列表 viewboxmgr
local getRewardList 	= {}			----领取按钮列表 button
local dayBtnBKList		= {}			----选择天数的背景

local IsGetReward		= {}			----是否领取过奖励
local ConditionState	= {}			----任务条件完成状态
local rewardList		= {}			----物品奖励

local dayBKBlack 		= nil			----黑色背景
local dayBKRed			= nil			----红色背景

local notice_index		= 1				----提示索引
local scroll_message	= {}			----提示内容

local day_num			= 1

function achievement_wnd_init()
	api_reg_module_msg_handler(moduleName, Achievement_msg_handler)
	achievement_wnd = core.createWindow('Data/Scp/Windows/Windows_Achievement.scp',achievement_wnd_ID)
	
	-----初始化窗口控件
	
	for k=1, 7 do
		dayBtnList[k] 	= achievement_wnd:GetButton('day'..k)
		dayBtnList[k]:SetClickEventHandler2(achievement.OnClickFlipDay)
		
		dayBtnBKList[k] = achievement_wnd:GetStaticBitmap('dayBg'..k)
		
		conditionsHtmList[k] = achievement_wnd:GetHtml('任务条件'..k)
	end
	
	for k=1, 4 do
		viewboxmgrList[k] = achievement_wnd:GetViewBoxMgr('物品栏'..k)
		
		getRewardList[k] = achievement_wnd:GetButton('领取'..k)
		getRewardList[k]:SetClickEventHandler2(achievement.GetReward)
	end
	
	local closeBtn = achievement_wnd:GetButton('关闭按钮')
	closeBtn:SetClickEventHandler2( function (wnd, event)
										achievement_wnd:SetVisible(false)
										timer.killTimer("OnFlush_Achievement_notice", 1037)
									end
									)
	
	achievement_wnd:SetLuaEvent(XWIN_EVENT_SHOW, 'OnAchievementShow')
	
	-- dayBKBlack 		= g_pGlobal:GetResourceMgr():RequestUIImage('RelationWnd\sign_daydikuang.png')
	-- dayBKRed 		= g_pGlobal:GetResourceMgr():RequestUIImage('Common\Frame\item_bg.png')
	
	achievement.Launch = core.createWindow('Data/Scp/Windows/Windows_Achievement.scp',achievement_launch_ID, false, g_pGlobal:GetMainUI():GetSystemIconSet(0, true))
	local fcmParent = XFlowCtrlMgr:CastToFlowCtrlMgr(achievement.Launch:GetParent())
	fcmParent:SetChildVisible(achievement_launch_ID, true)
	
	local launchBtn = achievement.Launch:GetButton('btn')
	achievement.Launch:GetAni('flashanim'):PlayAni(false)
	launchBtn:SetClickEventHandler('OnAchievementLaunchBtnClick')
	
	achievement.noticeHtml = achievement_wnd:GetHtml('notice')
end

function OnAchievementLaunchBtnClick()
	achievement_wnd:SetVisible(true)
	achievement.Launch:GetAni('flashanim'):PlayAni(false)
end

local function OnClickFlipDay(wnd)
	day_num = XButton:CastToButton(wnd):GetTag1()
	for k=1, 7 do
		if k ~= day_num then
			dayBtnBKList[k]:SetBitmap('RelationWnd/sign_daydikuang.png')
		else
			dayBtnBKList[k]:SetBitmap('Common/Frame/item_bg.png')
		end
	end
	achievement.OnUpdateWindow()
end

local function GetReward(wnd)
	local tag = XButton:CastToButton(wnd):GetTag1()
	
	if wnd.IsOutTime == 1 then
		if core.getHero():GetCrtProp(enProp_Actor_M_GoldIngot) < 10 then
			g_pGlobal:GetMainUI():ShowMessageBox("您的元宝不够#(GoldIngot,10)是否充值？","achievement_show_recharge",1,0,"首充大礼","充值")
			return
		end
		MsgAskBox.ShowAskBox("你确定要使用#(GoldIngot,10)领取奖励吗", "补领",achievement.sendGetReward,tag)
		return
	end
	
	achievement.sendGetReward(1, tag)
end

local function sendGetReward(nBtnIdx, useData)
	if nBtnIdx == 1 then
		local msg 		= {}
		msg.module 		=  moduleName
		msg.msg_code 	= 'OnGetReward'
		msg.dayNum		= day_num
		msg.rewardType	= useData
		local str 		= cjson.encode(msg)
		g_pGlobal:SendScriptMsg(str)	
	end
end

function achievement_show_recharge(msgid,wparam,lparam)
	if(msgid == WE_AW_BTN1_CLICKED) then
		WndSystem:GetInstance():ShowWnd(831,1)
		achievement_wnd:SetVisible(false)
	elseif msgid == WE_AW_BTN2_CLICKED then
		g_pGlobal:GetGoodsClient():Recharge()
		achievement_wnd:SetVisible(false)
	end
	
end

function Achievement_msg_handler(msg)
	if msg.msg_code == "OnUpdateShow" then
		achievement.GetUpdateInfo(msg)
	elseif msg.msg_code == "OnLaunchShow" then
		achievement.OnLaunchOpenWnd(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
	
end

local function GetUpdateInfo(msg)
	IsGetReward		= msg.IsGetReward
	ConditionState	= msg.ConditionState
	rewardList		= msg.rewardList
	achievement.OnUpdateWindow()
end

local function OnUpdateWindow()
	achievement.UpdateGoods()
	achievement.UpdateConditions()
	achievement.UpdateButtons()
end

-----更新物品奖励列表
local function UpdateGoods()
	local goodsList = rewardList[day_num]
	for k=1, viewboxmgrList[1]:GetSize() do
		local viewbox = viewboxmgrList[1]:GetViewBox(k-1)
		viewbox:ClearItem()
		if k <= (#goodsList[1])/3 then
			local goodsID = (goodsList[1])[3*k-2]
			local quality = (goodsList[1])[3*k-1]
			local goodsNum = (goodsList[1])[3*k]
			viewbox:SetItem(goodsID,goodsNum,false,quality)
		end
		
		viewbox = viewboxmgrList[2]:GetViewBox(k-1)
		viewbox:ClearItem()
		if k <= (#goodsList[2])/3 then
			local goodsID = (goodsList[2])[3*k-2]
			local quality = (goodsList[2])[3*k-1]
			local goodsNum = (goodsList[2])[3*k]
			viewbox:SetItem(goodsID,goodsNum,false,quality)
		end
		
		viewbox = viewboxmgrList[3]:GetViewBox(k-1)
		viewbox:ClearItem()
		if k <= (#goodsList[3])/3 then
			local goodsID = (goodsList[3])[3*k-2]
			local quality = (goodsList[3])[3*k-1]
			local goodsNum = (goodsList[3])[3*k]
			viewbox:SetItem(goodsID,goodsNum,false,quality)
		end
		
		viewbox = viewboxmgrList[4]:GetViewBox(k-1)
		viewbox:ClearItem()
		if k <= (#goodsList[4])/3 then
			local goodsID = (goodsList[4])[3*k-2]
			local quality = (goodsList[4])[3*k-1]
			local goodsNum = (goodsList[4])[3*k]
			viewbox:SetItem(goodsID,goodsNum,false,quality)
		end
	end
end

-----更新任务条件
local function UpdateConditions()
	local conditions = GetAchievementConditions() 
	local i = 1
	local conDesc = ''
	for k = (day_num-1)*5+1, day_num*5 do
		conDesc = conditions[k].condition
		conditionsHtmList[i]:Clear()
		if ConditionState[k] == 1 then
			conditionsHtmList[i]:ParseContext('#(color,%%0,255,255%%)'..conDesc..'#(color,restore)')
		else
			conditionsHtmList[i]:ParseContext('#(color,%%194,194,194%%)'..conDesc..'#(color,restore)')
		end
		i = i + 1
	end
	
	conditionsHtmList[6]:Clear()
	if ConditionState[36] == 1 then
		conditionsHtmList[6]:ParseContext('#(color,%%255,0,255%%)'..conditions[36].condition..'#(color,restore)')
	else
		conditionsHtmList[6]:ParseContext('#(color,%%194,194,194%%)'..conditions[36].condition..'#(color,restore)')
	end
	
	conditionsHtmList[7]:Clear()
	if ConditionState[37] == 1 then
		conditionsHtmList[7]:ParseContext('#(color,%%255,255,0%%)'..conditions[37].condition..'#(color,restore)')
	else
		conditionsHtmList[7]:ParseContext('#(color,%%194,194,194%%)'..conditions[37].condition..'#(color,restore)')
	end
	
end

-----更新按钮状态
local function UpdateButtons()
	local createTime 	= core.getHero():GetCrtProp(enProp_Actor_Create_Time)
	local currentTime 	= XDate:GetInstance():GetCurrentVTime()
	local dayNums	 	= XDate:GetInstance():GetDays(createTime, currentTime) + 1
	local selectTime 	= createTime + 86400*(day_num-1)
	local BtnCanGet 	= achievement.GetButtonState()
	local i = 1
	
	for k = (day_num-1)*4+1, day_num*4 do
		--API_Trace(' BtnCanGet['..i..'] '.. BtnCanGet[i]..' IsGetReward['..k..'] '..IsGetReward[k])
		--API_Trace(' day_num '..day_num..' dayNums '..dayNums)
		if day_num > dayNums then
			getRewardList[i]:setText('领取')
			getRewardList[i]:SetEnabled(false)
			getRewardList[i].IsOutTime = 0
		elseif XDate:GetInstance():IsSameDay(currentTime,  selectTime)==true then
			getRewardList[i].IsOutTime = 0
			if BtnCanGet[i] == 1 and IsGetReward[k] == 0 then
				getRewardList[i]:setText('领取')
				getRewardList[i]:SetEnabled(true)
			elseif IsGetReward[k] == 1 then
				getRewardList[i]:setText('已领')
				getRewardList[i]:SetEnabled(false)
			else
				getRewardList[i]:setText('领取')
				getRewardList[i]:SetEnabled(false)
			end
		else
			getRewardList[i].IsOutTime = 1
			if BtnCanGet[i] == 1 and IsGetReward[k] == 0 then
				getRewardList[i]:setText('补领')
				getRewardList[i]:SetEnabled(true)
			elseif IsGetReward[k] == 1 then
				getRewardList[i]:setText('已领')
				getRewardList[i]:SetEnabled(false)
			else
				getRewardList[i]:setText('补领')
				getRewardList[i]:SetEnabled(false)
			end		
		end
		i = i + 1
	end
end

----获取btn是否可领取
local function GetButtonState()
	local completeNum 	= 0
	local BtnCanGet		= {0, 0, 0, 0}
	for k = (day_num-1)*5+1, day_num*5 do
		if ConditionState[k] == 1 then
			completeNum = completeNum + 1
		end
	end
	
	local now		= XDate:GetInstance():GetCurrentVTime()
	local selectDayTime = core.getHero():GetCrtProp(enProp_Actor_Create_Time) + (day_num-1)*86400
	local isSameDay = XDate:GetInstance():IsSameDay(now,  selectDayTime)
	
	if completeNum >= 2 or isSameDay == false then
		BtnCanGet[1] = 1
	end
	
	if completeNum >= 4 or isSameDay == false then
		BtnCanGet[2] = 1
	end
	
	if ConditionState[36] == 1 then
		BtnCanGet[3] = 1
	end
	
	if ConditionState[37] == 1 then
		BtnCanGet[4] = 1
	end
	
	return BtnCanGet
end

function OnAchievementShow()
	---设置定时器 刷新左上角的提示
	timer.setTimer('OnFlush_Achievement_notice', 1037, 7000)
	scroll_message = GetAchievementScrollNotice()
	
	local createTime 	= core.getHero():GetCrtProp(enProp_Actor_Create_Time)
	local currentTime 	= XDate:GetInstance():GetCurrentVTime()
	day_num				= XDate:GetInstance():GetDays(createTime, currentTime) + 1
	if day_num > 7 then
		day_num = 7
	end
	for k=1, 7 do
		if k ~= day_num then
			dayBtnBKList[k]:SetBitmap('RelationWnd/sign_daydikuang.png')
		else
			dayBtnBKList[k]:SetBitmap('Common/Frame/item_bg.png')
		end
	end
	
	---请求服务器
	local msg = {}
	msg.module =  moduleName
	msg.msg_code = 'OnAchievementShow'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)	
end

function OnFlush_Achievement_notice()
	achievement.noticeHtml:Clear()
	achievement.noticeHtml:ParseContext(scroll_message[notice_index])
	notice_index = notice_index + 1
	if notice_index > #scroll_message then
		notice_index = 1
	end
end

local function OnLaunchOpenWnd(msg)
	day_num = msg.dayNum
	achievement.Launch:GetAni('flashanim'):PlayAni(true)
	for k=1, 7 do
		if k ~= day_num then
			dayBtnBKList[k]:SetBitmap('RelationWnd/sign_daydikuang.png')
		else
			dayBtnBKList[k]:SetBitmap('Common/Frame/item_bg.png')
		end
	end
end

achievement.OnClickFlipDay 		= OnClickFlipDay
achievement.GetReward			= GetReward
achievement.GetUpdateInfo		= GetUpdateInfo
achievement.OnUpdateWindow 		= OnUpdateWindow
achievement.UpdateGoods			= UpdateGoods
achievement.UpdateConditions	= UpdateConditions
achievement.UpdateButtons		= UpdateButtons
achievement.GetButtonState		= GetButtonState
achievement.OnLaunchOpenWnd		= OnLaunchOpenWnd
achievement.sendGetReward		= sendGetReward

-----初始化
achievement_wnd_init()
