---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_act_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.10.18
--版  本:	1.0
--描  述:	活动界面的子窗口

--日  期:	2014.01.21
--版  本:	2.0
--描  述:	活动界面的子窗口 改版

----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------

activitywnd 					= {}	--自己
activitywnd.thisWnd  			= nil				
activitywnd.actPanelList		= {}
activitywnd.scrollmgr 			= nil
activitywnd.activityList 		= nil
activitywnd.reward 				= {}
activitywnd.currentIndex 		= nil
activitywnd.pointList 			= {}

--每一页显示的icon数量
local eachPageCount 			= 6

local actIconMap =	
				{
					[10] = "Activity/killmonster_icon.png",
					[23] = "Activity/landwar_icon.png",
					[8] = "Activity/warmblood_icon.png",
					[22] = "Activity/snow_icon.png",
					[24] = "Activity/zhengba_icon.png",
					[25] = "Activity/guard_icon.png",
				}


function ActivityWndInit(wnd)
	activitywnd.thisWnd = wnd
	--注册显示回调事件
	activitywnd.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnActivityWndShow')

	activitywnd.scrollmgr 	= activitywnd.thisWnd:GetScrollMgr("huodong_scrollmgr")
	local panelmgr  		= activitywnd.scrollmgr:GetPanelMgr("huodong_mgr")
	activitywnd.scrollmgr:SetLuaEvent2(XWIN_EVENT_CHUNK_TO,OnActivityWndChunkTo)
	OnActivityWndChunkTo()

	local panelCount 		= panelmgr:GetPanelCount()
	for i=1, panelCount do
		local panelwndParent 			= panelmgr:GetPanelWnd(i-1)
		panelwndParent:SetEventToWindow(activitywnd.scrollmgr)
		local mgr = panelwndParent:GetPanelMgr("huodong_mgr")
		for j=1, mgr:GetPanelCount() do
			local panelwnd 			= mgr:GetPanelWnd(j-1)
			panelwnd:SetEventToWindow(activitywnd.scrollmgr)

			local actPanel = {}
			actPanel.actName 		= panelwnd:GetLabel("act_name")
			actPanel.actStatus 		= panelwnd:GetLabel("act_status")
			actPanel.actIcon 		= panelwnd:GetStaticBitmap("act_icon")
			actPanel.actSelect 		= panelwnd:GetStaticBitmap("selected")
			actPanel.panelwnd 		= panelwnd
			panelwnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateActInfo')

			table.insert(activitywnd.actPanelList, actPanel)
		end
	end
	--活动详细模块
	--这里显示的是 距离现在最近 但是还没开始的活动
	activitywnd.activityStatus	= activitywnd.thisWnd:GetLabel("activity_status")
	activitywnd.timeLeft		= activitywnd.thisWnd:GetLabel("time_left")
	activitywnd.activityName	= activitywnd.thisWnd:GetLabel("activity_name")
	--选中活动的详细信息
	activitywnd.joinLevel		= activitywnd.thisWnd:GetLabel("join_level")
	activitywnd.joinTime 		= activitywnd.thisWnd:GetHtml("join_time")
	activitywnd.actDes			= activitywnd.thisWnd:GetHtml("act_des")

	--换页按钮 
	local srcollmgr = activitywnd.thisWnd:GetScrollMgr('huodong_scrollmgr')
	local pointmgr = activitywnd.thisWnd:GetPanelMgr('pointMgr')

	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		btn:SetVisible(false)
		table.insert(activitywnd.pointList, btn)
	end

	--奖励
	local panelmgr 				= activitywnd.thisWnd:GetPanelMgr("reward_mgr")
	for i=1, panelmgr:GetPanelCount() do
		local panelwnd 			= panelmgr:GetPanelWnd(i-1)
		local rewardICON 		= panelwnd:getWindow("reward_icon")
		local rewardQuality 	= panelwnd:getWindow("reward_quality")
		
		local reward 			= {
								rewardICON 			= rewardICON,
								rewardQuality		= rewardQuality,
									}
		table.insert(activitywnd.reward, reward)
	end

	activitywnd.transmit 		= activitywnd.thisWnd:GetButton("transmit")
	activitywnd.transmit:SetClickEventHandler("OnActivityJoin")

	timer.setTimer("OnActivityWndTimer", 879, 10000)
end


--排序函数
local function ActivityWndSortFunc(a, b)

	if a.activityPriority == b.activityPriority then
		return a.activityTime[1] < b.activityTime[1]
	else
		return a.activityPriority < b.activityPriority
	end

end

function OnActivityWndShow(wnd, event)
	if activitywnd.activityList == nil then
		activitywnd.activityList = {}
		local tmpTb = GetAllActivityInfoByActivityType(3)
		--API_Trace(cjson.encode(tmpTb))
		if tmpTb == nil then return end
		local tmpTb2 = {}
		--为什么这么折腾呢 因为要兼容以前
		--1、合并同个活动不同时间段
		for k, v in pairs(tmpTb) do
				
			tmpTb2[v.activityID] = tmpTb2[v.activityID] or v
			tmpTb2[v.activityID].activityTimeList = tmpTb2[v.activityID].activityTimeList or {}	

			for kk, vv in pairs(v.activityTime) do
				table.insert(tmpTb2[v.activityID].activityTimeList, vv)
			end
		end
		--2、转为list
		for k, v in pairs(tmpTb2) do
			table.insert(activitywnd.activityList, v)
		end

		--排序
		table.sort(activitywnd.activityList, ActivityWndSortFunc)
		--API_Trace(cjson.encode(activitywnd.activityList))
	end

	local showPage = 1
	for i=1, #activitywnd.actPanelList do
		local panel 		= activitywnd.actPanelList[i]
		local activityInfo 	= activitywnd.activityList[i]
		if activityInfo ~= nil then
			----API_Trace(activityInfo.activityID)
			panel.actName:setText(activityInfo.activityName)
			panel.actIcon:SetBitmap(actIconMap[activityInfo.activityID])
			--取消选中
			panel.actSelect:SetVisible(false)
			panel.panelwnd:SetVisible(true)

			if i%(eachPageCount+1) == 0 then
				showPage = showPage + 1
			end
		else

			panel.panelwnd:SetVisible(false)
		end
	end

	--决定显示多少个翻页小圆点
	for i=1, #activitywnd.pointList do
		if i <= showPage and showPage ~= 1 then
			activitywnd.pointList[i]:SetVisible(true)
		else
			activitywnd.pointList[i]:SetVisible(false)
		end
	end
	--决定显示多少页
	local panelmgr  		= activitywnd.scrollmgr:GetPanelMgr("huodong_mgr")
	for i=1, panelmgr:GetPanelCount() do
		local panelwnd 		= panelmgr:GetPanelWnd(i-1)
		if i <= showPage then
			panelwnd:SetVisible(true)
		else
			panelwnd:SetVisible(false)
		end
	end

	--选中第一个
	OnUpdateActInfo(activitywnd.actPanelList[1].panelwnd)
	--立即刷新一下
	OnActivityWndTimer()
end

--前往
function OnActivityJoin(wnd, event)
 	if activitywnd.currentIndex == nil or not activitywnd.thisWnd:IsVisible() then 
 		API_TraceError("OnActivityJoin currentIndex is nil")
 		return 
 	end
 	local activityInfo = activitywnd.activityList[activitywnd.currentIndex]
 	if activityInfo ~= nil then
 		ActivityTransmit(activityInfo.activityID)
 	end
end

function OnUpdateActInfo(wnd, event)
	if wnd == nil then return end
	local hero = core.getHero()
	if hero == nil then return end
	--API_Trace("begin update")
	for i=1 , #activitywnd.actPanelList do
		local panelwnd 	= activitywnd.actPanelList[i]
		if wnd == panelwnd.panelwnd then
			local activityInfo 			= activitywnd.activityList[i]
			activitywnd.currentIndex 	= i

			--活动等级
			activitywnd.joinLevel:setText(FormatLevel(activityInfo.activityLevel))
			--活动描述
			activitywnd.actDes:Clear()
			activitywnd.actDes:ParseContext(activityInfo.activityDesc)
			--参与时间
			activitywnd.joinTime:Clear()
			local activityTimeTb = FormatTimes(activityInfo.activityTimeList)
			local strTime = ""
			for i=1, #activityTimeTb do
				if i%2 == 0 then
					strTime = strTime .."    ".. activityTimeTb[i]
					strTime = strTime.."#(br,1)"
				else
					strTime = strTime .. activityTimeTb[i]
				end
			end

			--星期限制
			if #activityInfo.activityWeek > 0 then
				strTime = strTime .." ("
				local weekstrTb = FormatWeek(activityInfo.activityWeek)
				for k, v in pairs(weekstrTb) do
					strTime = strTime..v.." "
				end
				strTime = strTime .. ")"
			end

			activitywnd.joinTime:ParseContext(strTime)

			--更新奖励viewbox
		 	for i=1, #activitywnd.reward do
		 		if activityInfo.activityReward[i] ~= nil then
		 			
		 			activitywnd.reward[i].rewardICON:SetBitmapIcon(activityInfo.activityReward[i].rewardICON)
		 			activitywnd.reward[i].rewardICON:SetToolTipIndex(activityInfo.activityReward[i].rewardToolTipID)
		 			activitywnd.reward[i].rewardICON:SetVisible(true)
		 			if activityInfo.activityReward[i].rewardQuality == 0 then
		 				activitywnd.reward[i].rewardQuality:SetVisible(false)
		 			else
		 				activitywnd.reward[i].rewardQuality:SetBitmap( ActivityClient.Quality[activityInfo.activityReward[i].rewardQuality] )
		 				activitywnd.reward[i].rewardQuality:SetVisible(true)
		 			end
		 		else
		 			
		 			activitywnd.reward[i].rewardICON:SetVisible(false)
		 			activitywnd.reward[i].rewardQuality:SetVisible(false)
		 			activitywnd.reward[i].rewardICON:SetToolTipIndex(-1)
		 		end
		 	end			

		 	if IsCanJoinActivity(activityInfo) then
		 		activitywnd.transmit:SetEnabled(true)
		 	else
		 		activitywnd.transmit:SetEnabled(false)
		 	end

			--显示选中状态
		 	panelwnd.actSelect:SetVisible(true)
		else
			--取消其他的选中状态
			panelwnd.actSelect:SetVisible(false)
		end
	end
end


--页滑动了
function OnActivityWndChunkTo()
	--API_Trace("OnActivityWndChunkTo")
	local srcollmgr = activitywnd.thisWnd:GetScrollMgr('huodong_scrollmgr')
	local pointmgr = activitywnd.thisWnd:GetPanelMgr('pointMgr')
	local n = srcollmgr:GetChunkNo()
	if n < 0 or pointmgr == nil then 
		--API_Trace("OnActivityWndChunkTo n < 0")
		return
	end
	
	for i=1,pointmgr:GetPanelCount() do
		local panel = pointmgr:GetPanelWnd(i-1)
		local btn = panel:GetButton("pointBtn")
		if n == (i-1) then
			btn:SetManualRestore(true);
			btn:SetState(BS_DOWN);
		else
			btn:SetManualRestore(false);
			btn:SetState(BS_UP);
		end
	end
end

--获取距离现在最近 但是活动时间还未到的活动 刷新界面
local function UpdateNextCanJoinAct()
	--距离现在最近 时间未到的活动id
	local activityInfo = nil
	local temp = -1
	for k, v in pairs(activitywnd.activityList) do
		local timeLeftStr, timeLeftSec = GetActivityTimeLeft(v.activityTimeList)
		--活动未开始
		if timeLeftSec > 0 then
			if temp == -1 then
				temp = timeLeftSec
				activityInfo = v
			end
			if temp > timeLeftSec then
				temp = timeLeftSec
				activityInfo = v
			end
		end
	end
	--检错
	if nil == activityInfo  then 
		API_TraceError("UpdateNextCanJoinAct error , activityInfo is nil")
		return 
	end

	local timeLeftStr, timeLeftSec = GetActivityTimeLeft(activityInfo.activityTimeList)
	--刷新即将开始活动的信息
	activitywnd.activityName:setText(activityInfo.activityName)
	activitywnd.activityStatus:SetVisible(true)
	activitywnd.timeLeft:setText(timeLeftStr)
end


--定时器
function OnActivityWndTimer()
	if activitywnd.currentIndex == nil or not activitywnd.thisWnd:IsVisible() then return end

	--刷新界面即将开始活动的信息
	UpdateNextCanJoinAct()
	
	--刷新左边的图片 的 "正在进行"
	for i=1, #activitywnd.actPanelList do
		local panel 		= activitywnd.actPanelList[i]
		local activityInfo 	= activitywnd.activityList[i]
		if activityInfo ~= nil then
			local timeLeftStr, timeLeftSec = GetActivityTimeLeft(activitywnd.activityList[i].activityTimeList)
			if timeLeftSec > 0 then
				panel.actStatus:SetVisible(false)
			else
				panel.actStatus:SetVisible(true)
			end
		end
	end
end