---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_client.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.10.18
--版  本:	1.0
--描  述:	
----------------------------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------------------------
--加载配置
API_LoadScript("Data\\Scp\\ActivityConfig.lua")
--加载脚本
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_main_wnd.lua")
--日常子界面
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_richang_wnd.lua")
--副本界面
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_copy_wnd.lua")
--活动子界面
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_act_wnd.lua")
--boss界面
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_boss_wnd.lua")
--游戏指南
API_LoadScript("Data\\Scp\\Lua\\window\\activity\\activity_guide_wnd.lua")

----------------------------------------------------------------------------------------------------------------------
--
ActivityClient = {}

--世界boss的倒计时相关变量
--上次更新数据时间
ActivityClient.updateTime 				= 0
--下次世界boss状态
ActivityClient.bossStatusList  		 	= {}

ActivityClient.Quality 					= {
										[1] = "Common/ViewBox/pin_zhi__you_xiu.png",
										[2] = "Common/ViewBox/pin_zhi__jing_zhi.png",
										[3] = "Common/ViewBox/pin_zhi__zhuo_yue.png",
										[4] = "Common/ViewBox/pin_zhi__chuan_shuo.png",
										[5] = "Common/ViewBox/pin_zhi__shen_gong.png",
											}


local chumo_taskID 			   	= 2001 --除魔令任务id
local WND_ARENA_MAIN 			= 936
local WE_ARENA_SEL_SUB 			= 93602
local chuansongfu_GoodsID 		= 24053--传送符
--聚灵仙阵 活动相关的变量
local max_open_wine_count = 12
local max_open_wine_count_vip6 = 13
local max_open_wine_count_vip7 = 14
local max_open_wine_count_vip8 = 15
local max_open_wine_count_vip9 = 16

----------------------------------------------------------------------------------------------------------------------
function activity_msg_handler(msg)
	if msg.msg_code == "closewnd" then
		OnActivityMainWndClose()
	elseif msg.msg_code == "getinfo" then
		ActivityClient.UpdateInfo(msg)
	elseif msg.msg_code == "setHelpFinishInfo" then
		ActivityClient.SetHelpFinsh(msg)
	elseif msg.msg_code == "helpfinishsuccess" then
		activitycopy.mouseX = nil
		OnUpdateCopyInfo(activitycopy.map_list[activitycopy.currentSelIndex].panelwnd)
	elseif msg.msg_code == "getActCfg" then
		SetActivityPosCfg(msg.actCfg)
	end
end

local function ActivityCientInit()
	--判断下如果已经初始化过就不用初始化了
	if WndSystem:GetInstance():GetGameDesktop():FindWindowByID(866) ~= nil then
		return
	end

	--创建各个窗口并初始化
	local mainWnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",866)
	ActivityMainWndInit(mainWnd)

	--副本窗口
	local copywnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",875)
	ActivityMainWndSubWnd(1, copywnd)
	ActivityCopyInit(copywnd)

	--日常子窗口
	local richang 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",876)
	ActivityMainWndSubWnd(2, richang)
	activityRiChangWndInit(richang)

	
	--创建活动子窗口
	local actwnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",879)
	ActivityMainWndSubWnd(4, actwnd)
	ActivityWndInit(actwnd)

	--boss子窗口
	local actwnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",880)
	ActivityMainWndSubWnd(5, actwnd)
	ActivityBossWndInit(actwnd)



	--游戏指南
	local guidewnd 			= core.createWindow("Data\\Scp\\Windows\\Windows_Activity.scp",874)
	ActivityMainWndSubWnd(3, guidewnd)
	GameGuideWndInit(guidewnd)
	

	--注册消息
	api_reg_module_msg_handler("activity_info",activity_msg_handler)

end

local function UpdateInfo(msg)
	API_Trace(cjson.encode(msg))

	ActivityClient.updateTime = msg.updateinfotime
	local infolist 	= msg.infolist
	if infolist == nil then API_TraceError("UpdateInfo infolist nil") return end

	--是否世界boss状态有变化
	local bBossStatusChange = false

	for k, v in pairs(infolist) do
		local activityID = v.actid
		bBossStatusChange = true

		ActivityClient.bossStatusList[activityID]				= {}
		ActivityClient.bossStatusList[activityID].islive		= v.islive
		ActivityClient.bossStatusList[activityID].nextLiveTime	= v.nexttime
		
	end

	if bBossStatusChange == true then
		--立即刷新下活动面板
		OnActivityBossWndTimer()
	end
end

local function SetHelpFinsh(msg)
	if msg == nil then return end
	activitycopy.helpfinishList = msg.activity_list
end

---------------------------------------------------------------------------------------------------------------------
--初始化
ActivityCientInit()


ActivityClient.UpdateInfo = UpdateInfo
ActivityClient.SetHelpFinsh = SetHelpFinsh


--一些公用函数的封装
--format activityLevel
function FormatLevel(activityLevel)
	if table.maxn(activityLevel) ~= 2 then
		API_TraceError("FormatLevel error")
		return
	end

	local levelStr = ""
	if activityLevel[2] == -1 then
		levelStr = "≥"..activityLevel[1]
	else
		levelStr = activityLevel[1].."-"..activityLevel[2]
	end
	return levelStr
end

--format act time
function FormatTime(activityTime)
	if table.maxn(activityTime) ~= 4 then
		API_TraceError("FormatTime error")
		return
	end
	
	local timeStr 	= ""
	local time 		= {}
	for i=1, #activityTime do
		if activityTime[i] < 10 then
			time[i] 	= "0"..activityTime[i]
		else
			time[i] 	= activityTime[i]
		end
	end
	timeStr = time[1]..":"..time[2].."-"..time[3]..":"..time[4]
	return timeStr

end

--返回格式化好的时间table
function FormatTimes(activityTime)
	if table.maxn(activityTime) < 4 then
		API_TraceError("FormatTimes error")
		return
	end

	local timeStrTb = {}
	local tmp 		= {}
	for i=1, #activityTime do
		if i > 1 and i%4 == 0 then
			table.insert(tmp, activityTime[i])

			local str = FormatTime(tmp)
			--API_Trace(cjson.encode(tmp))
			table.insert(timeStrTb, str)
			
			--清空
			tmp = {}
		else
			table.insert(tmp, activityTime[i])
		end
	end
	return timeStrTb
end
--返回格式化好的星期的字符串table
function FormatWeek(activityWeek)

	local weekStrTb = {}
	local tmp 		= {}
	for i=1, #activityWeek do
		table.insert(weekStrTb, "@activity_week_"..activityWeek[i].."@")
	end
	return weekStrTb
end


--是否在table内
function IsInTable(t, value)
	if t == nil then
		API_TraceError("IsInTable error got t nil")
		return false
	end
	for k, v in pairs(t) do
		if v == value then
			return true
		end
	end
	return false
end

--走路
function ActivityWalk(activityID)
	local hero = core.getHero()
	if hero == nil then return end
	local actorLevel	= API_GetHeroLevel()

	--特殊处理
	--天梯赛
	if activityID == 17 then
		local activityInfo = GetActivityInfoByActivityID(17)
		if actorLevel >= activityInfo.activityLevel[1] and (activityInfo.activityLevel[2] == -1 or actorLevel <= activityInfo.activityLevel[2]) then
			WndSystem:GetInstance():OnEvent(WND_ARENA_MAIN, WE_ARENA_SEL_SUB,0, 0)
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您目前的等级暂不能参加该活动")
		end
		return
	--竞技场
	elseif activityID == 18 then
		local activityInfo = GetActivityInfoByActivityID(18)
		if actorLevel >= activityInfo.activityLevel[1] and (activityInfo.activityLevel[2] == -1 or actorLevel <= activityInfo.activityLevel[2]) then		
			WndSystem:GetInstance():OnEvent(WND_ARENA_MAIN, WE_ARENA_SEL_SUB,1, 0)
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您目前的等级暂不能参加该活动")
		end
		return
	--除魔令
	elseif activityID == 16 then
		if API_HaveTask(chumo_taskID) == false then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您当前没有除魔令的任务。")
		else
			if GetRealVipLevel() >= 1 then
				ActivityTransmit(activityID)
			else
				API_ExecuteTaskAutoGo(chumo_taskID)
			end
			OnActivityMainWndClose()
		end
		return
	end

	--1、查找传送坐标
	local activityTmpList = {}
	--找出活动id为activity_id的所有配置
	local act_position_table = GetActivityPosCfg()
	for k, v in pairs(act_position_table) do
		if (v.activity_id == activityID) then
			activityTmpList[k] = v
		end
	end
	--查找等级符合的坐标配置
	local tActivityConfig = {}
	local isFindPosition = false
	for k, v in pairs(activityTmpList) do
		if ( actorLevel >= v.nLevelBegin and actorLevel < v.nLevelEnd) then
			tActivityConfig = v
			isFindPosition	= true
			break
		end
	end
	if(isFindPosition == false) then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "您目前的等级暂不能参加该活动")
		return
	end
	local xPointPre = XPoint:new()
	xPointPre.x = tActivityConfig.nX
	xPointPre.y = tActivityConfig.nY
	API_MoveTo(tActivityConfig.nMapId, xPointPre)
	OnActivityMainWndClose()
end

--询问的回调函数
function ActivityTransmitCallBack(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		ActivityWalk(wparam)
		return
	end

	ActivityTransmit(wparam, true)
end

--传送
function ActivityTransmit(activityID, bUseGoods)
	if activityID == nil then API_TraceError("activityID nil") end

	local actorLevel	= API_GetHeroLevel()
	--特殊处理
	--天梯赛
	if activityID == 17 then
		local activityInfo = GetActivityInfoByActivityID(17)
		if actorLevel >= activityInfo.activityLevel[1] and (activityInfo.activityLevel[2] == -1 or actorLevel <= activityInfo.activityLevel[2]) then
			WndSystem:GetInstance():OnEvent(WND_ARENA_MAIN, WE_ARENA_SEL_SUB,0, 0)
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您目前的等级暂不能参加该活动")
		end
		return
	--竞技场
	elseif activityID == 18 then
		local activityInfo = GetActivityInfoByActivityID(18)
		if actorLevel >= activityInfo.activityLevel[1] and (activityInfo.activityLevel[2] == -1 or actorLevel <= activityInfo.activityLevel[2]) then		
			WndSystem:GetInstance():OnEvent(WND_ARENA_MAIN, WE_ARENA_SEL_SUB,1, 0)
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您目前的等级暂不能参加该活动")
		end
		return
	--除魔令
	elseif activityID == 16 then
		if API_HaveTask(chumo_taskID) == false then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "您当前没有除魔令的任务。")
		else
			API_FlyToTask(chumo_taskID)
			OnActivityMainWndClose()
		end
		return
	--仙界争霸 领地争夺 仙城守将
	elseif activityID == 24 then
		WndSystem:GetInstance():OnEvent(1028, 10280,1, 0)
		return
	elseif activityID == 23 then
		WndSystem:GetInstance():OnEvent(1028, 10280,2, 0)
		return
	elseif activityID == 25 then
		WndSystem:GetInstance():OnEvent(1028, 10280,3, 0)
		return
	end
	
	local activityInfo 	= GetActivityInfoByActivityID(activityID)
	if GetRealVipLevel() < 1 then
		if core.getHero():GetPacketPart():GetNumByGoodsID(chuansongfu_GoodsID) > 0 then
			if bUseGoods ~= true then	
				g_pGlobal:GetMainUI():ShowMessageBox("本次飞行需要使用一个传送灵符，确定要飞行？","ActivityTransmitCallBack",activityID,0,"确定","取消")
				return
			end
		else
			API_ShowSystemMessage(enSysMsgDisplayType_Float,"成为VIP或消耗传送符才能传送")
			ActivityWalk(activityID)
			return
		end
	end
	--发消息
	local msg = {}
	msg.module   	= "activity_info"
	msg.msg_code 	= "transmit"
	msg.activity_id = activityID
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--获取活动今天能参加的次数
function API_GetActivityAlreadyTimes(countProp, lasttimeProp)
	local hero 				= core.getHero()
	if hero == nil then return 0 end
	local enterCount 		= 0
	local lastEnterTime 	= hero:GetCrtProp(lasttimeProp)
	if XDate:GetInstance():IsSameDay( XDate:GetInstance():GetCurrentVTime(),  lastEnterTime) then
		enterCount 			= hero:GetCrtProp(countProp)
	end
	return enterCount
end

--格式化时间

--获得vip等级
function GetRealVipLevel()
	local hero 			= core.getHero()
	if hero == nil then return 0 end
	local nVipLevel 	= hero:GetVipLevel() 
	if  hero:GetVipLevel() < hero:GetTempVipLevel() then
		nVipLevel 		= hero:GetTempVipLevel()
	end
	return nVipLevel
end


--返回活动今天可以参加的次数 和 上限
-- -1表示无限次数
--
function GetActivityCanJoinCount(activityInfo)
	local activityID 	= activityInfo.activityID
	local hero 			= core.getHero()
	if hero == nil then return 0, -1 end
	local nVipLevel 	= GetRealVipLevel()
	--聚灵仙阵
	if activityID == 6 then
		local nTodayOpenWineCount = API_GetActivityAlreadyTimes(enProp_Actop_JLXZ_TodayOpenWineCount, enProp_Actop_JLXZ_LastOpenWineTime)
		
		local nMaxOpen = max_open_wine_count
		if nVipLevel == 6 then
			nMaxOpen = max_open_wine_count_vip6
		elseif  nVipLevel == 7 then
			nMaxOpen = max_open_wine_count_vip7
		elseif  nVipLevel == 8 then
			nMaxOpen = max_open_wine_count_vip8
		elseif  nVipLevel >= 9 then
			nMaxOpen = max_open_wine_count_vip9
		end

		return nTodayOpenWineCount, nMaxOpen

	--天梯赛
	elseif activityID == 17 then
		--local todayMatchTime = API_GetActivityAlreadyTimes(enProp_Actor_LaddersMatchTimesCurDay, enProp_Actor_LastLaddersMatchTime)
		
		--return todayMatchTime, 10
	--黄粱梦
	elseif activityID == 12 then

		return API_GetActivityAlreadyTimes(enProp_Actor_PDream_Times, enProp_Actor_PDream_PrevTime), 10
	--除魔令
	elseif activityID == chumoActivityID then
		local todayChumoTime = API_GetActivityAlreadyTimes(enProp_Actor_Chumo_Accept_Times, enProp_Actor_Chumo_Last_Accept_Time)
		
		local nMaxOpen = 5
		if nVipLevel == 6 then
			nMaxOpen = 6
		elseif  nVipLevel == 7 then
			nMaxOpen = 7
		elseif  nVipLevel == 8 then
			nMaxOpen = 8
		elseif  nVipLevel == 9 then
			nMaxOpen = 9
		elseif nVipLevel >= 10 then
			nMaxOpen = 10
		end

		return todayChumoTime, nMaxOpen
	elseif activityID == 33 then
		return API_GetActivityAlreadyTimes(enProp_Actor_PetParadiseEnterTimes, enProp_Actor_PetParadiseLastTime), 2
	end

	return 0, -1
end

--是否能参加活动
function IsCanJoinActivity(activityInfo)
	local currentStime 		= XDate:GetInstance():GetDateStruct()
	local activityBeginTime = activityInfo.activityTime[1]*3600 + activityInfo.activityTime[2]*60
	local activityEndTime	= activityInfo.activityTime[3]*3600 + activityInfo.activityTime[4]*60
	local currentHourMin 	= currentStime.hour*3600 + currentStime.min*60
	local activityID 		= activityInfo.activityID
	local level = API_GetHeroLevel()
	if level < activityInfo.activityLevel[1] or (activityInfo.activityLevel[2] ~= -1 and level > activityInfo.activityLevel[2]) then
		return false
	end

	local count, maxCount = GetActivityCanJoinCount(activityInfo)
	if count == maxCount then
		return false
	end

	return true
end

--格式化时间
function FormatTimeBySec(secParams)
	if secParams == nil then return "" end

	--local sec 	= math.floor(secParams%60)
	local min 	= math.floor(secParams/60%60)
	local hour 	= math.floor(secParams/60/60)
	local str = ""
	--if hour < 10 then
	--	str = str.."0"..hour
	--else
		str = str..hour
	--end
	str = str.."小时"
	--if min < 10 then
	--	str = str.."0"..min
	--else
		str = str..min
	--end
	str = str.."分钟"
	--if sec < 10 then
	--	str = str.."0"..sec
	--else
	--	str = str..sec
	--end

	return str
end


--活动还剩多少时间可以参加 返回需要的时间字符串和int值
function GetActivityTimeLeft(activityTime)
	if activityTime == nil or type(activityTime) ~= "table" or table.maxn(activityTime) < 4 then
		API_TraceError("GetActivityTimeLeft activityTime error")
		return "", 0
	end
	--API_Trace(cjson.encode(activityTime))
	local currentStime 		= XDate:GetInstance():GetDateStruct()
	local currentSec 		= currentStime.hour*3600 + currentStime.min*60
	local len 				= #activityTime
	local j = 1
	for i=1, len do
		
		if activityTime[j+3] == nil then
			break
		end

		local activityBeginTime = activityTime[j]*3600 + activityTime[j+1]*60
		local activityEndTime	= activityTime[j+2]*3600 + activityTime[j+3]*60

		if currentSec < activityBeginTime then
			
			local leftSec = activityBeginTime - currentSec
			return FormatTimeBySec(leftSec), leftSec
		elseif currentSec > activityEndTime then
			if j+4 > len then
				local leftSec = 86400 - (currentSec - activityEndTime)
				return FormatTimeBySec(leftSec), leftSec
			end
		else
			return "0小时0分钟", 0
		end

		j = j + 4
	end
	return "", 0
end


