---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\activity\activity_main_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.10.18
--版  本:	1.0
--描  述:	活动界面的主窗口.主要负责切页
--			1、活动面板
--			2、副本
--			3、游戏指导
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
activityMainWnd 			= {}	--自己
activityMainWnd.thisWnd  		= nil				
local ctrlFlip 						--flip控件
local curPageIndex			= 1 	--当前所在的页
local subWndList			= {}	--子窗口列表
local funList	 			= {}	--函数列表
local nowTime 				= nil  	--当前时间

local weekdayconfig 		= {"星期一","星期二","星期三","星期四","星期五","星期六","星期日"}

--**********************************************************--
------------------------函数列表------------------------------

--初始化
function ActivityMainWndInit(wnd)
	activityMainWnd.thisWnd = wnd
	--注册显示回调事件
	activityMainWnd.thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnActivityMainWndShow')

	--设置切页时的调用	
	ctrlFlip 			= activityMainWnd.thisWnd:GetFlipPage('activity_flipPage')
	local pageCount 	= ctrlFlip:GetPageNum()
	for k=1, pageCount do 
		local pagebtn 	= ctrlFlip:GetPageBtnx(k-1)
		pagebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'OnActivityFlipSwitch')
	end
	
	--关闭按钮
	local btn_close = activityMainWnd.thisWnd:GetButton('activity_closebtn')
	btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'OnActivityMainWndClose')

	nowTime 		= activityMainWnd.thisWnd:GetLabel("now_time")

	--窗口的事件
	activityMainWnd.thisWnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,OnActivityMainWndEvent)
	
	activityMainWnd.thisWnd:SetVisible(false)

	timer.setTimer("OnTimeClock", 866, 1000) 
end

--主窗口显示回调
function OnActivityMainWndShow()
	--第一次显示的时候 切换到第一页
	ActivityMainWndFlipSwitch(1)
	
	if GetIsFreshHelpFlag('activity') ~= nil and GetIsFreshHelpFlag('activity') == 0 then
		SetIsFreshHelpFlag('activity', 1)
		WndSystem:GetInstance():OnEvent(866, 86606, 3, 0)		-----打开新手指引窗口
	end
	
end

--关闭事件
function OnActivityMainWndClose()
	activityMainWnd.thisWnd:SetVisible(false)
end

--OnEvent事件
--第一个参数 传送的活动activityID
--第二个参数 传送成功后需要关闭的窗口的ID
function OnActivityMainWndEvent(pWnd,event,eventID,param1,param2)
	--API_Trace("onEvent")
	local hero = core.getHero()
	if hero == nil then return end
	--传送的消息码
	if eventID == 86602 then
		if hero:GetVipLevel() > 1 or hero:GetTempVipLevel() > 1 then
			ActivityTransmit(param1)
		else
			ActivityWalk(param1)
		end
		if param2 ~= nil and param2 ~= 0 then
			WndSystem:GetInstance():ShowWnd(param2, 0);
		end
	elseif eventID == 86606 then
		activityMainWnd.thisWnd:SetVisible(false)
		activityMainWnd.thisWnd:SetVisible(true)
		ActivityMainWndFlipSwitch(param1)
	end
end

--flip切换函数
--pageIndex 为第几页
function ActivityMainWndFlipSwitch(pageIndex)
	--检查
	--API_Trace(pageIndex.."ActivityMainWndFlipSwitch")
	if subWndList[pageIndex] == nil then
		API_Trace("ActivityMainWndFlipSwitch pageIndex nil pageIndex:"..pageIndex)
		return
	else
		subWndList[curPageIndex]:SetVisible(false)
		curPageIndex 			= pageIndex
		subWndList[pageIndex]:SetVisible(true)
		--ctrlFlip:TurnPage(pageIndex-1)
		--tab标签不一定就是等于index
		local pageCount 	= ctrlFlip:GetPageNum()
		for k=1, pageCount do 
			local pagebtn 	= ctrlFlip:GetPageBtnx(k-1)
			if pagebtn:GetTag1() == pageIndex then
				ctrlFlip:TurnPage(k-1)
			end
		end
	end
end

--添加子窗口
function ActivityMainWndSubWnd(tag, wnd)
	activityMainWnd.thisWnd:AddWindow(wnd)
	subWndList[tag] 	= wnd
	--API_Trace("tag"..tag)
end

--点击切页
function OnActivityFlipSwitch(wnd)
	ActivityMainWndFlipSwitch(XButton:CastToButton(wnd):GetTag1())
end

function OnTimeClock()
	local currentWeekday 	= XDate:GetInstance():GetWeekDay()
	local currentTime 		= XDate:GetInstance():GetCurrentVTime()
	local currentStime 		= XDate:GetInstance():GetDateStruct()
	nowTime:setText(currentStime.year.."-"..currentStime.month.."-"..currentStime.day.." "..currentStime.hour..":"..currentStime.min..":00")
end


activityMainWnd.onEvent = OnEvent

--**********************************************************--
------------------------每日必修launch------------------------------
local activityLaunch 	= {}
activityLaunch.thisWnd 	= nil
activityLaunch.ani 		= nil

function ActivityLaunchInit()
	if activityLaunch.thisWnd ~= nil then
		return
	end

	--创建各个窗口并初始化
	activityLaunch.thisWnd = core.createWindow('Data\\Scp\\Windows\\Windows_Activity.scp', 905, false, g_pGlobal:GetMainUI():GetSystemIconSet(1, true))

	--按下按钮
	local btn = activityLaunch.thisWnd:GetButton('activityLaunchBtn')
	btn:SetClickEventHandler('OnActivityLaunchBtnClick')	
	activityLaunch.ani = activityLaunch.thisWnd:GetAni("activityAni")

	--timer.setTimer("activityLaunch_onTime", 1031, 60000) 
end

function OnActivityLaunchBtnClick()
	activityMainWnd.thisWnd:SetVisible(not activityMainWnd.thisWnd:IsVisible())
end

ActivityLaunchInit()

