﻿

ActivityDorpBox = {}

ActivityDorpBox.thisWnd = nil
ActivityDorpBox.vbmgr = nil

ActivityDorpBox.moduleName = "ActivityDorpBox"
local ActivityBoxCfg = {}

local function activity_drop_box_init()
	--判断下如果已经初始化过就不用初始化了
	if ActivityDorpBox.thisWnd ~= nil then
		return
	end
	
	--创建各个窗口并初始化
	ActivityDorpBox.thisWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',1027)
	
	----注册失去焦点调用
	ActivityDorpBox.thisWnd:SetLuaEvent(XWIN_EVENT_DEACTIVATE, "actvitiy_dorp_box_deactivate")
	
	--关闭按钮
	local btn_close = ActivityDorpBox.thisWnd:GetButton('关闭按钮')
	btn_close:SetClickEventHandler('actvitiy_dorp_box_close')
	
	--离开副本按钮
	local btn_leave = ActivityDorpBox.thisWnd:GetButton('离开副本')
	btn_leave:SetClickEventHandler('actvitiy_dorp_box_leave')

	----监听按下
	ActivityDorpBox.vbmgr = ActivityDorpBox.thisWnd:GetViewBoxMgr('物品栏')
	for i = 1, ActivityDorpBox.vbmgr:GetSize() do
		local vb = ActivityDorpBox.vbmgr:GetViewBox(i-1)
		vb:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "activity_drop_box_vb_mousedown")
	end
	
	----注册网络消息
	api_reg_module_msg_handler(ActivityDorpBox.moduleName, activity_drop_box_msg_handler)
	
end

----网络消息处理
function activity_drop_box_msg_handler()
	if msg.msg_code == "activity_level" then
		
	end
end

----失去焦点时
function actvitiy_dorp_box_deactivate()
	ActivityDorpBox.thisWnd:SetVisible(false)
end

----关闭界面
function actvitiy_dorp_box_close()
	 ActivityDorpBox.thisWnd:SetVisible(false)
end

----离开副本
function actvitiy_dorp_box_leave()
	local msg = {}
	msg.module =  "fly"
	msg.msg_code = "activity_level"
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)	
end

function activity_drop_box_vb_mousedown(vb_sel)
	if	ActivityBoxCfg == nil then
		return
	end

	for i = 1,#ActivityBoxCfg.rewards do
		if i > ActivityDorpBox.vbmgr:GetSize() then
			break
		end
		local vb = ActivityDorpBox.vbmgr:GetViewBox(i-1)

		if vb == vb_sel then
			vb_sel:SetAlwaysLight(true)

			local desc_html = ActivityDorpBox.thisWnd:GetHtml('描述')
			desc_html:Clear()
			--如果没有奖励内容那么默认的显示对应物品的描述
			if ActivityBoxCfg.rewards[i].desc == nil or ActivityBoxCfg.rewards[i].desc == "" then
				local goods_cfg = core.getGoodsConfig(ActivityBoxCfg.rewards[i].vb[1])
				if goods_cfg ~= nil then
					desc_html:ParseContext(goods_cfg.strDescDetail)
				end
			else
				desc_html:ParseContext(ActivityBoxCfg.rewards[i].desc)
			end
		else
			vb:SetAlwaysLight(false)
		end
	end
end

local function update_ui()
	--清空先
	ActivityDorpBox.vbmgr = ActivityDorpBox.thisWnd:GetViewBoxMgr('物品栏')
	for i=1, ActivityDorpBox.vbmgr:GetSize() do
		local vb = ActivityDorpBox.vbmgr:GetViewBox(i-1)
		vb:SetAlwaysLight(false)
		vb:ClearItem()
		vb:SetShowToolTip(false)
		vb:SetVisible(false)
	end

	local desc_html = ActivityDorpBox.thisWnd:GetHtml('描述')
	desc_html:Clear()

	ActivityDorpBox.thisWnd:GetLabel('内容'):setText("")

	if ActivityBoxCfg == nil then
		return
	end

	--显示
	ActivityDorpBox.thisWnd:GetLabel('内容'):setText(ActivityBoxCfg.name)
	for i = 1,#ActivityBoxCfg.rewards do
		if i > ActivityDorpBox.vbmgr:GetSize() then
			break
		end
		local vb = ActivityDorpBox.vbmgr:GetViewBox(i-1)
		vb:SetVisible(true)

		local vbItem = ActivityBoxCfg.rewards[i].vb
		if vbItem[3] == -1 then
			vb:SetItem(vbItem[1],vbItem[2])
		else
			vb:SetItem(vbItem[1],vbItem[2],false,vbItem[3])
		end
	end

	--默认显示第一个
	activity_drop_box_vb_mousedown(ActivityDorpBox.vbmgr:GetViewBox(0))
end

function activity_drop_box_open(context)
	ActivityBoxCfg = context
	
	ActivityDorpBox.update_ui()
	
	ActivityDorpBox.thisWnd:SetVisible(true)
end

-----初始化窗口
activity_drop_box_init()
ActivityDorpBox.update_ui = update_ui
ActivityDorpBox.cb_show_wnd = cb_show_wnd


--**********************************************************--
-------------------副本掉落信息的配置脚本----------------------
API_LoadScript("Data\\Scp\\drop_cfg.lua") 

--------副本掉落信息launch-----------------------------------------------------------
DropLaunch = {}
DropLaunch.thisWnd = nil --自己
DropLaunch.wndsys  = nil
DropLaunch.desktop = nil

local function drop_launch_init()
	--判断下如果已经初始化过就不用初始化了
	if DropLaunch.thisWnd ~= nil then
		return
	end
	DropLaunch.wndsys = WndSystem:GetInstance()
	DropLaunch.desktop = DropLaunch.wndsys:GetGameDesktop()

	--创建各个窗口并初始化
	DropLaunch.thisWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',791, false, g_pGlobal:GetMainUI():GetSystemIconSet(1, true))

	--按下按钮
	local btn = DropLaunch.thisWnd:GetButton('按钮')
	btn:SetClickEventHandler('drop_launch_btn')

	--监听玩家切换场景
	api_reg_hero_all_data_ready_listen(drop_launch_hero_all_data_ready_listen)
end

function drop_launch_hero_all_data_ready_listen()
	local cur_drop_info = DropLaunch.get_drop_info()
	local launchwnd = DropLaunch.thisWnd
	local fcmParent = XFlowCtrlMgr:CastToFlowCtrlMgr(launchwnd:GetParent())
	--如果是有配置掉落的场景那么就显示图标
	if nil ~= fcmParent then
		if cur_drop_info == nil then
			fcmParent:SetChildVisible(launchwnd:GetID(), false)
		else
			fcmParent:SetChildVisible(launchwnd:GetID(), true)
		end
	else
		if cur_drop_info == nil then
			launchwnd:SetVisible(false)
		else
			launchwnd:SetVisible(true)
		end
	end
end

function drop_launch_btn()
	local cur_drop_info = DropLaunch.get_drop_info()
	if cur_drop_info == nil then
		--隐藏按钮
		drop_launch_hero_all_data_ready_listen()
		return
	end
	activity_drop_box_open(cur_drop_info)	
end

local function get_drop_info()
	local cur_map_id = g_pGlobal:GetClientWorld():GetMapID() 
	--这里需要根据不同的副本进行不同个判断
	local hero = core.getHero()
	if hero == nil then return end
	local cur_shiliangu_lv = hero:GetPropEx("WarriorTrial_Game_Lv")
	local cur_drop_info =nil
	for i= 1,#drop_info_table do
		if cur_map_id == drop_info_table[i].mapId then
			--这里判断下是不是试炼谷，如果是还要进行进一步的判断
			if drop_info_table[i].shiliangu_lv ~= nil  then
				if drop_info_table[i].shiliangu_lv == cur_shiliangu_lv then
					return drop_info_table[i]
				end
			else
				return drop_info_table[i]
			end
		end
	end
	return nil
end

DropLaunch.get_drop_info = get_drop_info

-------读脚本时就执行
drop_launch_init()