---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\auction\auction_client.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.8.5
--版  本:	1.0
--描  述:	拍卖行客户端.负责和服务端交互
----------------------------------------------------------------------------------------------------------------------
--日  期:	2013.11.29
--版  本:	2.0
--描  述:	改名成交易行。去掉竞拍的功能，只剩一口价
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
-------------------加载对应的脚本-------------------------
API_LoadScript("Data\\Scp\\Lua\\window\\auction\\auction_main_wnd.lua")
API_LoadScript("Data\\Scp\\Lua\\window\\auction\\auction_add_sell_thing_wnd.lua")
API_LoadScript("Data\\Scp\\Lua\\window\\auction\\auction_mysell_page.lua")
API_LoadScript("Data\\Scp\\Common\\auction_cfg.lua")

--**********************************************************--
------------------------一些变量------------------------------
AuctionClient = {} --拍卖行模块实现
AuctionClient.auction_things ={} --查找页的拍卖品表
AuctionClient.valid_things = {} --查找页拍卖品是否有效的判别的表，和上边的拍卖品表是一一对应的
AuctionClient.mysell_auction_things ={} --我的上架页的拍卖品表
AuctionClient.mysell_valid_things = {} --我的上架页拍卖品是否有效的判别的表
AuctionClient.mybid_auction_things ={} --我的竞拍页的拍卖品表
AuctionClient.mybid_valid_things = {} --我的竞拍页拍卖品是否有效的判别的表

AuctionClient.page_row_count			= 10 --右边列表每页显示的行数，这里服务端客户端必须是同一个值

AuctionClient.module_name = "Auction"

--**********************************************************--
------------------------函数列表------------------------------
--模块初始化
local  function auction_init()	
	--判断下如果已经初始化过就不用初始化了
	if WndSystem:GetInstance():GetGameDesktop():FindWindowByID(591) ~= nil then
		return
	end
	
	--创建各个窗口并初始化
	local main_wnd = core.createWindow('Data/Scp/Windows/Windows_Auction.scp',591)
	auction_main_init(main_wnd)
	
	
	local my_sell_wnd =   core.createWindow('Data/Scp/Windows/Windows_Auction.scp',594)
	auction_mysell_init(my_sell_wnd)
	
	local add_sell_thing_wnd = core.createWindow('Data/Scp/Windows/Windows_Auction.scp',596)
	auction_add_sell_thing_init(add_sell_thing_wnd)
	
	--注册网络消息
	api_reg_module_msg_handler(AuctionClient.module_name,auction_msg_handler)
end
	
--------网络消息处理--------
--接收网络消息
function auction_msg_handler(msg)
	if (msg.msg_code=="cb_sell_thing") then
		AuctionClient.cb_sell_thing(msg)
	elseif (msg.msg_code=="cb_find_thing") then
		AuctionClient.cb_find_thing(msg)	
	elseif (msg.msg_code=="cb_request_thing") then
		AuctionClient.cb_request_thing(msg)
	elseif (msg.msg_code=="cb_fix_thing") then
		AuctionClient.cb_fix_thing(msg)
	elseif (msg.msg_code=="cb_find_mysell") then
		AuctionClient.cb_find_mysell(msg)
	elseif (msg.msg_code=="cb_cancel_sell") then
		AuctionClient.cb_cancel_sell(msg)
	elseif (msg.msg_code=="cb_request_price") then
		AuctionClient.cb_request_price(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end

--接收消息，上架成功
local function cb_sell_thing(msg)
	--关闭上架窗口
	--WndSystem:GetInstance():ShowWnd(596,0);
	
	--改成不关闭，只是清空
	--清空viewbox
	AuctionAddSellThingWnd.clear_vb()
	
	AuctionAddSellThingWnd.set_cur_paytype(enMoneyType_Ingot)
end

--接收消息，查找完返回拍卖品表
local function cb_find_thing(msg)
	AuctionClient.auction_things ={}
	AuctionClient.auction_things = msg.auction_things
	--API_Trace("cb_find_thing.thing count:"..#(AuctionClient.auction_things))
	--API_Trace(cjson.encode(AuctionClient.auction_things))
end

--接收消息，查找完返回拍卖品表
local function cb_request_thing(msg)
	if msg.type == "find" then
		for i=1,#msg.vSendFlag do
			local index = (msg.page-1)*AuctionClient.page_row_count + i
			AuctionClient.valid_things[index] = msg.vSendFlag[i]
			--检错下
			if AuctionClient.auction_things[index] == nil then
				API_Trace("cb_request_thing  auction_things is nil :index "..index.."  count:"..#AuctionClient.auction_things)
			end
		end
		
		--通知查找窗口
		AuctionMainWnd.flash_auction_things(msg.page)
	elseif msg.type == "mysell" then
		for i=1,#msg.vSendFlag do
			local index = (msg.page-1)*AuctionClient.page_row_count + i
			AuctionClient.mysell_valid_things[index] = msg.vSendFlag[i]
			--检错下
			if AuctionClient.mysell_auction_things[index] == nil then
				API_Trace("cb_request_thing  mysell_auction_things is nil :index "..index.."  count:"..#AuctionClient.mysell_auction_things)
			end
		end
		
		--通知我的上架窗口
		AuctionMySellWnd.flash_auction_things(msg.page)	
	else
		API_Trace("Auction error.cb_request_thing unknown type : "..msg.type)
	end
end

--接收消息，一口价返回
local function cb_fix_thing(msg)
	if msg.type == "find" then
		--这里要更新这个thing的状态，并刷新界面
		local flash_page = nil
		for i=1,#AuctionClient.auction_things do
			if AuctionClient.auction_things[i].uidThing == msg.uidThing then
				AuctionClient.valid_things[i] = false
				flash_page = math.ceil(i /AuctionClient.page_row_count)
				break
			end
		end
		
		--通知查找窗口
		if flash_page ~= nil then 
			AuctionMainWnd.flash_auction_things(flash_page)
		end
	else
		API_Trace("Auction error.cb_fix_thing unknown type : "..msg.type)
	end
end

--接收消息，查找返回我的上架的表
local function cb_find_mysell(msg)
	AuctionClient.mysell_auction_things ={}
	AuctionClient.mysell_auction_things = msg.auction_things
end

--接收消息，获取参考价
local function cb_request_price(msg)
	AuctionAddSellThingWnd.input_reference_price(msg.uidThing,msg.nLevel,msg.nId,msg.quality,msg.nStarLevel,msg.bidprice,msg.fixprice )
end

--发送消息，上架
local function auction_msg_sell_thing(uidThing,moneyType,bidprice,fixprice)
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "sell_thing"
	msg.uidThing = uidThing -- 这里是字符串类型而不是UID类型
	msg.moneytype = moneyType
	msg.bidprice = bidprice
	msg.fixprice = fixprice
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，获取参考价
local function auction_msg_request_price(uidThing,nLevel,nId,quality,nStarLevel)
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "request_price"
	msg.uidThing = uidThing -- 这里是字符串类型而不是UID类型
	msg.nLevel = nLevel
	msg.nId = nId
	msg.quality = quality
	msg.nStarLevel = nStarLevel
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，查找
local function auction_msg_find_by_class(strNameKeyword,nLowerLimit,nUpperLimit,quality,nStarLevelLow,nStarLevelUppper,thingClass,firstClass,secondClass,thirdClass)
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "find_thing_by_class"
	
	msg.strNameKeyword = strNameKeyword 	--strNameKeyword 名字字串
	msg.nLowerLimit=nLowerLimit 			--nLowerLimit 等级下限
	msg.nUpperLimit= nUpperLimit			--nUpperLimit 等级上限 
	msg.nId= nId 							--nId 物品id或者怪物id
	msg.quality =quality	 				--quality	  品质
	msg.nStarLevelLow = nStarLevelLow		--nStarLevelLower  星级下限 
	msg.nStarLevelUppper = nStarLevelUppper	--nStarLevelUpper  星级上限 
	msg.thingClass = thingClass				--thingClass  类型，宠物，物品
	msg.firstClass =firstClass				--firstClass  第一子类
	msg.secondClass = secondClass			--secondClass 第二子类
	msg.thirdClass = thirdClass				--thirdClass  第三子类
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，查找
local function auction_msg_find_by_id(strNameKeyword,nLowerLimit,nUpperLimit,quality,nStarLevelLow,nStarLevelUppper,index)
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "find_thing_by_id"
	
	msg.strNameKeyword = strNameKeyword 	--strNameKeyword 名字字串
	msg.nLowerLimit=nLowerLimit 			--nLowerLimit 等级下限
	msg.nUpperLimit= nUpperLimit			--nUpperLimit 等级上限 
	msg.nId= nId 							--nId 物品id或者怪物id
	msg.quality =quality	 				--quality	  品质
	msg.nStarLevelLow = nStarLevelLow		--nStarLevelLower  星级下限 
	msg.nStarLevelUppper = nStarLevelUppper	--nStarLevelUpper  星级上限 
	msg.index = index						--在树形控件中的索引
	
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，查找常用物品
local function auction_msg_find_common_use()
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "find_thing_common_use"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，请求服务端发送thing对象过来，参数是uid的字串的数组
local function auction_msg_request_info(vUID,strType,page)
	if vUID == nil or #vUID == 0 then
		return
	end
	
	--API_Trace(cjson.encode(vUID))
	
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "request_thing"
	msg.vUID = vUID
	msg.page = page
	msg.type = strType
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，一口价
local function auction_msg_fix_thing(uidThing,strType)
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "fix_thing"
	msg.uidThing = uidThing
	msg.type = strType
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--发送消息，查找我的上架的物品
local function auction_msg_find_mysell()
	local msg = {}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "find_mysell"
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--在现有的查找表中找到对应uid的拍卖品
local function local_find_thing(strUID)
	for i=1,#AuctionClient.auction_things do
		if AuctionClient.auction_things[i].uidThing == strUID then
			return AuctionClient.auction_things[i]
		end
	end
	
	return nil
end

--接收消息，取消上架返回
local function cb_cancel_sell(msg)
	--这里要更新这个thing的状态，并刷新界面
	local flash_page = nil
	for i=1,#AuctionClient.mysell_auction_things do
		if AuctionClient.mysell_auction_things[i].uidThing == msg.uidThing then
			AuctionClient.mysell_valid_things[i] = false
			flash_page = math.ceil(i /AuctionClient.page_row_count)
			break
		end
	end
		
	--通知我的上架窗口窗口
	if flash_page ~= nil then 
		AuctionMySellWnd.flash_auction_things(flash_page)
	end
end

--发送消息，取消拍卖
local function auction_cancel_sell(uidThing)
	local msg ={}
	msg.module   = AuctionClient.module_name
	msg.msg_code = "cancel_sell"
	msg.uidThing = uidThing
	
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

--**********************************************************--
--------------------刷脚本的时候执行--------------------------
-- 开服先刷一次,模块初始化
auction_init()

AuctionClient.cb_sell_thing = cb_sell_thing
AuctionClient.cb_find_thing = cb_find_thing
AuctionClient.cb_request_thing = cb_request_thing
AuctionClient.cb_fix_thing = cb_fix_thing
AuctionClient.cb_find_mysell = cb_find_mysell
AuctionClient.cb_request_price =cb_request_price
--上架物品
AuctionClient.sell_thing = auction_msg_sell_thing
--查找物品
AuctionClient.find_by_class = auction_msg_find_by_class
AuctionClient.find_by_id = auction_msg_find_by_id
AuctionClient.find_common_use = auction_msg_find_common_use --查找常用物品，用于浏览页刚打开的时候
--请求发送thing对象过来
AuctionClient.request_info = auction_msg_request_info
--一口价
AuctionClient.fix_thing = auction_msg_fix_thing
--查找我的上架的物品
AuctionClient.find_mysell = auction_msg_find_mysell
--在现有的查找表中找到对应uid的拍卖品
AuctionClient.local_find_thing = local_find_thing
--获取一件拍卖品的参考价
AuctionClient.request_price =auction_msg_request_price
AuctionClient.cb_cancel_sell = cb_cancel_sell
AuctionClient.cancel_sell= auction_cancel_sell

