---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\auction\auction_main_wnd.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.8.5
--版  本:	1.0
--描  述:	拍卖行主框架窗口.主要负责切页
---------------------------------------------------------------------------------------------------------------------
--日  期:	2013.11.29
--版  本:	2.0
--描  述:	将查找拍卖品的功能移植到这里来
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
AuctionMainWnd = {}

AuctionMainWnd.this_wnd 				= nil  	--自己
AuctionMainWnd.ctrl_gold 				= nil
AuctionMainWnd.ctrl_goldingot 			= nil
AuctionMainWnd.panelmgr 				= nil 	--拍卖品列表框
AuctionMainWnd.pagenum_label 			= nil
AuctionMainWnd.name_edit 				= nil	--名字编辑框
AuctionMainWnd.level_lower_limit_edit 	= nil
AuctionMainWnd.level_upper_limit_edit 	= nil
AuctionMainWnd.btn_quality 				= nil	--品质按钮
AuctionMainWnd.sort_tree				= nil  	--用于选择分类的树形控件

AuctionMainWnd.cur_page_num    			= nil	--当前页码
AuctionMainWnd.cur_sel_quality 			= nil 	--当前选择的质量，默认是全部(nil)

local negation_val = 10000 --用于判断是否取反

--品质poplist的上下文
local quality_list = {}
quality_list["item_1"] = "白色"
quality_list["item_data_1"] = 0
quality_list["item_quality_clr_1"] = enGoodsQuality_Common
quality_list["item_clr_1"] = {r = 255, g = 255, b = 255}

quality_list["item_2"] = "绿色"
quality_list["item_data_2"] = 1
quality_list["item_quality_clr_2"] = enGoodsQuality_OutStanding
quality_list["item_clr_2"] = {r = 0, g = 255, b = 0}

quality_list["item_3"] = "蓝色"
quality_list["item_data_3"] = 2
quality_list["item_quality_clr_3"] = enGoodsQuality_Fine
quality_list["item_clr_3"] = {r = 0, g = 252, b = 226}

quality_list["item_4"] = "紫色"
quality_list["item_data_4"] = 3
quality_list["item_quality_clr_4"] = enGoodsQuality_Excel
quality_list["item_clr_4"] = {r = 192, g = 87, b = 253}

quality_list["item_5"] = "橙色"
quality_list["item_data_5"] = 4
quality_list["item_quality_clr_5"] = enGoodsQuality_Tale
quality_list["item_clr_5"] = {r = 255, g = 97, b = 0}

quality_list["item_6"] =  "全部"
quality_list["item_data_6"] = -1
quality_list["item_quality_clr_6"] = enGoodsQuality_Common
quality_list["item_clr_6"] = {r = 255, g = 255, b = 255}

quality_list.count = 6
quality_list.line_height = 40


--**********************************************************--
------------------------函数列表------------------------------
--初始化
function auction_main_init(wnd)	
	AuctionMainWnd.this_wnd = wnd

	--关闭按钮
	AuctionMainWnd.this_wnd:GetButton('btnclose'):SetClickEventHandler2(function()
				AuctionMainWnd.this_wnd:SetVisible(false)
			end)
	
	--关闭按钮
	AuctionMainWnd.this_wnd:GetButton('出售记录'):SetClickEventHandler2(function()
				AuctionMySellWnd.this_wnd:SetVisible(false)
				AuctionMySellWnd.this_wnd:SetVisible(true)
			end)
			
	--设置显示时的调用
	AuctionMainWnd.this_wnd:SetLuaEvent(XWIN_EVENT_SHOW,'auction_main_onshow')

	--出售按钮
	local btn_sell = AuctionMainWnd.this_wnd:GetButton('出售')
	btn_sell:SetLuaEvent(XWIN_EVENT_CLICK, 'auction_main_btn_sell')

	--查找按钮
	local btn_find = AuctionMainWnd.this_wnd:GetButton('查找')
	btn_find:SetClickEventHandler('auction_main_btn_find')

	--自己的钱
	AuctionMainWnd.ctrl_gold=AuctionMainWnd.this_wnd:GetMoneyLabel('游戏币')
	AuctionMainWnd.ctrl_gold:SetShowCopper(false)
	AuctionMainWnd.ctrl_goldingot = AuctionMainWnd.this_wnd:GetMoneyLabel('元宝')

	--右边列表
	local srcollmgr =AuctionMainWnd.this_wnd:GetScrollMgr('滚动管理')
	AuctionMainWnd.panelmgr = srcollmgr:GetPanelMgr('物品列表')
	--page_row_count = AuctionMainWnd.panelmgr:GetPanelCount()
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		panel:SetEventToWindow(srcollmgr)

		panel:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, 'auction_main_sel_panel')
		
		local sel_static = panel:getWindow('选中')
		sel_static:SetVisible(false)
		
		panel:GetButton('购买'):SetClickEventHandler("auction_main_btn_fixprice")
	end
	
	--页码
	AuctionMainWnd.pagenum_label = AuctionMainWnd.this_wnd:GetLabel('页码')

	--前一页按钮
	local btn_prev = AuctionMainWnd.this_wnd:GetButton('左边按钮')
	btn_prev:SetClickEventHandler('auction_main_btn_prev')

	--后一页按钮
	local btn_next = AuctionMainWnd.this_wnd:GetButton('右边按钮')
	btn_next:SetClickEventHandler('auction_main_btn_next')

	--名字编辑框
	AuctionMainWnd.name_edit = AuctionMainWnd.this_wnd:GetEdit('查找输入框')

	--等级下限
	AuctionMainWnd.level_lower_limit_edit = AuctionMainWnd.this_wnd:GetEdit('等级下限')

	--等级上限
	AuctionMainWnd.level_upper_limit_edit = AuctionMainWnd.this_wnd:GetEdit('等级上限')

	--品质按钮
	AuctionMainWnd.btn_quality = AuctionMainWnd.this_wnd:GetButton('品质2')
	AuctionMainWnd.btn_quality:SetLuaEvent(XWIN_EVENT_CLICK, 'auction_main_btn_quality')

	--树形控件
	local srcollmgr2 =AuctionMainWnd.this_wnd:GetScrollMgr('分类树滚动管理')
	local panelwnd2= srcollmgr2:GetPanel('面板框')
	AuctionMainWnd.sort_tree = panelwnd2:GetTree('分类树')
	AuctionMainWnd.sort_tree:SetEventToWindow(srcollmgr2)
	AuctionMainWnd.init_tree_ctrl()

	--添加展开监听
	AuctionMainWnd.sort_tree:SetLuaEvent(XWIN_EVENT_TREE_EXPAND, 'auction_main_tree_expand')

	--监听玩家属性变化
	g_pGlobal:GetEventServer():onEvent(make_msgid(CIRCULTYPE_CC, MSG_ACTION_SYNC_PROP), AuctionMainWnd.auction_main_on_sync_prop)
	
end

local function init_tree_item(itemCfg,pParent)
	local ti = HXTreeRoot
	local tid = nil
	if itemCfg.index ~= -1 then
		--1 创建item
		local name = ""
		if itemCfg.name ~= nil then
			name = itemCfg.name
		end
		ti = AuctionMainWnd.sort_tree:AddItem(pParent, name);
		tid = AuctionMainWnd.sort_tree:GetTreeNodeItemData(ti)
		
		
		--2 设置图片和玩家数据
		if pParent == HXTreeRoot then
			local bmppath = ""
			if itemCfg.bmppath ~= nil then
				bmppath = itemCfg.bmppath 
			end
			local bmpItemBk = g_pGlobal:GetResourceMgr():RequestUIImage(bmppath);
			tid.ItemBkBitmap = bmpItemBk;
			tid.alignXStr = AS_CENTERX
		else
			 -- 非顶层不用图片显示了，显示个图标
			tid.ItemBitmap = g_pGlobal:GetResourceMgr():RequestIcon(46400)
		end
		tid.name = itemCfg.showname		
		
		tid.dwItemData = itemCfg.index
	end
	
	--3 创建子节点，如果有的话
	if itemCfg.vItem ~= nil and #itemCfg.vItem ~= 0 then
		if ti~= HXTreeRoot and tid~= nil then
			tid.expandable = true
		end
		
		for j=1,#itemCfg.vItem do
			AuctionMainWnd.init_tree_item(itemCfg.vItem[j],ti)
		end
	end
	
end

local function init_tree_ctrl()
	AuctionMainWnd.sort_tree:SetItemHeight(40);

	local tree_cfg = get_auction_tree_cfg()
	--递归初始化
	AuctionMainWnd.init_tree_item(tree_cfg,HXTreeRoot)
	
	--默认选择"全部"
	local tiAll =AuctionMainWnd.sort_tree:GetChildByIndex(HXTreeRoot,0)
	AuctionMainWnd.sort_tree:SetCurSel(AuctionMainWnd.sort_tree:GetTreeNodeItemData(tiAll))
end

--窗口打开时
function auction_main_onshow()
	AuctionMainWnd.auction_main_fresh_money()
	
	AuctionMainWnd.flash_auction_things(1)
	AuctionClient.find_common_use()
end

--点击出售
function auction_main_btn_sell()
	--弹出出售窗口
	WndSystem:GetInstance():ToggleWnd(596)
end

--玩家属性变化
local function auction_main_on_sync_prop(obj,msgid)
	--窗口不可见就忽略
	if( not AuctionMainWnd.this_wnd:IsVisible() or not obj:IsHero()) then return end

	AuctionMainWnd.auction_main_fresh_money()
end

--刷新金钱
local function auction_main_fresh_money()
	local hero = core.getHero()
	if hero==nil  then
		return
	end

	--刷新一下元宝属性，防止元宝变化了
	local gold = hero:GetCrtProp(enProp_Actor_M_Gold)
	local ingot = hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	
	AuctionMainWnd.ctrl_gold:SetMoney(gold)
	AuctionMainWnd.ctrl_goldingot:SetMoney(ingot)
end

--查找按钮
function auction_main_btn_find()
	--关键字
	local strName = AuctionMainWnd.name_edit:getText()
	if strName == "" then
		strName = nil
	end

	--等级下限
	local lvLowLimit =  AuctionMainWnd.level_lower_limit_edit:getText()

	--等级上限
	local lvUpperLimit =  AuctionMainWnd.level_upper_limit_edit:getText()

	--分类树
	local cur_item = AuctionMainWnd.sort_tree:GetCurSel()
	if cur_item== nil  then
		--strNameKeyword,nLowerLimit,nUpperLimit,quality,nStarLevelLow,nStarLevelUppper,thingClass,firstClass,secondClass,thirdClass)
		AuctionClient.find_by_id(	strName,
						tonumber(lvLowLimit),
						tonumber(lvUpperLimit),
						AuctionMainWnd.cur_sel_quality
						)
	else
		AuctionClient.find_by_id(	strName,
						tonumber(lvLowLimit),
						tonumber(lvUpperLimit),
						AuctionMainWnd.cur_sel_quality,
						nil,
						nil,
						cur_item.dwItemData
						)
	end

end

--刷新右侧拍卖品的listbox，参数一是第几页，从第一页开始算起
local function flash_auction_things(page)
	--这里先清空下
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		panel:SetVisible(false)
	end
	
	local things = AuctionClient.auction_things
	if #things == 0 then
		return
	end

	--计算页数
	if page <= 0 then
		API_Trace("flash_auction_things page <= 0")
		return
	end
	local page_num = math.ceil(#things /AuctionClient.page_row_count)
	if page > page_num then
		API_Trace("flash_auction_things page > page_num")
		return
	end

	--清除选中状态
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		local sel_static = panel:getWindow('选中')
		sel_static:SetVisible(false)
	end

	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		local auction_thing = AuctionClient.auction_things[(page-1)*AuctionClient.page_row_count+i]
		local thing_valid = AuctionClient.valid_things[(page-1)*AuctionClient.page_row_count+i] --显示时判断物品是否下架了，下架就做标明下
		if auction_thing ~= nil and thing_valid == nil  then
			API_Trace("flash_auction_things  thing_valid is nil ")
			thing_valid = false
		end

		--控件先清空下
		local name_html = panel:GetHtml('物品名')
		name_html:Clear()

		local level_html = panel:GetHtml('等级')
		level_html:Clear()

		local fixprice_mlabel=panel:GetMoneyLabel('一口价')
		fixprice_mlabel:SetVisible(false)

		local vb = panel:GetItemViewBox('物品图标')
		vb:ClearItem()


		if auction_thing ~= nil  and thing_valid == true then
			panel:SetVisible(true)

			name_html:ParseContext(auction_thing.strName)

			level_html:ParseContext(auction_thing.nLevel.."级")

			fixprice_mlabel:SetVisible(true)
			fixprice_mlabel:SetMoneyType(auction_thing.moneytype)
			fixprice_mlabel:SetMoney(auction_thing.fixprice)

			local uid = core.strToUID(auction_thing.uidThing)
			vb:SetItem(uid)
		elseif  auction_thing ~= nil  and thing_valid == false then
			panel:SetVisible(true)

			name_html:ParseContext("(已下架)"..auction_thing.strName)

		else
			panel:SetVisible(false)
		end
	end

	--这里要显示当前的页码
	AuctionMainWnd.pagenum_label:setText(page.."/"..page_num)

	AuctionMainWnd.cur_page_num = page
end

local function format_time(minute)
	if minute <= 0 then
		return ""
	elseif minute<60 then
		return minute.."分钟"
	else
		local hour = math.floor(minute/60)
		return hour.."小时"
	end

end

--前一页
function auction_main_btn_prev()
	if AuctionMainWnd.cur_page_num == nil then
		return
	end

	if AuctionMainWnd.cur_page_num-1 <= 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "当前已经是首页")
		return
	end

	AuctionMainWnd.flash_auction_things(AuctionMainWnd.cur_page_num-1)

	
	local vUID = {}
	for i=1,AuctionClient.page_row_count do
		local auction_thing = AuctionClient.auction_things[(AuctionMainWnd.cur_page_num-2)*AuctionClient.page_row_count+i]
		if auction_thing == nil then
			break
		end
		vUID[i] = auction_thing.uidThing
	end

	AuctionClient.request_info(vUID[i],"find",AuctionMainWnd.cur_page_num-1)
end

--后一页
function auction_main_btn_next()
	if AuctionMainWnd.cur_page_num == nil then
		return
	end

	local page_num = math.ceil(#AuctionClient.auction_things /AuctionClient.page_row_count)
	if AuctionMainWnd.cur_page_num+1 > page_num then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "当前已经是最后一页")
		return
	end

	local vUID = {}
	for i=1,AuctionClient.page_row_count do
		local auction_thing = AuctionClient.auction_things[(AuctionMainWnd.cur_page_num)*AuctionClient.page_row_count+i]
		if auction_thing == nil then
			break
		end
		vUID[i] = auction_thing.uidThing
	end

	if #vUID == 0 then
		API_Trace("auction_main_btn_next  vUID size == 0 ")
		return
	end

	AuctionClient.request_info(vUID,"find",AuctionMainWnd.cur_page_num+1)
end

--品质
function auction_main_btn_quality()
	local jsonstr = cjson.encode(quality_list)

	local desktop_wnd = WndSystem:GetInstance():GetGameDesktop()
	xPopupList = WndSystem:GetInstance():CreatePopupListWnd(desktop_wnd)
	xPopupList:InitPopupListEx("auction_main_pop_cb",jsonstr)
	xPopupList:SetVisible(true)
end

function auction_main_pop_cb(selIndex , userdata)
	--先设置按钮文本
	local name_i_str = "item_"..(selIndex+1)
	local clr_i_str = "item_clr_"..(selIndex+1)	
	local name = quality_list[name_i_str];
	local clr = quality_list[clr_i_str];
	if name == nil or clr == nil then
		API_TraceError("auction_main_pop_cb error.selIndex:"..selIndex)
		return
	end

	AuctionMainWnd.btn_quality:setText(name)	
	AuctionMainWnd.btn_quality:SetForeColor(clr.r, clr.g, clr.b)
	
	if userdata >= enGoodsQuality_Common and userdata < enGoodsQuality_Max then
		AuctionMainWnd.cur_sel_quality = userdata
	else
		AuctionMainWnd.cur_sel_quality = nil
	end
end

--树控件被展开或者收起
function auction_main_tree_expand(pWnd,event,tiExpand,bIsExpand)
	--由于空间有限，当展开一个时把别的都收缩
	if bIsExpand == 1  then
		for i=0,AuctionMainWnd.sort_tree:GetChildItemCount(HXTreeRoot)-1 do
			local ti = AuctionMainWnd.sort_tree:GetChildByIndex(HXTreeRoot,i);
			if ti ~= HXTreeRoot  and ti ~= tiExpand then
				local  tni = AuctionMainWnd.sort_tree:GetTreeNodeItemData(ti);
				AuctionMainWnd.sort_tree:ExpandNode(tni,false,true);
			end
		end
	end
end


function auction_main_sel_panel(pWnd)
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		local sel_static = panel:getWindow('选中')
		if panel == pWnd then
			--sel_static:SetVisible(true)
			sel_static:SetVisible(false) -- 不在界面上显示选中了哪个了
		else
			sel_static:SetVisible(false)
		end
	end
end

--点击一口价按钮
function auction_main_btn_fixprice(pWnd)
	local hero = core.getHero()
	if hero==nil  then return end

	--1 找到选中的拍卖品
	if AuctionMainWnd.cur_page_num == nil then
		return
	end
	local sel_auction_thing = nil
	local sel_index = nil
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMainWnd.panelmgr:GetPanelWnd(i-1)
		local curBtn = panel:GetButton('购买')
		if curBtn == XButton:CastToButton(pWnd)	then
			sel_auction_thing = AuctionClient.auction_things[i+(AuctionMainWnd.cur_page_num-1)*AuctionClient.page_row_count]
			sel_index = i+(AuctionMainWnd.cur_page_num-1)*AuctionClient.page_row_count
		end
	end
	if sel_auction_thing == nil then
		--API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选中某交易品")
		return
	end
	if AuctionClient.valid_things[sel_index] == false then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该交易品已经下架")
		return
	end

	--2 判断钱够不够
	local ingot = hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	local strmoney = ""
	if enMoneyType_Ingot ==sel_auction_thing.moneytype then
		strmoney = "#(GoldIngot,"..sel_auction_thing.fixprice..")"
		if sel_auction_thing.fixprice>ingot then
			API_ShowSystemMessage(enSysMsgDisplayType_Float, "元宝不足.需要"..strmoney)
			return
		end
	else
		API_Trace("auction_main_btn_fixprice moneytype error :"..sel_auction_thing.moneytype)
		return
	end

	--3 弹消息框
	g_pGlobal:GetMainUI():ShowMessageBox("花"..strmoney.."买下"..sel_auction_thing.strName,"auction_main_fixprice_cb",sel_index,0,"确定","取消");

end

--一口价返回
function auction_main_fixprice_cb(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then return end
	
	local hero = core.getHero()
	if hero == nil then return end 

	if AuctionMainWnd.this_wnd:IsVisible() == false then
		return
	end
	
	local sel_auction_thing =  AuctionClient.auction_things[wparam]
	if sel_auction_thing == nil then return end
	if AuctionClient.valid_things[sel_index] == false then	return	end
	
	--在判断下金钱
	local ingot = hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	if enMoneyType_Ingot ==sel_auction_thing.moneytype then
		if sel_auction_thing.fixprice>ingot then
			return
		end
	else
		return
	end
	
	--发消息
	AuctionClient.fix_thing(sel_auction_thing.uidThing,"find")
end

--**********************************************************--
--------------------刷脚本的时候执行--------------------------
AuctionMainWnd.auction_main_on_sync_prop=auction_main_on_sync_prop
AuctionMainWnd.auction_main_fresh_money=auction_main_fresh_money
AuctionMainWnd.format_time=format_time
AuctionMainWnd.flash_auction_things = flash_auction_things
AuctionMainWnd.init_tree_ctrl = init_tree_ctrl
AuctionMainWnd.init_tree_item  = init_tree_item


