---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\auction\auction_mysell_page.lua
--版  权:	(C)盛游
--创建人:	linhongwei
--日  期:	2013.8.29
--版  本:	1.0
--描  述:	拍卖行我的上架页
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
AuctionMySellWnd = {}

AuctionMySellWnd.this_wnd 				= nil  	--自己
AuctionMySellWnd.ctrl_gold 				= nil
AuctionMySellWnd.ctrl_goldingot 		= nil
AuctionMySellWnd.panelmgr 				= nil 	--拍卖品列表框
AuctionMySellWnd.pagenum_label 			= nil

AuctionMySellWnd.cur_page_num    		= nil --当前页码

--**********************************************************--
------------------------函数列表------------------------------
--初始化
function auction_mysell_init(wnd)
	AuctionMySellWnd.this_wnd = wnd

	--关闭按钮
	AuctionMySellWnd.this_wnd:GetButton('btnclose'):SetClickEventHandler2(function()
				AuctionMySellWnd.this_wnd:SetVisible(false)
			end)
			
	--设置显示时的调用
	AuctionMySellWnd.this_wnd:SetLuaEvent(XWIN_EVENT_SHOW,'auction_mysell_onshow')
	
	--右边列表
	local srcollmgr =AuctionMySellWnd.this_wnd:GetScrollMgr('滚动管理')
	AuctionMySellWnd.panelmgr = srcollmgr:GetPanelMgr('物品列表')
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMySellWnd.panelmgr:GetPanelWnd(i-1)
		panel:SetEventToWindow(srcollmgr)

		--控件先清空下
		local sel_static = panel:getWindow('选中')
		sel_static:SetVisible(false)

		panel:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, 'auction_mysell_panel')
		
		panel:GetButton('取消'):SetClickEventHandler2(AuctionMySellWnd.cancel_sell)
	end
	--页码
	AuctionMySellWnd.pagenum_label = AuctionMySellWnd.this_wnd:GetLabel('页码')

	--前一页按钮
	local btn_prev = AuctionMySellWnd.this_wnd:GetButton('左边按钮')
	btn_prev:SetClickEventHandler('auction_mysell_btn_prev')

	--后一页按钮
	local btn_next = AuctionMySellWnd.this_wnd:GetButton('右边按钮')
	btn_next:SetClickEventHandler('auction_mysell_btn_next')

	--出售按钮
	AuctionMySellWnd.this_wnd:GetButton('出售'):SetLuaEvent(XWIN_EVENT_CLICK, 'auction_mysell_btn_sell')
	
	AuctionMySellWnd.flash_auction_things(1)
	
end

--窗口打开时
function auction_mysell_onshow()
	--每次打开都查找一遍
	AuctionClient.find_mysell()
end

--点击出售按钮
function auction_mysell_btn_sell()
	--弹出出售窗口
	WndSystem:GetInstance():ToggleWnd(596)
end

--更新
local function flash_auction_things(page)
	--这里先清空下
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMySellWnd.panelmgr:GetPanelWnd(i-1)
		panel:SetVisible(false)
	end
	
	AuctionMySellWnd.pagenum_label:setText("")
	
	local things = AuctionClient.mysell_auction_things
	if things == nil or #things == 0 then
		return
	end

	--计算页数
	if page <= 0 then
		API_Trace("AuctionMySellWnd flash_auction_things page <= 0")
		return
	end
	local page_num = math.ceil(#things /AuctionClient.page_row_count)
	if page > page_num then
		API_Trace("AuctionMySellWnd flash_auction_things page > page_num")
		return
	end

	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMySellWnd.panelmgr:GetPanelWnd(i-1)
		local auction_thing = AuctionClient.mysell_auction_things[(page-1)*AuctionClient.page_row_count+i]
		local thing_valid = AuctionClient.mysell_valid_things[(page-1)*AuctionClient.page_row_count+i] --显示时判断物品是否下架了，下架就做标明下
		if auction_thing ~= nil and thing_valid == nil  then
			API_Trace("AuctionMySellWnd flash_auction_things  thing_valid is nil ")
			thing_valid = false
		end

		--控件先清空下
		local name_html = panel:GetHtml('物品名')
		name_html:Clear()

		local level_html = panel:GetHtml('等级')
		level_html:Clear()

		local timeleft_html =panel:GetHtml('剩余时间')
		timeleft_html:Clear()

		local fixprice_mlabel=panel:GetMoneyLabel('一口价')
		fixprice_mlabel:SetVisible(false)

		local vb = panel:GetItemViewBox('物品图标')
		vb:ClearItem()

		local btnCancel = panel:GetButton("取消")

		if auction_thing ~= nil  and thing_valid == true then
			panel:SetVisible(true)

			name_html:ParseContext(auction_thing.strName)

			level_html:ParseContext(auction_thing.nLevel.."级")

			
			local curTime = XDate:GetInstance():GetCurrentVTime()
			local strTL = AuctionMySellWnd.format_time(math.ceil((auction_thing.tOffTime - curTime)/60))
			timeleft_html:ParseContext(strTL)

			fixprice_mlabel:SetVisible(true)
			fixprice_mlabel:SetMoneyType(auction_thing.moneytype)
			fixprice_mlabel:SetMoney(auction_thing.fixprice)

			local uid = core.strToUID(auction_thing.uidThing)
			vb:SetItem(uid)
			
			btnCancel:SetVisible(true)
		elseif  auction_thing ~= nil  and thing_valid == false then
			panel:SetVisible(true)

			name_html:ParseContext("(已下架)"..auction_thing.strName)

			btnCancel:SetVisible(false)
		else
			panel:SetVisible(false)
		end
	end

	--这里要显示当前的页码
	AuctionMySellWnd.pagenum_label:setText(page.."/"..page_num)

	AuctionMySellWnd.cur_page_num = page
end

--前一页
function auction_mysell_btn_prev()
	if AuctionMySellWnd.cur_page_num == nil then
		return
	end

	if AuctionMySellWnd.cur_page_num-1 <= 0 then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "当前已经是首页")
		return
	end

	AuctionMySellWnd.flash_auction_things(AuctionMySellWnd.cur_page_num-1)
end

--后一页
function auction_mysell_btn_next()
	if AuctionMySellWnd.cur_page_num == nil then
		return
	end

	local page_num = math.ceil(#AuctionClient.mysell_auction_things /AuctionClient.page_row_count)
	if AuctionMySellWnd.cur_page_num+1 > page_num then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "当前已经是最后一页")
		return
	end

	local vUID = {}
	for i=1,AuctionClient.page_row_count do
		local auction_thing = AuctionClient.mysell_auction_things[(AuctionMySellWnd.cur_page_num)*AuctionClient.page_row_count+i]
		if auction_thing == nil then
			break
		end
		vUID[i] = auction_thing.uidThing
	end

	if #vUID == 0 then
		API_Trace("auction_mysell_btn_next  vUID size == 0 ")
		return
	end

	AuctionClient.request_info(vUID,"mysell",AuctionMySellWnd.cur_page_num+1)
end

--这里由于考虑到不同页面可以写的空间不一样，所以分开写
local function format_time(minute)
	if minute <= 0 then
		return ""
	elseif minute<60 then
		return minute.."分钟"
	else
		local hour = math.floor(minute/60)
		return hour.."小时"
	end

end

function auction_mysell_panel(pWnd)
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMySellWnd.panelmgr:GetPanelWnd(i-1)
		local sel_static = panel:getWindow('选中')
		if panel == pWnd then
			--sel_static:SetVisible(true)--暂时不显示选中状态，需要支持取消竞拍时再显示
			sel_static:SetVisible(false)
		else
			sel_static:SetVisible(false)
		end
	end
end

--点击取消竞拍按钮
local function cancel_sell(pWnd)
	local hero = core.getHero()
	if hero==nil  then return end

	--1 找到选中的拍卖品
	if AuctionMySellWnd.cur_page_num == nil then
		return
	end
	local sel_auction_thing = nil
	local sel_index = nil
	for i=1,AuctionClient.page_row_count do
		local panel = AuctionMySellWnd.panelmgr:GetPanelWnd(i-1)
		local curBtn = panel:GetButton("取消")
		if curBtn == XButton:CastToButton(pWnd)	then
			sel_auction_thing = AuctionClient.mysell_auction_things[i+(AuctionMySellWnd.cur_page_num-1)*AuctionClient.page_row_count]
			sel_index = i+(AuctionMySellWnd.cur_page_num-1)*AuctionClient.page_row_count
		end
	end
	if sel_auction_thing == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先选中某交易品")
		return
	end
	if AuctionClient.mysell_valid_things[sel_index] == false then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该交易品已经下架")
		return
	end
	
	--2 弹消息框
	g_pGlobal:GetMainUI():ShowMessageBox("取消上架"..sel_auction_thing.strName.."吗？","auction_mysell_cancel_sell_cb",sel_index,0,"确定","取消");
end

function auction_mysell_cancel_sell_cb(msgid,wparam,lparam) 
	if(msgid ~= WE_AW_BTN1_CLICKED) then return end
	
	if AuctionMySellWnd.this_wnd:IsVisible() == false then
		return
	end
	 
	local hero = core.getHero()
	if hero == nil then return end 

	local sel_auction_thing =  AuctionClient.mysell_auction_things[wparam]
	if sel_auction_thing == nil then return end
	if AuctionClient.mysell_valid_things[sel_index] == false then return	end
	
	
	--发消息
	AuctionClient.cancel_sell(sel_auction_thing.uidThing)
end

--**********************************************************--
--------------------刷脚本的时候执行--------------------------
AuctionMySellWnd.on_sync_prop=on_sync_prop
AuctionMySellWnd.fresh_money=fresh_money
AuctionMySellWnd.flash_auction_things=flash_auction_things
AuctionMySellWnd.format_time=format_time
AuctionMySellWnd.cancel_sell = cancel_sell


