-----------------------------------------
--名    称:	仙城守将
--版    权:	(C)盛游
--创 建 人:	Xiao Lizhi
--创建日期:	2013-12-4
-----------------------------------------

-----------------------------------------公共数据-----------------------------------------
local CD_Rank_Wnd_ID 	= 1077
local CD_Launch_Wnd_ID 	= 1078
local CD_Activity_Wnd_ID= 1079
local CD_Tip_Wnd_ID		= 1076
local CD_Title_Wnd_ID	= 1075

-----------------------------------------排行窗口-----------------------------------------
local CDRank = {}
--初始化常量数据
CDRank.main_wnd_id 		= CD_Rank_Wnd_ID
CDRank.module_name		= "CityDefender"
CDRank.occup_names		=
{
	[enActorOccupation_Paladin]				= "魔羽",
    [enActorOccupation_SwordKnightErrant] 	= "神剑",
	[enActorOccupation_Assassin] 			= "鬼影",
    [enActorOccupation_Tao]					= "仙乐",
}

--初始化数据
CDRank.wndsys  			= nil
CDRank.desktop			= nil

CDRank.main_wnd 	 	= nil
CDRank.flip_page 	 	= nil

CDRank.lbl_total_score 	= nil
CDRank.pgb_total_score 	= nil

CDRank.panel_score 		= nil
CDRank.list_score_rank 	= nil
CDRank.label_my_score 	= nil
CDRank.label_my_money 	= nil

CDRank.panel_defender	= nil
CDRank.list_cnt_rank	= nil
CDRank.label_my_cnt		= nil

CDRank.fun_occup_name		= nil
CDRank.fun_on_net_msg		= nil
CDRank.fun_do_init			= nil
CDRank.fun_on_switch_panel	= nil
CDRank.fun_switch_panel		= nil
CDRank.fun_on_main_show		= nil
CDRank.fun_on_score_show	= nil
CDRank.fun_on_defender_show	= nil
CDRank.fun_on_net_score		= nil
CDRank.fun_on_net_defender	= nil
CDRank.fun_on_net_launch	= nil
CDRank.fun_on_net_info		= nil
CDRank.fun_on_net_title_list= nil
CDRank.fun_on_net_get_title = nil
CDRank.fun_on_reset			= nil

--工具函数
function CDRank.fun_occup_name(occ)
	return CDRank.occup_names[occ] or ""
end

--网络消息路由
function CDRank.fun_on_net_msg(msg)
	if (msg.msg_code=="score_list") then
		CDRank.fun_on_net_score(msg)
	elseif (msg.msg_code=="defender_list") then
		CDRank.fun_on_net_defender(msg)
	elseif (msg.msg_code=="launch") then
		CDRank.fun_on_net_launch(msg)
	elseif (msg.msg_code=="defender_info") then
		CDRank.fun_on_net_info(msg)
	elseif (msg.msg_code=="title_list") then
		CDRank.fun_on_net_title_list(msg)
	elseif (msg.msg_code=="get_title") then
		CDRank.fun_on_net_get_title(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

--本地逻辑实现
function CDRank.fun_do_init()
	--注册网络消息
	api_reg_module_msg_handler(CDRank.module_name, CDRank.fun_on_net_msg)

	--获取一些窗口引用
	CDRank.wndsys  = WndSystem:GetInstance()
	CDRank.desktop = XDesktop:GetInstance()
	
	--创建窗口
	CDRank.main_wnd = CDRank.desktop:FindWindowByID(CDRank.main_wnd_id) or core.createWindow('Data/Scp/Windows/Windows_CityDefender.scp', CDRank.main_wnd_id)

	--执行窗口初始化
	--关闭按钮
	local btn_close 	 	= CDRank.main_wnd:GetButton("btn_close")
	--切换页
	CDRank.flip_page		= CDRank.main_wnd:GetFlipPage("flip")
	--总分标题
	CDRank.lbl_total_score 	= CDRank.main_wnd:GetLabel("total_score_title")
	--总分进度条
	CDRank.pgb_total_score 	= CDRank.main_wnd:GetProgressBar("total_score_progress")
	--积分面板
	CDRank.panel_score 		= CDRank.main_wnd:getWindow("score_rank_panel")	
	CDRank.list_score_rank 	= CDRank.panel_score:GetListBox("listbox")
	CDRank.label_my_score 	= CDRank.panel_score:GetLabel("self_score_value")
	CDRank.label_my_money 	= CDRank.panel_score:GetMoneyLabel("self_money_value")
	--守将面板
	CDRank.panel_defender	= CDRank.main_wnd:getWindow("defener_rank_panel")
	CDRank.list_cnt_rank	= CDRank.panel_defender:GetListBox("listbox")
	CDRank.label_my_cnt		= CDRank.panel_defender:GetLabel("self_cnt_value")
	
	--主窗口
	CDRank.main_wnd:SetShowEventHandler2(CDRank.fun_on_main_show)
	
	--关闭按钮
	btn_close:SetClickEventHandler2(function()
		CDRank.main_wnd:SetVisible(false)
	end)

	--切换标签
	for i = 1, CDRank.flip_page:GetPageNum() do 
		local page_btn = CDRank.flip_page:GetPageBtnx(i-1)
		page_btn:SetClickEventHandler("CDRank_fun_on_switch_panel")
	end
	
	--初始化进度条
	CDRank.pgb_total_score:SetRange(0, 0)
	CDRank.pgb_total_score:SetPos(0)
	
	--积分面板
	CDRank.panel_score:SetShowEventHandler2(CDRank.fun_on_score_show)
	CDRank.label_my_score:setText("0")
	CDRank.label_my_money:SetMoney(0)

	--守将面板
	CDRank.panel_defender:SetShowEventHandler2(CDRank.fun_on_defender_show)
	CDRank.label_my_cnt:setText("0")

	--积分排行列表
	CDRank.list_score_rank:SetColCount(5);
	CDRank.list_score_rank:SetColFormat(0,120);
	CDRank.list_score_rank:SetColAlign(0, 1);
	CDRank.list_score_rank:SetColFormat(1,225);
	CDRank.list_score_rank:SetColAlign(1, 1);
	CDRank.list_score_rank:SetColFormat(2,136);
	CDRank.list_score_rank:SetColAlign(2, 1);
	CDRank.list_score_rank:SetColFormat(3,130);
	CDRank.list_score_rank:SetColAlign(3, 1);
	CDRank.list_score_rank:SetColFormat(4,130);
	CDRank.list_score_rank:SetColAlign(4, 1);
	CDRank.list_score_rank:SetLineHeight(28)
	
	--守将排行列表
	CDRank.list_cnt_rank:SetColCount(4);
	CDRank.list_cnt_rank:SetColFormat(0,120);
	CDRank.list_cnt_rank:SetColAlign(0, 1);
	CDRank.list_cnt_rank:SetColFormat(1,225);
	CDRank.list_cnt_rank:SetColAlign(1, 1);
	CDRank.list_cnt_rank:SetColFormat(2,185);
	CDRank.list_cnt_rank:SetColAlign(2, 1);
	CDRank.list_cnt_rank:SetColFormat(3,215);
	CDRank.list_cnt_rank:SetColAlign(3, 1);
	CDRank.list_cnt_rank:SetLineHeight(28)
	
	CDRank.main_wnd:SetVisible(false)
end

function CDRank.fun_on_main_show()
	--切换到第一个标签
	CDRank.fun_switch_panel(1)
end

function CDRank.fun_on_score_show()
	--请求积分表
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "score_list"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDRank.fun_on_defender_show()
	--请求守将表
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "defender_list"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDRank_fun_on_switch_panel(wnd)
	local page = wnd:GetTag1()
	CDRank.fun_switch_panel(page)
end

function CDRank.fun_switch_panel(page)
	CDRank.flip_page:TurnPage(page-1)
	if page == 2 then
		CDRank.panel_score:SetVisible(false)
		CDRank.panel_defender:SetVisible(true)
		CDRank.lbl_total_score:SetVisible(false)
		CDRank.pgb_total_score:SetVisible(false)
	else
		CDRank.panel_score:SetVisible(true)
		CDRank.panel_defender:SetVisible(false)
		CDRank.lbl_total_score:SetVisible(true)
		CDRank.pgb_total_score:SetVisible(true)
	end
end

function CDRank.fun_on_reset()
	CDRank.pgb_total_score:SetRange(0, 0)
	CDRank.pgb_total_score:SetPos(0)
	CDRank.label_my_score:setText("0")
	CDRank.label_my_money:SetMoney(0)
	CDRank.label_my_cnt:setText("0")
	CDRank.list_score_rank:RemoveAll()
	CDRank.list_cnt_rank:RemoveAll()
end

function CDRank.fun_on_net_score(msg)
	CDRank.list_score_rank:RemoveAll()
	if not msg.attacker_list then		
		return
	end
	for i = 1, 10 do
		if i > #msg.attacker_list then
			break
		end
		local o = msg.attacker_list[i]
		local n = CDRank.list_score_rank:AddItem(tostring(i))
		CDRank.list_score_rank:SetItem(n, 1, o.actorname)
		CDRank.list_score_rank:SetItem(n, 2, CDRank.fun_occup_name(o.occupation))
		CDRank.list_score_rank:SetItem(n, 3, tostring(o.score))
		CDRank.list_score_rank:SetItem(n, 4, "", o.money, enMoneyType_Voucher)
	end
	CDRank.pgb_total_score:SetRange(0, msg.max_score)
	CDRank.pgb_total_score:SetPos(msg.cur_score)
	CDRank.label_my_score:setText(tostring(msg.my_score or 0))
	CDRank.label_my_money:SetMoney(msg.my_money)
end

function CDRank.fun_on_net_defender(msg)
	CDRank.list_cnt_rank:RemoveAll()
	if not msg.no_1_list then
		return
	end
	for i = 1, 10 do
		if i > #msg.no_1_list then
			break
		end
		local o = msg.no_1_list[i]
		local n = CDRank.list_cnt_rank:AddItem(tostring(i))
		CDRank.list_cnt_rank:SetItem(n, 1, o.actorname)
		CDRank.list_cnt_rank:SetItem(n, 2, CDRank.fun_occup_name(o.occupation))
		CDRank.list_cnt_rank:SetItem(n, 3, tostring(o.cnt))
	end
	CDRank.label_my_cnt:setText(msg.my_cnt)
end

function CDRank.fun_on_net_launch(msg)
	if msg.show then
		CDRank.wndsys:ShowWnd(CD_Launch_Wnd_ID, 1)
	else
		CDRank.wndsys:ShowWnd(CD_Launch_Wnd_ID, 0)
	end
end

function CDRank.fun_on_net_info(msg)
	CDActivity_on_net_info(msg)
end

function CDRank.fun_on_net_title_list(msg)
	CDRankTitle_on_net_cfg(msg)
end

function CDRank.fun_on_net_get_title(msg)
	CDRankTitle_on_net_get(msg)
end

--调用初始化逻辑
CDRank.fun_do_init()
-----------------------------------------排行窗口-----------------------------------------

-----------------------------------------排行开启图标-----------------------------------------
local CDRankLaunch = {}
--初始化常量数据
CDRankLaunch.main_wnd_id= CD_Launch_Wnd_ID

--初始化数据
CDRankLaunch.wndsys  	= nil
CDRankLaunch.desktop	= nil

CDRankLaunch.main_wnd 	= nil
CDRankLaunch.btn_rank 	= nil

CDRankLaunch.fun_do_init		= nil
CDRankLaunch.fun_adjwinpos		= nil

--本地逻辑实现
function CDRankLaunch.fun_do_init()
	--获取一些窗口引用
	CDRankLaunch.wndsys  = WndSystem:GetInstance()
	CDRankLaunch.desktop = XDesktop:GetInstance()
	
	--创建窗口
	CDRankLaunch.main_wnd = CDRankLaunch.desktop:FindWindowByID(CDRankLaunch.main_wnd_id) or core.createWindow('Data/Scp/Windows/Windows_CityDefender.scp', CDRankLaunch.main_wnd_id)

	--执行窗口初始化
	--主窗口
	--切图不隐藏
	CDRankLaunch.main_wnd:SetWndTraits(0x1000, true)
	CDRankLaunch.main_wnd:SetShowEventHandler2(function()
		CDRankLaunch.fun_adjwinpos()
	end)
	
	--屏幕变化
	CDRankLaunch.main_wnd:SetClientRectChangedCallback("CDRankLaunch_on_screen_change")
	
	--排行启动按钮
	local btn_rank = CDRankLaunch.main_wnd:GetButton("btn_rank")
	--排行启动按钮
	btn_rank:SetClickEventHandler2(function()
		CDRankLaunch.wndsys:ToggleWnd(CD_Rank_Wnd_ID)
	end)
	
	CDRankLaunch.main_wnd:SetVisible(false)
end

function CDRankLaunch_on_screen_change()
	CDRankLaunch.fun_adjwinpos()
end

function CDRankLaunch.fun_adjwinpos()
	local xoff = 211
	local yoff = 80
	XWinUtil:AlignWindow(CDRankLaunch.desktop, CDRankLaunch.main_wnd, XWinUtil.enXUAlign_LEFT_LEFT, XWinUtil.enXUAlign_TOP_TOP, xoff, 0, yoff, 0, false)
end

--初始化
CDRankLaunch.fun_do_init()
-----------------------------------------排行开启图标-----------------------------------------

-----------------------------------------活动展示界面-----------------------------------------
local CDActivity = {}
--初始化常量数据
CDActivity.main_wnd_id	= CD_Activity_Wnd_ID
CDActivity.bg_have_actor= "Clan/bk.png"
CDActivity.bg_no_actor	= "text1/xuwei.png"

--初始化数据
CDActivity.wndsys  	= nil
CDActivity.desktop	= nil

CDActivity.main_wnd			= nil
CDActivity.lbl_actorname_1	= nil
CDActivity.cp_preview_1		= nil
CDActivity.btn_sel_1		= nil
CDActivity.lbl_actorname_2	= nil
CDActivity.cp_preview_2		= nil
CDActivity.btn_sel_2		= nil
CDActivity.lbl_actorname_3	= nil
CDActivity.cp_preview_3		= nil
CDActivity.btn_sel_3		= nil
CDActivity.lbl_countdown	= nil

CDActivity.fun_do_init 	= nil
CDActivity.fun_on_show 	= nil
CDActivity.fun_do_clear = nil
CDActivity.fun_on_select= nil
CDActivity.fun_go_act	= nil
CDActivity.fun_on_reset	= nil

--本地逻辑实现
function CDActivity.fun_do_init()
	--获取一些窗口引用
	CDActivity.wndsys  = WndSystem:GetInstance()
	CDActivity.desktop = XDesktop:GetInstance()
	
	--创建窗口
	CDActivity.main_wnd = CDActivity.desktop:FindWindowByID(CDActivity.main_wnd_id) or core.createWindow('Data/Scp/Windows/Windows_CityDefender.scp', CDActivity.main_wnd_id)

	--执行窗口初始化
	--加入到PVP主窗口面板
	PvpActMainWndSubWnd(3, CDActivity.main_wnd)
	
	--取控件
	CDActivity.lbl_actorname_1	= CDActivity.main_wnd:GetLabel("label_name1")
	CDActivity.cp_preview_1		= CDActivity.main_wnd:GetCreaturePreviewCtrl("cp_actor1")
	CDActivity.btn_sel_1		= CDActivity.main_wnd:GetButton("btn_sel1")
	CDActivity.lbl_actorname_2	= CDActivity.main_wnd:GetLabel("label_name2")
	CDActivity.cp_preview_2		= CDActivity.main_wnd:GetCreaturePreviewCtrl("cp_actor2")
	CDActivity.btn_sel_2		= CDActivity.main_wnd:GetButton("btn_sel2")
	CDActivity.lbl_actorname_3	= CDActivity.main_wnd:GetLabel("label_name3")
	CDActivity.cp_preview_3		= CDActivity.main_wnd:GetCreaturePreviewCtrl("cp_actor3")
	CDActivity.btn_sel_3		= CDActivity.main_wnd:GetButton("btn_sel3")
	CDActivity.lbl_countdown	= CDActivity.main_wnd:GetLabel("label_countdown")
		
	--控件清理
	CDActivity.fun_do_clear()
	
	--选择按钮事件
	CDActivity.btn_sel_1:SetClickEventHandler2(CDActivity.fun_on_select)
	CDActivity.btn_sel_2:SetClickEventHandler2(CDActivity.fun_on_select)
	CDActivity.btn_sel_3:SetClickEventHandler2(CDActivity.fun_on_select)
	
	--窗口显示事件
	CDActivity.main_wnd:SetShowEventHandler2(CDActivity.fun_on_show)
	
	--排行启动按钮
	local btn_rank = CDActivity.main_wnd:GetButton("btn_rank")
	btn_rank:SetClickEventHandler2(function()
		CDActivity.wndsys:ToggleWnd(CD_Rank_Wnd_ID)
	end)
	
	--前往按钮
	local btn_go = CDActivity.main_wnd:GetButton("btn_go")
	btn_go:SetClickEventHandler2(function()
		CDActivity.fun_go_act()
	end)
	
	--规则说明
	local btn_rule = CDActivity.main_wnd:GetButton("btn_rule")
	btn_rule:SetClickEventHandler2(function()
		CDRankTip_ShowTip(1)
	end)
	
	--称号说明
	local btn_title = CDActivity.main_wnd:GetButton("btn_title")
	btn_title:SetClickEventHandler2(function()
		CDActivity.wndsys:ToggleWnd(CD_Title_Wnd_ID)
	end)
	
	--隐藏窗口
	CDActivity.main_wnd:SetVisible(false)
end

function CDActivity.fun_on_show()
	--请求守将活动信息
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "defender_info"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDActivity.fun_do_clear()
	CDActivity.lbl_actorname_1:setText("")
	CDActivity.btn_sel_1:SetBitmap(CDActivity.bg_no_actor)
	CDActivity.btn_sel_1:SetTag1(0)
	CDActivity.cp_preview_1:SetActorID(0)
	
	CDActivity.lbl_actorname_2:setText("")
	CDActivity.btn_sel_2:SetBitmap(CDActivity.bg_no_actor)
	CDActivity.btn_sel_2:SetTag1(0)
	CDActivity.cp_preview_2:SetActorID(0)
	
	CDActivity.lbl_actorname_3:setText("")
	CDActivity.btn_sel_3:SetBitmap(CDActivity.bg_no_actor)
	CDActivity.btn_sel_3:SetTag1(0)
	CDActivity.cp_preview_3:SetActorID(0)
	
	CDActivity.lbl_countdown:setText("")
end

function CDActivity.fun_on_select(wnd)
	local btn = XButton:CastToButton(wnd)
	if not btn then
		API_TraceError("wnd cast to btn fail")
		return
	end

	local actorid = btn:GetTag1()
	if actorid ~= 0 then
		--弹出poplist
		local pt = XDesktop:GetInstance():GetMouseXY()
		pt.x = pt.x + 15
		g_pGlobal:GetMainUI():ShowCreaturePopMenu(actorid, pt)
	end
end

function CDActivity.fun_go_act(wnd)
	--前往活动点
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "go_act"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDActivity_on_net_info(msg)
	--先清理
	CDActivity.fun_do_clear()

	if not msg.attacker_list then
		return
	end	
	
	for i = 1, math.min(3, #msg.attacker_list) do
		local o = msg.attacker_list[i]
		CDActivity["lbl_actorname_" .. i]:setText(o.actorname)
		CDActivity["cp_preview_" .. i]:SetActorID(o.actorid)
		CDActivity["btn_sel_" .. i]:SetBitmap(CDActivity.bg_have_actor)	
		CDActivity["btn_sel_" .. i]:SetTag1(o.actorid)
	end

	local str = ""
	
	local cur_time = XDate:GetInstance():GetCurrentVTime()
	if cur_time >= msg.start_time and cur_time < msg.end_time then
		str = "活动进行中"
	else
		local left_min = math.floor(math.max(0, msg.start_time - cur_time) / 60)
		str = format_time_dd_hh_mm(left_min)
	end

	CDActivity.lbl_countdown:setText(str)
end

function CDActivity.fun_on_reset()
	CDActivity.fun_do_clear()
end

--初始化
CDActivity.fun_do_init()
-----------------------------------------活动展示界面-----------------------------------------


-----------------------------------------说明窗口-----------------------------------------
local CDRankTip = {}
--初始化常量数据
CDRankTip.main_wnd_id= CD_Tip_Wnd_ID
CDRankTip.tip_data   =
{
	[1] = "1、22:30,22:33,22:36,22:39，在开封城刷4次怪物，每次刷出80只。#(br,1)2、在规定的时间内没有杀死，怪物也会刷新（击杀怪物，掉落白色、绿色的酒、除魔令）。#(br,1)3、在规定的时间内杀死了怪物，最终BOSS的攻击力下降10%，每一波都会叠加。#(br,1)4、最后一波怪物打死，22:42，在开封一个固定点 79,63 刷新一只BOSS,boss血量无限。#(br,1)5、击杀BOSS的时间13分钟，每击杀1000滴血获得1点积分。积分越多奖励越丰厚。收集满总积分，怪物还会大爆。#(br,1)6、积分排名前三，将会在开封城中树立雕像，受万民敬仰。",
}

--初始化数据
CDRankTip.wndsys  	= nil
CDRankTip.desktop	= nil

CDRankTip.main_wnd 	= nil
CDRankTip.html_tip 	= nil

CDRankTip.fun_do_init		= nil

--本地逻辑实现
function CDRankTip.fun_do_init()
	--获取一些窗口引用
	CDRankTip.wndsys  = WndSystem:GetInstance()
	CDRankTip.desktop = XDesktop:GetInstance()
	
	--创建窗口
	CDRankTip.main_wnd = CDRankTip.desktop:FindWindowByID(CDRankTip.main_wnd_id) or core.createWindow('Data/Scp/Windows/Windows_CityDefender.scp', CDRankTip.main_wnd_id)

	--执行窗口初始化
	CDRankTip.html_tip = CDRankTip.main_wnd:GetHtml("tip1")
	--关闭按钮
	local btn_close	= CDRankTip.main_wnd:GetButton("btn_close")	
	btn_close:SetClickEventHandler2(function()
		CDRankTip.main_wnd:SetVisible(false)
	end)
	
	CDRankTip.main_wnd:SetVisible(false)
end

function CDRankTip_ShowTip(tipid)
	local tip = CDRankTip.tip_data[tipid]
	if not tip then
		tip = ""
	end
	CDRankTip.html_tip:Clear()
	CDRankTip.html_tip:ParseContext(tip)

	CDRankTip.main_wnd:SetVisible(true)
end

--初始化
CDRankTip.fun_do_init()
-----------------------------------------说明窗口-----------------------------------------

-----------------------------------------称号窗口-----------------------------------------
local CDRankTitle = {}
--初始化常量数据
CDRankTitle.main_wnd_id= CD_Title_Wnd_ID

--初始化数据
CDRankTitle.wndsys  	= nil
CDRankTitle.desktop		= nil

CDRankTitle.main_wnd 	= nil
CDRankTitle.panel_infos = nil

CDRankTitle.title_list	= nil
CDRankTitle.my_no1_cnt	= 0
CDRankTitle.exist_title	= 0

CDRankTitle.fun_do_init	= nil
CDRankTitle.fun_on_show = nil
CDRankTitle.fun_get_it	= nil
CDRankTitle.fun_refresh	= nil
CDRankTitle.fun_on_reset= nil

--本地逻辑实现
function CDRankTitle.fun_do_init()
	--获取一些窗口引用
	CDRankTitle.wndsys  = WndSystem:GetInstance()
	CDRankTitle.desktop = XDesktop:GetInstance()
	
	--创建窗口
	CDRankTitle.main_wnd = CDRankTitle.desktop:FindWindowByID(CDRankTitle.main_wnd_id) or core.createWindow('Data/Scp/Windows/Windows_CityDefender.scp', CDRankTitle.main_wnd_id)

	--执行窗口初始化
	--主窗口
	CDRankTitle.main_wnd:SetShowEventHandler2(CDRankTitle.fun_on_show)
	
	local scrollmgr = CDRankTitle.main_wnd:GetScrollMgr("scrollmgr")
	local panelmgr = scrollmgr:GetPanelMgr("panelmgr")
	
	--取面板控件
	CDRankTitle.panel_infos = {}
	for i=1,panelmgr:GetPanelCount() do
		local panel_info = {}
		CDRankTitle.panel_infos[#CDRankTitle.panel_infos + 1] = panel_info
		
		panel_info.panel 	= panelmgr:GetPanelWnd(i-1)
		panel_info.titlepic = panel_info.panel:GetStaticBitmap("titlepic")
		panel_info.condition= panel_info.panel:GetHtml("condition")
		panel_info.getit	= panel_info.panel:GetButton("getit")
		
		panel_info.panel:SetVisible(false)
		panel_info.getit:SetClickEventHandler2(CDRankTitle.fun_get_it)
	end

	--关闭按钮
	local btn_close	= CDRankTitle.main_wnd:GetButton("btn_close")	
	btn_close:SetClickEventHandler2(function()
		CDRankTitle.main_wnd:SetVisible(false)
	end)
	
	CDRankTitle.main_wnd:SetVisible(false)
end

function CDRankTitle.fun_on_show()
	--获取称号配置
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "title_list"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDRankTitle.fun_get_it()
	--领取称号
	local msg = {}
	msg.module   = CDRank.module_name
	msg.msg_code = "get_title"
	local jsonstr = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(jsonstr)
end

function CDRankTitle.fun_refresh()
	--全部隐藏
	for i = 1, #CDRankTitle.panel_infos do
		local item = CDRankTitle.panel_infos[i]
		item.panel:SetVisible(false)
	end
	if nil == CDRankTitle.title_list then
		return
	end
	for i = 1, math.min(#CDRankTitle.title_list, #CDRankTitle.panel_infos) do
		local title_cfg  = CDRankTitle.title_list[i]
		local panel_info = CDRankTitle.panel_infos[i]
		
		panel_info.panel:SetVisible(true)
		
		--称号图片,这里需要缩放下
		local bmp = g_pGlobal:GetResourceMgr():RequestIcon2(title_cfg.title_icon)
		if bmp ~= nil then
			local cxt = XDrawCxt:new()
			cxt.scalex = 120 / bmp:GetWidth()
			cxt.scaley = cxt.scalex
			panel_info.titlepic:SetBitmapIcon(title_cfg.title_icon, cxt)
			local rectParent = panel_info.panel:GetWindowXRect()
			local rectSelf   = panel_info.titlepic:GetWindowXRect()
			panel_info.titlepic:MoveWindowTo(rectSelf.left, rectParent.top + ((rectParent.bottom - rectParent.top) - (rectSelf.bottom - rectSelf.top)) / 2)
		else
			panel_info.titlepic:SetBitmap("")
		end

		panel_info.condition:Clear()
		panel_info.condition:ParseContext(string.format("获取第一名%d次", title_cfg.no_1_count))
		local can_get = false
		if CDRankTitle.my_no1_cnt >= title_cfg.no_1_count then
			--最后一条，或后一条条件没达到
			if i >= #CDRankTitle.title_list or CDRankTitle.my_no1_cnt < CDRankTitle.title_list[i + 1].no_1_count then
				can_get = true
			end
		end		
		local got_it = CDRankTitle.exist_title == title_cfg.title_id
		--可以领取，并未领取才开启按钮
		if can_get and not got_it then
			panel_info.getit:SetEnabled(true)
		else
			panel_info.getit:SetEnabled(false)			
		end		
		if got_it then
			--这时可能按钮是禁用，也可能未禁用
			panel_info.getit:setText("已领取")
		else
			panel_info.getit:setText("领取")			
		end
	end
end

function CDRankTitle_on_net_cfg(msg)
	CDRankTitle.title_list  = msg.title_list
	CDRankTitle.my_no1_cnt	= msg.my_no1_cnt
	CDRankTitle.exist_title	= msg.exist_title
	CDRankTitle.fun_refresh()
end

function CDRankTitle_on_net_get(msg)
	CDRankTitle.exist_title	= msg.exist_title
	CDRankTitle.fun_refresh()
end

function CDRankTitle.fun_on_reset()
	for i = 1, #CDRankTitle.panel_infos do
		local item = CDRankTitle.panel_infos[i]
		item.panel:SetVisible(false)
	end
end

--初始化
CDRankTitle.fun_do_init()
-----------------------------------------称号窗口-----------------------------------------

--外部调用，进度游戏态时先重置数据
function api_reset_citydefender()
	CDRank.fun_on_reset()
	CDActivity.fun_on_reset()
	CDRankTitle.fun_on_reset()
end