--消息回调函数
local m_clan = {}

--变量
local listboxMemberList
local listboxApplyList
local btnViewInfo
local btnKick
local btnWithdraw
local btnAppoint
local xPopupList
local checkboxAutoJoin
local btnPageLeft
local btnPageRight

local listMemberDataCache = {}
local listApplyDataCache = {}
local listMemberCurrentPage = 1
local listApplyCurrentPage = 1

local clanMember_wnd
local heroAppoint
--成员actorID列表
local memberActorIDList = {}
local clanBasicInfo 	= {}
--所有公会的基本信息列表
local allClanBasicInfo 	= {}

-------------------------------
--充当常量
local occupationKeyValue = {
						[3] = "魔羽",
						[4] = "神剑",
						[5] = "鬼影",
						[6] = "仙乐",
							}
local relationWndID = 360
local WW_ADD_SUB_PANEL	= 36001 --注册子窗口的消息ID
local WND_CLAN_MEMBER_MAIN = 1040

--------------------------------
--网络消息处理
function clan_msg_handler(msg)
	--API_Trace(cjson.encode(msg))
	if msg.msg_code == "clanMemberData" then
		m_clan.updateMemberList(msg)
	elseif msg.msg_code == "clanApplyData" then
		m_clan.updateApplyList(msg)
	elseif msg.msg_code == "clanListData" then
		updateClanList(msg)
	elseif msg.msg_code == "setClanID" then
		CreateClanByClanID(msg)
	elseif msg.msg_code == "updateClanListUI" then
		updateClanListUI()
	elseif msg.msg_code == "updateClanMemberListUI" then		
		updateClanMemberListUI()
	elseif msg.msg_code == "updateClanApplyListUI" then
		updateClanApplyListUI()
	elseif msg.msg_code == "createClanSuccess" then
		createClanSuccess(msg)
	elseif msg.msg_code == "closeClanMemberWnd" then
		--关闭社交界面的窗口
		--local pWndRelation = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(360)
		--pWndRelation:SetVisible(false)
		OnCloseClanList(msg)
	elseif msg.msg_code == "heroAppoint" then
		m_clan.updateHeroAppoint(msg)
	elseif msg.msg_code == "updateClanMemberActorIDList" then
		m_clan.updateClanMemberActorIDList(msg)
	elseif msg.msg_code == "updateAutoJoinCheckbox" then
		m_clan.updateAutoJoinCheckbox(msg)
	elseif msg.msg_code == "updateClanBasicInfo" then
		m_clan.updateClanBasicInfo(msg)
	elseif msg.msg_code == "updateAllClanBasicInfo" then
		m_clan.updateAllClanBasicInfo(msg)
	end
end
--窗口模块初始化
function clanMember_init()
	--注册消息
	api_reg_module_msg_handler("CLAN_MODULE",clan_msg_handler)

	--创建及初始化窗口
	local pWndRelation = WndSystem:GetInstance():GetGameDesktop():FindWindowByID(relationWndID)
	clanMember_wnd = core.createWindow('Data/Scp/Windows/Windows_ClanMember.scp', WND_CLAN_MEMBER_MAIN,false)
	WndSystem:GetInstance():OnEvent(relationWndID, WW_ADD_SUB_PANEL,0, WND_CLAN_MEMBER_MAIN)
	--成员列表
	clanMember_wnd:SetLuaEvent(XWIN_EVENT_SHOW, 'clanMemberOnshow')
	listboxMemberList = clanMember_wnd:GetListBox("clan_member_list")
	listboxMemberList:SetColCount(7);
	listboxMemberList:SetColFormat(0,124);
	listboxMemberList:SetColAlign(0, 1);
	listboxMemberList:SetColFormat(1,70);
	listboxMemberList:SetColAlign(1, 1);
	listboxMemberList:SetColFormat(2,60);
	listboxMemberList:SetColAlign(2, 1);
	listboxMemberList:SetColFormat(3,68);
	listboxMemberList:SetColAlign(3, 1);
	listboxMemberList:SetColFormat(4,139);
	listboxMemberList:SetColAlign(4, 1);
	listboxMemberList:SetColFormat(5,115);
	listboxMemberList:SetColAlign(5, 1);
	listboxMemberList:SetColFormat(6,109);
	listboxMemberList:SetColAlign(6, 1);
	listboxMemberList:SetLineHeight(32);
	listboxMemberList:SetSelEventHandler2(OnSelListboxMember);
	listboxMemberList:SetLuaEvent(XWIN_EVENT_CLICK, "OnMemberPopList")
	--listboxMemberList:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "OnMouseDownListbox")
	--listboxMemberList:SetLuaEvent(XWIN_EVENT_MOUSEUP, "OnMouseUpListbox")
	--页码
	lebalMemberlistPage = clanMember_wnd:GetLabel("clan_memberlist_page")
	--申请列表
	listboxApplyList = clanMember_wnd:GetListBox("clan_apply_list")
	listboxApplyList:SetColCount(4);
	listboxApplyList:SetColFormat(0,124);
	listboxApplyList:SetColAlign(0, 1);
	listboxApplyList:SetColFormat(1,85);
	listboxApplyList:SetColAlign(1, 1);
	listboxApplyList:SetColFormat(2,72);
	listboxApplyList:SetColAlign(2, 1);
	listboxApplyList:SetColFormat(3,72);
	listboxApplyList:SetColAlign(3, 1);
	--listboxApplyList:SetLuaEvent(XWIN_EVENT_CLICK, "OnApplyPopList")
	--listboxApplyList:SetLuaEvent(XWIN_EVENT_MOUSEMOVE, "OnMouseMoveListbox")
	listboxApplyList:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "OnMouseDownListbox")
	listboxApplyList:SetLuaEvent(XWIN_EVENT_MOUSEUP, "OnMouseUpListbox")
	--页码
	labelApplylistPage = clanMember_wnd:GetLabel("clan_applylist_page")
	--查看详情按钮
	btnViewInfo = clanMember_wnd:GetButton("clan_btn_viewinfo")
	btnViewInfo:SetLuaEvent(XWIN_EVENT_CLICK, 'OnViewInfo')
	--踢出公会按钮
	btnKick = clanMember_wnd:GetButton("clan_btn_kick")
	btnKick:SetLuaEvent(XWIN_EVENT_CLICK, 'OnKickMess')
	--职位任免按钮
	btnAppoint = clanMember_wnd:GetButton("clan_btn_appoint")
	btnAppoint:SetLuaEvent(XWIN_EVENT_CLICK, 'OnAppointPopList')
	--退出公会按钮
	btnWithdraw = clanMember_wnd:GetButton("clan_btn_withdraw")
	btnWithdraw:SetLuaEvent(XWIN_EVENT_CLICK, 'OnWithdrawMess')

	--设置自动允许玩家加入公会
	checkboxAutoJoin = clanMember_wnd:GetCheckBox("clan_btn_autojoin")
	checkboxAutoJoin:SetLuaEvent(XWIN_EVENT_CHECK_CHANGE,"OnCheckAutoJoin")

	--左边翻页
	btnPageLeft 	= clanMember_wnd:GetButton("clan_page_left")
	btnPageLeft:SetLuaEvent2(XWIN_EVENT_CLICK, function()
		clanmemberListPage(-1)
	end)
	--右边翻页
	btnPageRight 	= clanMember_wnd:GetButton("clan_page_right")
	btnPageRight:SetLuaEvent2(XWIN_EVENT_CLICK, function()
		clanmemberListPage(1)
	end)

	--API_Trace("clanmember wnd init ok")
	clanMember_wnd:SetVisible(false)

end

--窗口显示 初始化数据
function clanMemberOnshow(wnd, event)
	--请求公会会员列表页面
	updateClanMemberListUI()
	updateClanApplyListUI()
	--更新下玩家职位 和跟职位相关的按钮状态
	getHeroAppoint()
	--更新下所有成员的actorID List
	sendMessGetMemberActorIDList()
	--刷新公会基本信息
	GetClanBasicInfo()
end

--获取成员的信息
local function GetClanMemberInfo(actorID)
	if actorID == nil then  return {} end
	for k, v in pairs(listMemberDataCache) do
		if v.actorID == actorID then
			return v
		end
	end
	return {}
end

--获取申请玩家的信息
local function GetClanApplyInfo(actorID)
	if actorID == nil then return {} end
	for k, v in pairs(listApplyDataCache) do
		if v.actorID == actorID then
			return v
		end
	end
	return {}
end

--成员列表选择 回调函数
function OnSelListboxMember(wnd, event)
	local hero 			= core.getHero()
	if hero == nil then return end

	local sel 			= listboxMemberList:GetCurSel()
	local selActorID 	= listboxMemberList:GetItemData(sel)
	local selActorInfo 	= GetClanMemberInfo(selActorID)

	if hero:GetActorDBID() == selActorID then
		btnViewInfo:SetEnabled(false)
	else
		btnViewInfo:SetEnabled(true)
	end
end

----------------------------------------------
--鼠标操作

--鼠标按下的坐标
local xPointPre = XPoint:new()
--鼠标按下操作
function OnMouseDownListbox(wnd, event)
	xPointPre = XDesktop:GetInstance():GetMouseXY()
end
--鼠标弹起事件
function OnMouseUpListbox(wnd, event)

	local xPointNow = XDesktop:GetInstance():GetMouseXY()
	
	if xPointNow.x - xPointPre.x > 100 then
		if wnd == listboxMemberList then
			--clanmemberListPage(-1)
		elseif wnd == listboxApplyList then
			clanApplyListPage(-1)
		end
	elseif  xPointNow.x - xPointPre.x < -100 then
		if wnd == listboxMemberList then
			--clanmemberListPage(1)
		elseif wnd == listboxApplyList then
			clanApplyListPage(1)
		end		
	elseif xPointNow.x - xPointPre.x >= -5 and xPointNow.x - xPointPre.x <= 5 then
		if wnd == listboxApplyList then
			--申请列表弹出菜单
			OnApplyPopList(wnd, event)
		elseif wnd == listboxMemberList then
			--OnMemberPopList(wnd, event)
		end

	end
end

--鼠标点击申请列表的某一项

----------------------------------------------

--memberlist翻页
function clanmemberListPage(page)
	local hero = core.getHero()
	if hero == nil then return end
	local clanID 	= hero:GetCrtProp(enProp_ClanID)

	--请求会员列表页面
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'getClanMemberData'
	msg.page		= listMemberCurrentPage + page
	msg.clanID 		= clanID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)

end
--applaylist翻页
function clanApplyListPage(page)
	local hero = core.getHero()
	if hero == nil then return end
	local clanID 	= hero:GetCrtProp(enProp_ClanID)

	--请求申请入会会员列表页面
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='getClanApplyData'
	msg.page		= listApplyCurrentPage + page
	msg.clanID 		= clanID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end



--刷新成员列表
local function updateMemberList(msg)
	local list = msg.list
	listMemberDataCache = list
	listboxMemberList:RemoveAll()
	lebalMemberlistPage:setText("1/1")
	if list == nil or next(list) == nil then
		API_Trace("updateMemberList not data")
		return
	end
	listMemberCurrentPage = msg.page
	local pageCount = msg.pageCount
	lebalMemberlistPage:setText(listMemberCurrentPage.."/"..pageCount)
	local i = 0
	for k, v in pairs(list) do
		local nCol = 0;
		listboxMemberList:AddItem(0, tonumber(v.actorID))
		listboxMemberList:SetItem(i, nCol, v.actorName)--名称

		nCol = nCol + 1
		listboxMemberList:SetItem(i, nCol, v.appointName)--职务
		nCol = nCol + 1
		listboxMemberList:SetItem(i, nCol, occupationKeyValue[v.occupation])--职业	
		nCol = nCol + 1
		listboxMemberList:SetItem(i, nCol, v.level)	--等级
		nCol = nCol + 1
		v.activityValue = v.activityValue or 0
		listboxMemberList:SetItem(i, nCol, v.activityValue)--活跃值
		nCol = nCol + 1
		if v.isOnline == nil or v.isOnline == false then
			listboxMemberList:SetItem(i, nCol, os.date("%m/%d %H:%M",v.lastLevelTime))--离开时间
		else
			listboxMemberList:SetItem(i, nCol, "在线")--离开时间
		end
		nCol = nCol + 1
		listboxMemberList:SetItem(i, nCol, v.MapName)--所在区域
		i = i + 1
	end
	listboxMemberList:SetCurSel(0)
	--API_Trace("updateMemberList")
end

--刷新申请列表
local function updateApplyList( msg )
	local list = msg.list
	listApplyDataCache = list
	listboxApplyList:RemoveAll()
	labelApplylistPage:setText("1/1")
	if list == nil or next(list) == nil then
		return
	end
	listApplyCurrentPage = msg.page
	local pageCount = msg.pageCount
	labelApplylistPage:setText(listApplyCurrentPage.."/"..pageCount)
	local i = 0
	for k, v in pairs(list) do
		local nCol = 0;
		listboxApplyList:AddItem(0, tonumber(v.actorID))
		listboxApplyList:SetItem(i, nCol, v.actorName)--名称
		nCol = nCol + 1
		listboxApplyList:SetItem(i, nCol, v.actorID)
		nCol = nCol + 1
		listboxApplyList:SetItem(i, nCol, occupationKeyValue[v.occupation])--职业	
		nCol = nCol + 1
		listboxApplyList:SetItem(i, nCol, v.level)	--等级
		i = i + 1
	end
	listboxApplyList:SetCurSel(0)
end

---------------------------
--更新MemberList UI
--发送消息 请求服务器数据
function updateClanMemberListUI()
	local hero 	= core.getHero()
	if hero == nil then
		return
	end
	local actorID 	= hero:GetActorDBID()
	local clanID 	= hero:GetCrtProp(enProp_ClanID)
	if clanID == nil or clanID == 0 then
		return
	end

	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code 	= 'getClanMemberData'
	msg.page		= 1
	msg.clanID 		= clanID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)

end
----------------------------
--更新ApplyList UI
--发送更新消息 请求服务器数据
function updateClanApplyListUI()
	local hero 	= core.getHero()
	if hero == nil then
		return
	end
	local actorID 	= hero:GetActorDBID()
	local clanID 	= hero:GetCrtProp(enProp_ClanID)
	if clanID == nil or clanID == 0 then
		return
	end
	--请求申请入会会员列表页面
	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='getClanApplyData'
	msg.page		= 1
	msg.clanID 		= clanID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--查看信息
function OnViewInfo()
	local hero 			= core.getHero()
	local sel 			= listboxMemberList:GetCurSel()
	local selActorID 	= listboxMemberList:GetItemData(sel)
	if(hero:GetActorDBID() == selActorID) then
		g_pGlobal:GetMainUI():ShowMessageBox("无需从此处查看您的个人信息。","",0,0,"确定");
	else
		API_ViewActorInfo(selActorID);
	end
end

--踢出公会询问弹出框
function OnKickMess()
	local sel 			= listboxMemberList:GetCurSel()
	local selActorID 	= listboxMemberList:GetItemData(sel)
	local targetActorInfo = GetClanMemberInfo(selActorID)
	if targetActorInfo  == nil then
		return
	end
	--API_Trace(cjson.encode(targetActorInfo))
	local selActorName 	= targetActorInfo["actorName"]
	g_pGlobal:GetMainUI():ShowMessageBox("您确定移除["..selActorName.."]脱离公会？","OnKick",0,0,"确定","取消");
end
--踢出公会
function OnKick(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local hero 			= core.getHero()
	local sel 			= listboxMemberList:GetCurSel()
	local selActorID 	= listboxMemberList:GetItemData(sel)
	if(hero:GetActorDBID() == selActorID) then
		g_pGlobal:GetMainUI():ShowMessageBox("您不能在此踢自己出公会。","",0,0,"确定");
	else
		local msg 		= {}
		msg.module 		= "CLAN_MODULE"
		msg.msg_code	='kickActor'
		msg.actorID		= selActorID
		msg.clanID		= hero:GetCrtProp(enProp_ClanID)
		local str = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(str)

	end
end

--主动脱离公会询问弹出框
function OnWithdrawMess()
	g_pGlobal:GetMainUI():ShowMessageBox("您确定脱离公会？","OnWithdraw",0,0,"确定","取消");
end
--主动脱离公会
function OnWithdraw(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local hero = core.getHero()

	local msg 		= {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='withdrawFromClan'
	msg.clanID		= hero:GetCrtProp(enProp_ClanID)
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--职务任免
local function clanAppoint(appoint)
	local hero 	= core.getHero()
	if hero == nil then return end
	local sel 			= listboxMemberList:GetCurSel()
	local selActorID 	= listboxMemberList:GetItemData(sel)	

	local msg = {}
	if appoint == "chairman" then
		msg.appoint = appoint
	elseif appoint == "viceChairman" then
		msg.appoint = appoint
	elseif appoint == "member" then
		msg.appoint = appoint
	else
		return
	end
	msg.actorID 	= selActorID
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	= "appoint"
	msg.clanID		= hero:GetCrtProp(enProp_ClanID)
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
--职务任免右击菜单响应处理
function OnClanAppoint(selIndex , userdata)
	if userdata == 1 then
		clanAppoint("chairman")
	elseif userdata == 2 then 
		clanAppoint("viceChairman")
	elseif userdata == 3 then
		clanAppoint("member")
	end
end

--职务任免菜单
function OnAppointPopList(wnd, event)
	--如果是移动处于翻页状态 那么不弹出菜单
	if bIsMove == true then return end

	local desktop_wnd = WndSystem:GetInstance():GetGameDesktop()
	xPopupList = WndSystem:GetInstance():CreatePopupListWnd(desktop_wnd)
	--xPopupList:InitPopupList("OnClanAppoint",0,"会长",1,"副会长",2,"取消职务",3)
	local vItemData = {count=3, line_height=50, item_1="会长", item_data_1=1, item_2="副会长", item_data_2=2, item_3="取消职务", item_data_3=3}
	xPopupList:InitPopupListEx("OnClanAppoint",cjson.encode(vItemData) )
	xPopupList:SetVisible(true)
end

--查看基础信息
function OnViewClanInfo()
	WndSystem:GetInstance():ToggleWnd(1041)
end

--点击弹出右击菜单
function OnApplyPopList(wnd, event)
	local sel = listboxApplyList:GetCurSel()
	--API_Trace(sel)
	if sel == -1 then return end

	local desktop_wnd = WndSystem:GetInstance():GetGameDesktop()
	xPopupList = WndSystem:GetInstance():CreatePopupListWnd(desktop_wnd)
	--xPopupList:InitPopupList("OnPopupClick",0,"同意入会",1,"拒绝入会",2,"清空列表",3)
	local vItemData = {count=3, line_height=50, item_1="同意入会", item_data_1=1, item_2="拒绝入会", item_data_2=2, item_3="清空列表", item_data_3=3}
	xPopupList:InitPopupListEx("OnPopupClick",cjson.encode(vItemData) )
	xPopupList:SetVisible(true)
end

--点击弹出成员列表右击菜单
function OnMemberPopList(wnd, event)
	local sel = listboxMemberList:GetCurSel()
	--API_Trace(sel)
	if sel == -1 then return end
	local selActorID 	= listboxMemberList:GetItemData(sel)
	local pt 	= XDesktop:GetInstance():GetMouseXY()
	pt.x 		= pt.x + 15
	g_pGlobal:GetMainUI():ShowCreaturePopMenu(selActorID, pt)
end

--允许入会申请
function OnAllowJoinClan()
	local hero 			= core.getHero()
	local sel 			= listboxApplyList:GetCurSel()
	local selActorID	= listboxApplyList:GetItemData(sel)
	if selActorID == nil then return end

	--发送允许入会消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='allowJoinClan'
	msg.clanID		= hero:GetCrtProp(enProp_ClanID)
	msg.actorID 	= selActorID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--拒绝入会申请询问弹出框
local function OnRefuseJoinClanMess()
	local sel = listboxApplyList:GetCurSel()
	local targetActorID 	= listboxApplyList:GetItemData(sel)
	local targetActorInfo = GetClanApplyInfo(targetActorID)
	if targetActorInfo  == nil then
		return
	end
	local selActorName 	= targetActorInfo["actorName"]
	g_pGlobal:GetMainUI():ShowMessageBox("您确定拒绝["..selActorName.."]加入公会？","OnRefuseJoinClan",targetActorID,0,"确定","取消");

end
--拒绝入会申请
function OnRefuseJoinClan(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local hero = core.getHero()
	if hero == nil then return end 

--	local sel = listboxApplyList:GetCurSel()
--	local actorID 	= listboxApplyList:GetItemData(sel)
	local actorID = wparam
	if actorID == nil then return end

	--发送拒绝入会消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='refuseJoinClan'
	msg.clanID		= hero:GetCrtProp(enProp_ClanID)
	msg.actorID 	= actorID
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--清空申请列表询问框
local function OnCleanApplyListMess()
	g_pGlobal:GetMainUI():ShowMessageBox("您确定清空申请列表？","OnCleanApplyList",0,0,"确定","取消");
end
--清空申请列
function OnCleanApplyList(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	local hero = core.getHero()
	if hero == nil then return end 
	--发送清空命令
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='cleanApplyList'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function OnPopupClick( selIndex , userdata)
	
	if userdata == 1 then
		OnAllowJoinClan()
	elseif userdata == 2 then 
		OnRefuseJoinClanMess()
	elseif userdata == 3 then
		OnCleanApplyListMess()
	end
end

--设置是否允许自动加入公会
function OnCheckAutoJoin(wnd, event, status)
	--	local status = checkboxAutoJoin:GetState()
	if wnd ~= checkboxAutoJoin then
		--API_Trace("error OnCheckAutoJoin")
		return
	end

	local setFlag
	if status == 1 then
		setFlag = true
	else
		setFlag = false
	end

	local hero = core.getHero()
	if hero == nil then return end 
	--发送设置命令
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.setFlag 	= setFlag
	msg.msg_code	='setAutoAllowJoinIn'
	local str = cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)

end

--更新是否自动加入公会选项的状态
local function updateAutoJoinCheckbox(msg)
	if msg == nil then return end

	local setFlag = msg.setFlag
	if setFlag then
		checkboxAutoJoin:SetState(true)
	else
		checkboxAutoJoin:SetState(false)
	end
end


--获取玩家公会职位
function getHeroAppoint()
	--发送请求消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	='getHeroAppoint'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

--更新玩家公会职位
function updateHeroAppoint(msg)
	if msg == nil then return end
	heroAppoint = msg.appoint
	
	--更新跟职位有关的按钮状态
	if heroAppoint == "member" then
		btnKick:SetEnabled(false)
		btnAppoint:SetEnabled(false)
	else
		btnKick:SetEnabled(true)
		btnAppoint:SetEnabled(true)
	end
end

--请求所有成员actorID list
function sendMessGetMemberActorIDList()
	local hero 			= core.getHero()
	if hero == nil then API_Trace("nil hero") return end

	local clanID 	= hero:GetCrtProp(enProp_ClanID)
	if clanID == nil or clanID == 0 then
		return 0
	end
	--发送请求消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	= 'getMemberActorIDList'
	local str = cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)
end

--更新所有成员actorID list
function updateClanMemberActorIDList(msg)
	if msg == nil or msg.list == nil then return end
	memberActorIDList = msg.list
	--API_Trace(cjson.encode(memberActorIDList))
end

--返回所有成员actorID list
function GetClanMemberActorIDList()
	return memberActorIDList
end

--请求刷新公会的基本信息
function GetClanBasicInfo()
	local hero 			= core.getHero()
	if hero == nil then API_TraceError("nil hero") return end
	
	--清除数据
	clanBasicInfo = {}

	--发送请求消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	= 'getClanBasicInfo'
	local str = cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)
end

--更新公会的基本信息
local function updateClanBasicInfo(msg)
	if msg == nil or msg.clanBasicInfo == nil then return end
	clanBasicInfo = msg.clanBasicInfo

	--设置下自动入会checkbox状态
	if clanBasicInfo.autoAllowJoinIn then
		checkboxAutoJoin:SetState(true)
	else
		checkboxAutoJoin:SetState(false)
	end

end

--返回公会名
function API_GetClanName(clanID)
	--API_Trace(cjson.encode(clanBasicInfo))
	if clanID ~= nil and clanID ~= 0 then

		if allClanBasicInfo[tostring(clanID)] ~= nil and allClanBasicInfo[tostring(clanID)].clanName ~= nil then
			return allClanBasicInfo[tostring(clanID)].clanName
		end
	end
	return ""
end

--请求获取所有公会的基本信息列表
local function getAllClanListBasicInfo()
	local hero 			= core.getHero()
	if hero == nil then API_TraceError("nil hero") return end

	--发送请求消息
	local  msg = {}
	msg.module 		= "CLAN_MODULE"
	msg.msg_code	= 'getAllClanListBasicInfo'
	local str = cjson.encode(msg)
	--API_Trace(str)
	g_pGlobal:SendScriptMsg(str)	
end

--更新公会的基本信息
local function updateAllClanBasicInfo(msg)
	if msg == nil or msg.allClanBasicInfo == nil then return end
	allClanBasicInfo = msg.allClanBasicInfo
	--API_Trace(cjson.encode(allClanBasicInfo))
end

--登录时处理公会相关的流程
function DealClanWhenLogin()
	
	sendMessGetMemberActorIDList()

	GetClanBasicInfo()

	getAllClanListBasicInfo()
end

--清除数据
function ClearClanClientData()
	clanBasicInfo 			= {}
	listApplyDataCache 		= {}
	listMemberCurrentPage 	= {}
	listMemberCurrentPage   = 1
	listApplyCurrentPage	= 1
	memberActorIDList = {}
end



--初始化
clanMember_init()

m_clan.updateMemberList 			= updateMemberList
m_clan.updateApplyList 				= updateApplyList
m_clan.updateHeroAppoint			= updateHeroAppoint
m_clan.updateClanMemberActorIDList	= updateClanMemberActorIDList
m_clan.updateAutoJoinCheckbox 		= updateAutoJoinCheckbox
m_clan.updateClanBasicInfo			= updateClanBasicInfo
m_clan.updateAllClanBasicInfo		= updateAllClanBasicInfo
