

--模块定义
local m_ib={}


local ctrl_ingot ;
local ctrl_silver_ingot;
local ctrl_flip ;
local page_count ;
local s_cur_page=0;
local ib_goods={};
local shop_wnd;

--- 窗口显示，初始化数据
function ibshop_event_onshow(wnd,event)
	local hero = core.getHero()
	if hero==nil then
		return;
	end
	local ingot = hero:GetCrtProp(enProp_Actor_M_GoldIngot)
	local silver_ingot = hero:GetCrtProp(enProp_Actor_SilverIngot)
	ctrl_ingot:setText(ingot)
	ctrl_silver_ingot:setText(silver_ingot)
	local ctrl_platform = shop_wnd:getWindow('usercenter')
	ctrl_platform:SetVisible(SYHelper:HasPlatformCenter())

	m_ib.ibshop_wnd_adjustwinpos()
end

--在UI上显示
local function update_view(type)
	local  goods_list = ib_goods[type];
	local panelmgr = shop_wnd:GetScrollMgr('scrollmgr'):GetPanelMgr('panelmgr')
	
	local  panel_count = panelmgr:GetPanelCount()
	local m =  math.min(#goods_list,panel_count)
	for k=1,panel_count do
	
		local panel = panelmgr:GetPanelWnd(k-1)
		if k<= #goods_list then
			local goods = goods_list[k]
			API_Trace(goods.szName)
			panel:SetVisible(true)
			local lbl_name = panel:getWindow('name')
			lbl_name:setText(goods.name)
			local viewbox = panel:GetItemBox()
			viewbox:SetItem(goods.goodsID,goods.number)
			--price
			local price = panel:getWindow('price')
			local before_price = panel:getWindow('before_price')
			if goods.IsLower == 1 then
				price:setText(''..goods.lowerPrice)
			else
				price:setText(''..goods.price)
			end
			before_price:setText(''..goods.price)
			
			--buy
			local btn_buy = panel:getWindow('buy')
			btn_buy:SetClickEventHandler('ibshop_buy_handler')
			--改进滚动
			local smgr = shop_wnd:GetScrollMgr('scrollmgr')
			btn_buy:SetEventToWindow(smgr)
			---设置物品索引，用户点击了可以查询是那个道具，liyong
			btn_buy:SetPropertyInt32('index',k)
			btn_buy:SetPropertyInt32('type',s_cur_page)
			--money-icon
			local bmp_icon = panel:getWindow('icon_money')
			local before_bmp_icon = panel:getWindow('before_icon_money')
			if goods.nPayType== enMoneyType_Ingot  then
				bmp_icon:SetBitmapIcon(120026)
				before_bmp_icon:SetBitmapIcon(120026)
			else
				bmp_icon:SetBitmapIcon(120028)
				before_bmp_icon:SetBitmapIcon(120028)
			end
			
			--preview 
			local btn_preview = panel:getWindow('preview')
			if(goods.previewID ~= nil) then
				btn_preview:SetEnabled(goods.previewID ~= 0)
				btn_preview:SetClickEventHandler('ibshop_event_preview')
				btn_preview:SetPropertyInt32('index',k)
				btn_preview:SetPropertyInt32('type',s_cur_page)
				btn_preview:SetVisible(true)
			else
				btn_preview:SetVisible(false)
			end
			
			local dazheIcon = panel:getWindow('dazheIcon')
			local line_bmp = panel:getWindow('line')
			local panelRect = panel:GetWindowXRect()
			local iconRect = bmp_icon:GetWindowXRect()
			local priceRect = price:GetWindowXRect()
			
			if goods.IsLower == 1 then
				line_bmp:SetVisible(true)
				before_bmp_icon:SetVisible(true)
				before_price:SetVisible(true)
				dazheIcon:SetVisible(true)
				
				priceRect.top = panelRect.top+70
				iconRect.top = panelRect.top+70
				iconRect.bottom = panelRect.top+95
			else
				line_bmp:SetVisible(false)
				before_bmp_icon:SetVisible(false)
				before_price:SetVisible(false)
				dazheIcon:SetVisible(false)
				
				priceRect.top = panelRect.top+40
				iconRect.top = panelRect.top+55
			end
			bmp_icon:SetWindowRect(iconRect)
			price:SetWindowRect(priceRect)
			
		else
			panel:SetVisible(false)
		end
	end
	
end


--预览
function ibshop_event_preview(wnd,event)
	local preview= SPreView:new()
	local index = wnd:GetPropertyInt32('index')
	local page = wnd:GetPropertyInt32('type')
	local goods = ib_goods[page][index]
	preview.previewType = goods.previewType
	preview.previewID = goods.previewID
	preview.alignType = goods.alignType
	preview.action = goods.action
	
	g_pGlobal:GetGoodsClient():ShowPreviewWnd(preview,wnd)
end
--购买按钮
function ibshop_buy_handler(wnd,event)

	local index = wnd:GetPropertyInt32('index')
	local page = wnd:GetPropertyInt32('type')
	local goods = ib_goods[page][index]
	
	---获取元宝
	local nGoldIngot = core.getHero():GetCrtProp(enProp_Actor_M_GoldIngot);
	local nSilverIngot = core.getHero():GetCrtProp(enProp_Actor_SilverIngot);

	local cfg = core.getGoodsConfig(goods.goodsID)
	if (cfg == nil ) then
		return false;
	end
	
	local nPrice = 0
	if goods.IsLower == 1 then
		nPrice = goods.lowerPrice
	else
		nPrice = goods.price
	end
	
	local  bFlag = false;
	if (goods.nPayType == enMoneyType_Ingot and nGoldIngot < nPrice) then 
		bFlag = true;
	elseif (goods.nPayType == enMoneyType_VoucherIngot and nSilverIngot < nPrice and nGoldIngot < nPrice) then
		bFlag = true;
	end

	if (bFlag) then
		g_pGlobal:GetMainUI():ShowMessageBox("@goods_ingot_nomore@","ibshop_no_money_callback",0 ,0,"@goods_ingot_get@","@quxiao@");
		return false;
	end
	

	--购买确认框
	g_pGlobal:GetGoodsClient():ShowBuyConfirmDlg(goods.goodsID,goods.nPayType,nPrice,'ibshop_buy_confirm_call_back')

end

--钱不够，提示回调
function ibshop_no_money_callback(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then
		return
	end
	--充值
	g_pGlobal:GetGoodsClient():Recharge()
		
end

--购买提示回调
function ibshop_buy_confirm_call_back(goodsid,count,paytype,price)
	--价格不需要，服务器来计算，liyong
	m_ib.send_buy_goods_request(goodsid,count,paytype)
end
--查看第几页
local function view_page(page)
	local goods_list = ib_goods[page]
	if goods_list == nil then
		m_ib.view_goods(page)
	else
		update_view(s_cur_page)
	end
end
--向服务器请求物品信息
local function viewGoods(type)
	local msg = {}
	msg.module = "ibshop"
	msg.msg_code='view'
	msg.type=type
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str);
end

--物品列表返回
local function viewGoods_ack(msg)

	local  type = msg.type;
	local  goods_list = msg.goods_list;
	if(goods_list == nil ) then
		goods_list={}
	end
	ib_goods[type]=goods_list;
	
	update_view(type)
	
end


--点击按钮
function ibshop_event_page_btn_click(wnd, event)
	local btn=XButton:CastToButton(wnd)
	s_cur_page=btn:GetTag1()
	API_Trace('cur_page '..s_cur_page)
	ctrl_flip:TurnPage(s_cur_page)
	view_page(s_cur_page)

end
function ibshop_toggle_show()
	local v = not shop_wnd:IsVisible()
	m_ib.view_goods(0)
	s_cur_page = 0
	ctrl_flip:TurnPage(s_cur_page)
	if(v) then
		view_page(0)
		shop_wnd:SetVisible(v)
	end
end

--购买请求返回
local function buy_ack(msg)
	ibshop_event_onshow(0,0)
	--API_Trace('buy_ack')
	if m_ib.pay_call_back ~= nil then
		api_call_function(m_ib.pay_call_back)
	end
end
--显示导购信息
local function quickPayView_ack(msg)

	local hero = core.getHero()
	if hero == nil then
		return
	end
	--弹出快速购买界面
	g_pGlobal:GetGoodsClient():ShowQuickPayShopDlg(msg.goodsID,msg.nPayType,msg.price,msg.tips,msg.nosell,m_ib.pay_call_back,m_ib.quick_pay_param1,m_ib.quick_pay_param2)
	
end
--网络消息处理
local function ibshop_msg_handler(msg)

	if(msg.msg_code=="view") then
		m_ib.viewGoods_ack(msg)
	elseif (msg.msg_code=="buy") then
		m_ib.buy_ack(msg)
	elseif (msg.msg_code=="quickPayView") then
		m_ib.quickPayView_ack(msg);
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end	
end
--模块初始化
local  function ibshop_init()
	api_reg_module_msg_handler("ibshop",ibshop_msg_handler)
	 shop_wnd = core.createWindow('Data/Scp/Windows/Windows_Ibshop.scp',542)
	 
	 ctrl_ingot = shop_wnd:getWindow("ingot")
	 ctrl_silver_ingot=shop_wnd:getWindow("silver_ingot")
	 ctrl_flip = shop_wnd:GetFlipPage('flip')
	 page_count = ctrl_flip:GetPageNum()
	 s_cur_page=0
	--API_Trace('page count '.. page_count)
	for k=1, page_count do 
		local page_btn = ctrl_flip:GetPageBtnx(k-1)
		--API_Trace('page set lua event '.. k-1)
		page_btn:SetLuaEvent(XWIN_EVENT_CLICK, 'ibshop_event_page_btn_click')
	end
	---充值
	local ctrl_recharge = shop_wnd:GetButton('btn_recharge')
	ctrl_recharge:SetClickEventHandler('ibshop_event_recharge')
	--用户中心
	local ctrl_platform = shop_wnd:getWindow('usercenter')
	ctrl_platform:SetClickEventHandler2(function (wnd,event) --用户中心
		SYHelper:OpenPlatformCenter()
	end)
end

--充值
function ibshop_event_recharge(wnd,event)
	g_pGlobal:GetGoodsClient():Recharge()
end
--购买请求
function send_buy_goods_request(goodsid, count,paytype,call_back)

	--记住回调
	m_ib.pay_call_back=call_back
	--API_Trace('paytype '..paytype)
	local msg={}
	msg.type = s_cur_page
	msg.module='ibshop'
	msg.msg_code='buy'
	msg.nPayType=paytype
	msg.goodsID=goodsid
	msg.count=count
	local str = cjson.encode(msg)
	API_Trace(str)
	g_pGlobal:SendScriptMsg(str);
end

--导购请求
local function send_quick_pay_request(goodsid)
	--API_Trace("goodsid .."..goodsid)
	local msg={}
	msg.goodsID= goodsid
	msg.module='ibshop'
	msg.msg_code='quickPayView'
	
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str);
end

--手动调整窗口界面位置
local function ibshop_wnd_adjustwinpos()
	--API_Trace("ibshop_wnd_adjustwinpos")
	XWinUtil:AlignWindow(WndSystem:GetInstance():GetGameDesktop(), shop_wnd, XWinUtil.enXUAlign_X_CENTER,XWinUtil.enXUAlign_Y_CENTER,210,0,0,0,false)
end

--关闭界面
function ibshop_close_window(wnd,event)
	shop_wnd:SetVisible(false)
	s_cur_page = 0
	update_view(0)
	ctrl_flip:TurnPage(0)
end


--快速购买接口
function ibshop_show_quick_pay_ui(goodsid, call_back,param1,param2)
	
	m_ib.pay_call_back = call_back
	m_ib.quick_pay_param1 = param1
	m_ib.quick_pay_param2 = param2
	
	send_quick_pay_request(goodsid)
end

ibshop_init()

m_ib.send_buy_goods_request=send_buy_goods_request
m_ib.buy_ack=buy_ack
m_ib.view_goods=viewGoods
m_ib.viewGoods_ack=viewGoods_ack
m_ib.quickPayView_ack = quickPayView_ack
m_ib.ibshop_wnd_adjustwinpos = ibshop_wnd_adjustwinpos

g_pGlobal:GetEventServer():onEvent(make_msgid(CIRCULTYPE_CC, MSG_ACTION_SYNC_PROP), 
	function(obj,msgid)
		--窗口不可见就忽略
		if( not shop_wnd:IsVisible()) then return end
		
		local hero = core.getHero()
		--api_log('hero'..hero)
		--api_log('obj'..obj)
		--print(hero,obj)
		if hero==nil or  not obj:IsHero() then
			--api_log('not hero')
			return
		end
		--刷新一下元宝属性，防止元宝变化了
		local ingot = hero:GetCrtProp(enProp_Actor_M_GoldIngot)
		local silver_ingot = hero:GetCrtProp(enProp_Actor_SilverIngot)
		shop_wnd:getWindow('ingot'):setText(ingot)
		shop_wnd:getWindow('silver_ingot'):setText(silver_ingot)
	end)
	
