﻿
module("moneyManage", package.seeall)

local moduleName = "moneyManage"
local moneyManage_Wnd_ID = 1046
local msg_code = "managerMoneyBuy"

local getBuyBtn
local getDesc_label
local day_label
local ingotLabel
local managerMoneyCost 		= 300		-----购买八仙理财消耗
local buyDay				= 30		-----购买的天数
local getSilverIngotOneDay	= 100		-----每天领取绑定元宝数
local activityDesc


function MoneyManage_Wnd_init()
	
	api_reg_module_msg_handler("Recharge", moneyManage_msg_handler)
	
	MoneyManageWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',moneyManage_Wnd_ID)
	
	MoneyManageWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'OnMoneyManageGetData')
	MoneyManageWnd:SetLuaEvent(XWIN_EVENT_HIDE, 'OnMoneyManageWndHide')
	
	getBuyBtn 	= MoneyManageWnd:GetButton('购买领取')
	getBuyBtn:PlayAni(false)
	getBuyBtn:SetLuaEvent2(XWIN_EVENT_CLICK, MoneyManageGetBuy)
	
	activityDesc = MoneyManageWnd:GetHtml('规则说明')
	activityDesc:Clear()
	
	lingqu_label 	= MoneyManageWnd:GetLabel('购买领取说明')
	day_label		= MoneyManageWnd:GetLabel('显示天数')
	ingotLabel		= MoneyManageWnd:GetMoneyLabel('元宝')
	
	MoneyManageWnd:GetButton('关闭按钮'):SetLuaEvent2(XWIN_EVENT_CLICK, function () MoneyManageWnd:SetVisible(false) end)
	
end

function moneyManage_msg_handler(msg)
	if msg.msg_code == "OnShowMoneyManageWnd" then
		OnShowMoneyManageWnd(msg)
	elseif msg.msg_code == "OnUpdateMoneyManageWnd" then
		OnUpdateMoneyManageWnd(msg)
	end
end

function OnUpdateMoneyManageWnd(msg)
	local buyTime = core.getHero():GetPropEx("moneyManagerBuyTime")
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local curTime = XDate:GetInstance():GetCurrentVTime()
	
	OnShowMoneyManageWnd()
	getBuyBtn:SetEnabled(false)
	getBuyBtn:PlayAni(false)
	lingqu_label:setText('明日可领')
	ingotLabel:SetMoney(getSilverIngotOneDay)
	ingotLabel:SetMoneyType(3)
	local HaveGetDays = XDate:GetInstance():GetDays(buyTime, getTime) + 1
	if HaveGetDays > buyDay then
		HaveGetDays = buyDay 
	end
	day_label:setText((HaveGetDays)..'/'..buyDay..'天')
end

function OnMoneyManageGetData()
	local msg = {}
	msg.module =  "Recharge"
	msg.msg_code = 'moneyManageGetData'
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end
rawset(_G, "OnMoneyManageGetData", OnMoneyManageGetData)

function OnShowMoneyManageWnd(msg)
	if msg ~= nil then
		managerMoneyCost 		= msg.managerMoneyCost
		buyDay					= msg.buyDay
		getSilverIngotOneDay	= msg.getSilverIngotOneDay
		activityDesc:Clear()
		activityDesc:ParseContext('#(color,%%0,255,255%%)1、购买八仙理财需要花费#(color,red)'..managerMoneyCost..'元宝#(color,restore)。#(br,2)2、购买了八仙理财的玩家可以#(color,red)每天领取'..getSilverIngotOneDay..'元宝#(color,restore)，持续#(color,red)'..buyDay..'天#(color,restore)。总返还#(color,red)'..(getSilverIngotOneDay*buyDay)..'元宝#(color,restore)#(color,restore)')
	end
	
	local buyTime = core.getHero():GetPropEx("moneyManagerBuyTime")
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local curTime = XDate:GetInstance():GetCurrentVTime()
	
	local HaveGetDays = XDate:GetInstance():GetDays(buyTime, getTime) + 1
	local useGetTime = getTime
	if getTime == 0 then
		useGetTime = curTime
		HaveGetDays = 0
	end
	
	API_Trace(' HaveGetDays '..HaveGetDays)
	if HaveGetDays > buyDay then
		HaveGetDays = buyDay 
	end
	day_label:setText(HaveGetDays..'/'..buyDay..'天')
	
	----购买了并且没领取过 或者 当前时间和领取的时间距离大于一天 可领取 
	if (buyTime ~= 0 and getTime == 0) or XDate:GetInstance():GetDays(useGetTime, curTime) > 0 then
		getBuyBtn:setText('领取')
		getBuyBtn:PlayAni(true)
		getBuyBtn:SetEnabled(true)
		lingqu_label:setText('今日可领')
		local useTime = getTime
		if getTime == 0 and buyTime ~= 0 then
			useTime = buyTime - 86400
		end
		
		local dayNums = XDate:GetInstance():GetDays(useTime, curTime)
		API_Trace(' getTime '..getTime..' buyTime '..buyTime..' dayNums '..dayNums)
		local haveGetDayNums = XDate:GetInstance():GetDays(buyTime, getTime) + 1
		----如果第一天购买没领取 过30天后上线 会少领一天奖励 特殊处理 
		if dayNums > buyDay and getTime == 0 then
			dayNums = buyDay
		elseif dayNums + haveGetDayNums > buyDay then
			dayNums = buyDay - haveGetDayNums
		end
		---购买时间和当前同一天时 dayNums是0
		if dayNums == 0 then
			dayNums = 1
		end
		
		API_Trace('dayNums '..dayNums)
		ingotLabel:SetMoney(dayNums*getSilverIngotOneDay)
		ingotLabel:SetMoneyType(3)
		msg_code = "managerMoneyGet"
		return
	end
	
	----从购买 到今天大于30天并且没有领取完30天的奖励 或者 没购买过 可购买
	local useBuyTime = buyTime
	if buyTime == 0 then
		useBuyTime = curTime
	end
	--if (XDate:GetInstance():GetDays(buyTime, curTime) > buyDay and XDate:GetInstance():GetDays(buyTime, getTime) >= buyDay) or buyTime == 0 then
	if buyTime == 0 and getTime == 0 then
		----没有购买
		getBuyBtn:setText('购买')
		getBuyBtn:SetEnabled(true)
		getBuyBtn:PlayAni(false)
		lingqu_label:setText('购买需耗')
		ingotLabel:SetMoney(managerMoneyCost)
		ingotLabel:SetMoneyType(2)
		day_label:setText('0/'..buyDay..'天')
		msg_code = "managerMoneyBuy"
		return
	end
	
	
	getBuyBtn:setText('领取')
	getBuyBtn:SetEnabled(false)
	lingqu_label:setText('明日可领')
	ingotLabel:SetMoney(getSilverIngotOneDay)
	getBuyBtn:PlayAni(false)
end

function OnMoneyManageWndHide()
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local curTime = XDate:GetInstance():GetCurrentVTime()
	----已经领取过 隐藏主界面图标
	-- if getTime ~= 0 and XDate:GetInstance():GetDays(getTime, curTime) == 0 then
		-- local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("2013/201301"))
		-- iconset:SetChildVisible(1047, false)
	-- end
end
rawset(_G, "OnMoneyManageWndHide", OnMoneyManageWndHide)

function MoneyManageGetBuy()
	if msg_code == "managerMoneyBuy" then
		if core.getHero():GetCrtProp(enProp_Actor_M_GoldIngot) < managerMoneyCost then
			--API_ShowSystemMessage(enSysMsgDisplayType_Float, "你的元宝不足，无法购买")
			g_pGlobal:GetMainUI():ShowMessageBox("您的元宝不够#(GoldIngot,"..managerMoneyCost..")是否充值？","achievement_show_recharge",1,0,"首充大礼","充值")
			return
		end
		g_pGlobal:GetMainUI():ShowMessageBox("你确定消耗#(GoldIngot,"..managerMoneyCost..")购买八仙理财吗？","MoneyManage_IsBuyCallBack",1,0,"确定","取消")
		return
	end
	local buyTime = core.getHero():GetPropEx("moneyManagerBuyTime")
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local HaveGetDays = XDate:GetInstance():GetDays(buyTime, getTime) + 1
	if HaveGetDays > buyDay then
		HaveGetDays = buyDay
	end
	day_label:setText(HaveGetDays..'/'..buyDay..'天')
	getBuyBtn:PlayAni(false)
	getBuyBtn:SetEnabled(false)
	local msg = {}
	msg.module =  "Recharge"
	msg.msg_code = msg_code
	local str = cjson.encode(msg)
	g_pGlobal:SendScriptMsg(str)
end

function MoneyManage_IsBuyCallBack(msgid,wparam,lparam)
	if(msgid == WE_AW_BTN1_CLICKED) then
		local msg = {}
		msg.module =  "Recharge"
		msg.msg_code = msg_code
		local str = cjson.encode(msg)
		g_pGlobal:SendScriptMsg(str)
		getBuyBtn:setText('领取')
		getBuyBtn:PlayAni(true)
		lingqu_label:setText('今日可领')
		ingotLabel:SetMoney(getSilverIngotOneDay)
		ingotLabel:SetMoneyType(3)
		day_label:setText('0/'..buyDay..'天')
		msg_code = "managerMoneyGet"
		return
	end
end
rawset(_G, "MoneyManage_IsBuyCallBack", MoneyManage_IsBuyCallBack)

MoneyManage_Wnd_init()

--------------------------------------------理财launch-------------------------------------

local moneyLaunchWnd
local launchAni

function moneyLaunchInit()
	--创建窗口并初始化
	moneyLaunchWnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp', 1047, false, g_pGlobal:GetMainUI():GetSystemIconSet(0, true))

	--按下按钮
	local btn = moneyLaunchWnd:GetButton('按钮')
	btn:SetLuaEvent2(XWIN_EVENT_CLICK, OnClickMoneylaunch)
	launchAni = moneyLaunchWnd:GetAni("flashanim")
	moneyLaunchWnd:SetLuaEvent(XWIN_EVENT_SHOW, 'OnMoneyManageLaunchWndShow')
	local iconset  = API_GetWindowByPath("2013")
	--iconset:SetLuaEvent2(XWIN_EVENT_SHOW, OnIconShow)
end

function OnClickMoneylaunch()
	MoneyManageWnd:SetVisible(true)
	launchAni:PlayAni(false)
end

function OnIconShow()
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local curTime = XDate:GetInstance():GetCurrentVTime()
	----已经领取过 隐藏主界面图标
	local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("2013/201301"))
	if getTime ~= 0 and XDate:GetInstance():GetDays(getTime, curTime) == 0 then
		iconset:SetChildVisible(1047, false)
	else
		iconset:SetChildVisible(1047, true)
	end
end

function OnMoneyManageLaunchWndShow()
	local getTime = core.getHero():GetPropEx("moneyManagerGetTime")
	local curTime = XDate:GetInstance():GetCurrentVTime()
	local buyTime = core.getHero():GetPropEx("moneyManagerBuyTime")
	
	-- local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("2013/201301"))
	-- if getTime ~= 0 and XDate:GetInstance():GetDays(getTime, curTime) == 0 then
		-- iconset:SetChildVisible(1047, false)
	-- end
	--API_Trace(' getTime '..getTime)
	--API_Trace(' XDate:GetInstance():GetDays(getTime, curTime) '..(XDate:GetInstance():GetDays(getTime, curTime)))
	local useGetTime = getTime
	if getTime == 0 then
		useGetTime = curTime
	end
	if XDate:GetInstance():GetDays(useGetTime, curTime) > 0 or (getTime == 0 and buyTime~= 0) then
		launchAni:PlayAni(true)
	else
		launchAni:PlayAni(false)
	end
end
rawset(_G, "OnMoneyManageLaunchWndShow", OnMoneyManageLaunchWndShow)

function On_ShowMoneyManageIcon()
	local iconset  = XFlowCtrlMgr:CastToFlowCtrlMgr(API_GetWindowByPath("2013/201301"))
	iconset:SetChildVisible(1047, true)
end
rawset(_G, "On_ShowMoneyManageIcon", On_ShowMoneyManageIcon)

moneyLaunchInit()