---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\pvp\pvp_act_landwar.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.9.26
--版  本:	1.0
--描  述:	领地争夺战
----------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------
--需要配置的

--地图配置
local mapsConfig = {
						{icon = "Icon/map9.png", mapName = "落凤坡", 		mapID = 9 	, gain = "打怪经验 +10%  打坐灵气 +9%  #(br, 1)金币加成 +1%"},
						{icon = "Icon/map10.png", mapName = "罗浮西园寺", 	mapID = 10  , gain = "打怪经验 +10%  打坐灵气 +9%  #(br, 1)金币加成 +1%"},
						{icon = "Icon/map11.png", mapName = "中条山", 		mapID = 11  , gain = "打怪经验 +10%  打坐灵气 +9%  #(br, 1)金币加成 +1%"},
						{icon = "Icon/map12.png", mapName = "昆仑山", 		mapID = 12  , gain = "打怪经验 +10%  打坐灵气 +9%  #(br, 1)金币加成 +1%"},
						{icon = "Icon/map13.png", mapName = "东海", 		mapID = 13  , gain = "打怪经验 +10%  打坐灵气 +9%  #(br, 1)金币加成 +1%"},
					}
local occupyStr 	= "已占领"
local notOccupyStr	= "未占领"
local actDoing  	= "进行中"
----------------------------------------------------------------------------------------------------------------------
--变量
--领地信息列表
local landWarInfoList 	= nil

--窗口相关变量
local thisWnd 			= nil
local landWarInfoPanel 	= {}
local landwarClanName 		-- 占领的公会名
local landwarLandGain 		-- 领地增益
local landwarClanLevel		-- 公会等级
local landwarTeleportBtn
local landwarRuleBtn
local curLandwarInfoPanelIndex = 1 --当前选中的地图index
local landwarTimeLeft			--倒计时
local mouseX 			= nil

--函数列表
landwarFunc = {}

--网络消息处理
function LandWarMsgHandler(msg)
	--API_Trace(cjson.encode(msg))
	if msg.msg_code == "updateLandInfoList" then
		--接收到更新领地信息的数据
		landwarFunc.updateLandInfoList(msg)
	elseif msg.msg_code == "closeLandWarWnd" then
		--关闭主窗口
		OnPvpActMainWndClose()
	elseif msg.msg_code == "getRank" then
		LandwarHeroRankWnd.OnGetRank(msg)
	elseif msg.msg_code == "getRankRT" then
		LandwarRankWnd.OnGetRank(msg)
	elseif msg.msg_code == "switchRankLaunch" then
		LandwarRankLaunch.SetIsCanShowWin(msg.bShowWin)
	end
end
----------------------------------------------------------------------------------------------------------------------
--获取领地信息数据
local function GetLandInfo(mapID)
	return landWarInfoList[tostring(mapID)]
end

local function GetMapsConfig(mapID)
	for k, v in pairs(mapsConfig) do
		if v.mapID == mapID then
			return v
		end
	end
	return nil
end

---------------------------------------------------
--初始化
---------------------------------------------------
function LandwarWndInit(wnd)
	--注册消息
	api_reg_module_msg_handler("LANDWAR_MODULE",LandWarMsgHandler)


	thisWnd 		= wnd
	--注册显示回调事件
	thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnLandwarWndShow')
	
	local landWarScrollMgr 		= thisWnd:GetScrollMgr("landwar_landInfoScrollMgr")
	local landWarPanelMgr 		= landWarScrollMgr:GetPanelMgr("landwar_landInfoPanelMgr")

	for i=1, landWarPanelMgr:GetPanelCount() do
		local panelWnd 			= landWarPanelMgr:GetPanelWnd(i-1)
		local landwarLandBg 	= panelWnd:GetButton("landwar_landBg")				--背景
		local occupy 		 	= panelWnd:GetStaticBitmap("landwar_occupy")		--占领
		local notOccupy 	 	= panelWnd:GetStaticBitmap("landwar_not_occupy")	--未占领
		local notEnable 		= panelWnd:GetStaticBitmap("landwar_not_enable")	--暂未开放
		local landNameLabel 	= panelWnd:GetLabel("landwar_landName")				--地图名
		local landIcon			= panelWnd:GetStaticBitmap("landwar_landIcon")		--地图icon
		local landwarLightbtn 	= panelWnd:GetButton("landwar_lightbtn")			--高亮框
		local fireAnimate 		= panelWnd:GetAni("landwar_fireAni")				--火的光效

		panelWnd:SetEventToWindow(landWarScrollMgr)

		if mapsConfig[i] ~= nil then

			landwarLightbtn:SetManualRestore(true)

			landNameLabel:setText(mapsConfig[i].mapName)
			landIcon:SetBitmap(mapsConfig[i].icon)

			local landWarInfoItem 	= {
										panelWnd 		 = panelWnd,
										occupy 			 = occupy,
										notOccupy 		 = notOccupy,
										notEnable 		 = notEnable,
										landNameLabel 	 = landNameLabel,
										landwarLightbtn  = landwarLightbtn,
										fireAnimate		 = fireAnimate,
										landwarLandBg	 = landwarLandBg,
										--加个mapID 便于确定点击了那个pannel
										mapID 			= mapsConfig[i].mapID
										}
			table.insert(landWarInfoPanel, landWarInfoItem)

			panelWnd:SetLuaEvent(XWIN_EVENT_CLICK, 'OnUpdateLandInfo')
			panelWnd:SetLuaEvent(XWIN_EVENT_MOUSEDOWN,"OnSelectLandwar")
		else
			panelWnd:SetVisible(false)
		end
	end

	landwarClanName 			= thisWnd:GetLabel("landwar_clanName")
	landwarLandGain 			= thisWnd:GetHtml("landwar_landGain")
	landwarClanLevel 			= thisWnd:GetLabel("landwar_clanLevel")
	landwarTimeLeft  			= thisWnd:GetLabel("landwar_time")

	--传送按钮
	landwarTeleportBtn			= thisWnd:GetButton("landwar_teleportBtn")
	landwarTeleportBtn:SetClickEventHandler2( 
			function()
				if landWarInfoPanel[curLandwarInfoPanelIndex] == nil then return end

				local mapID 	= landWarInfoPanel[curLandwarInfoPanelIndex].mapID
				--发送数据请求传送
				SendMessLandwarTelePort(mapID)
			end
	)
	--规则按钮
	landwarRuleBtn				= thisWnd:GetButton("landwar_ruleBtn")
	landwarRuleBtn:SetClickEventHandler2( 
		function()
			if LandWarTip.thisWnd:IsVisible() == false then
				LandWarTip.thisWnd:SetVisible(true)
			else
				LandWarTip.thisWnd:SetVisible(false)
				LandWarTip.thisWnd:SetVisible(true)
			end
		end
	)

	--英雄榜按钮
	landwarRuleBtn				= thisWnd:GetButton("landwar_heroRankBtn")
	landwarRuleBtn:SetClickEventHandler2( 
		function()
			WndSystem:GetInstance():GetGameDesktop():FindWindowByID(1845):SetVisible(true)
		end
	)

	thisWnd:SetVisible(false)
end
---------------------------------------------------
--收到数据后 更新界面UI
---------------------------------------------------
local function UpdateLandWarWnd()
	
	if landWarInfoList == nil then
		API_Trace("landWarInfoList empty")
		return 
	end

	--更新地图略缩图
	for i=1, #landWarInfoPanel do
		local mapID 		= landWarInfoPanel[i].mapID
		
		--获取领地信息数据
		local landwarInfo = GetLandInfo(mapID)
		if landwarInfo ~= nil then
			--占领
			if landwarInfo.bEnable == false then
				landWarInfoPanel[i].notEnable:SetVisible(true)
				landWarInfoPanel[i].landwarLandBg:SetState(BS_DISABLE)
				
				landWarInfoPanel[i].occupy:SetVisible(false)
				landWarInfoPanel[i].notOccupy:SetVisible(false)
			elseif landwarInfo.status == false and landwarInfo.occupyClanID ~= 0 then
				landWarInfoPanel[i].notEnable:SetVisible(false)
				landWarInfoPanel[i].landwarLandBg:SetState(BS_UP)

				landWarInfoPanel[i].occupy:SetVisible(true)
				landWarInfoPanel[i].notOccupy:SetVisible(false)
			else
				landWarInfoPanel[i].notEnable:SetVisible(false)
				landWarInfoPanel[i].landwarLandBg:SetState(BS_UP)

				landWarInfoPanel[i].occupy:SetVisible(false)
				landWarInfoPanel[i].notOccupy:SetVisible(true)
			end

			--更新火焰
			if landwarInfo.status == true then
				landWarInfoPanel[i].fireAnimate:PlayAni(true)
			else
				landWarInfoPanel[i].fireAnimate:PlayAni(false)
			end

		end
	end

	--选中第一个
	mouseX = nil
	OnUpdateLandInfo(landWarInfoPanel[1].panelWnd)

end
---------------------------------------------------
--收到数据后更新数据
---------------------------------------------------
local function UpdateLandInfoList(msg)

	if msg.landWarInfoList == nil then 
		API_Trace("UpdateLandInfoList empty")
		return
	end

	landWarInfoList = msg.landWarInfoList
	--更新UI
	UpdateLandWarWnd()
end
---------------------------------------------------
--发送消息请求领地数据
---------------------------------------------------
local function SendMessUpdateLandInfoList()
	--请求公会列表数据
	local msg 		= {}
	msg.module 		= "LANDWAR_MODULE"
	msg.msg_code 	= 'getLandInfoList'
	local str = cjson.encode(msg)
	API_Trace(str)
	g_pGlobal:SendScriptMsg(str)
end

---------------------------------------------------
--请求传送
---------------------------------------------------
function SendMessLandwarTelePort(mapID)

	--请求传送
	local msg 		= {}
	msg.module 		= "LANDWAR_MODULE"
	msg.msg_code 	= 'teleport'
	msg.mapID 		= mapID
	local str = cjson.encode(msg)
	API_Trace(str)
	g_pGlobal:SendScriptMsg(str)
end
---------------------------------------------------
--请求传送
---------------------------------------------------
function SendMessLandwarTelePortJson(mapIDJson)
	local json = cjson.decode(mapIDJson)
	if json == nil then return end
	SendMessLandwarTelePort(json.mapID)
end


---------------------------------------------------
--显示时回调函数
---------------------------------------------------
function OnLandwarWndShow(wnd, event)
	--发送请求 更新数据
	SendMessUpdateLandInfoList()
	
	--定时器
	timer.killTimer("UpdateActTimeLeft", 1029) 		 --先kill一下
	timer.setTimer("UpdateActTimeLeft", 1029, 60000) --一分钟
end

----------------------------------------------------
--返回已经格式化的时间字符串
--传入参数 秒数
----------------------------------------------------
local function FormatTimeStr(nTime)
	local timestr = ""
	if nTime ~= 0 then
		nTime 			= nTime/60
		timestr 	= format_time_dd_hh_mm(nTime)
	else
		timestr 	= "进行中"
	end
	return timestr
end

---------------------------------------------------
--返回领地加成描述
---------------------------------------------------
local function FormatGainStr(landWarInfo)
	local str = ""
	if landWarInfo == nil  then return "" end
	
	if landWarInfo.Exp ~= nil and landWarInfo.Exp ~= 0 then
		str = "经验加成 +"..landWarInfo.Exp.."% "
	end
	
	if landWarInfo.Silver ~= nil and landWarInfo.Silver ~= 0 then
		str = str.."游戏币加成 +"..landWarInfo.Silver.."% "
	end

	if landWarInfo.LinQi ~= nil and landWarInfo.LinQi ~= 0 then
		str = str.."#(br,1)灵气加成 +"..landWarInfo.LinQi.."% "
	end
	
	if landWarInfo.HonorValue ~= nil and landWarInfo.HonorValue ~= 0 then
		str = str.."荣誉加成 +"..landWarInfo.HonorValue.."% "
	end
	
	return str
end
---------------------------------------------------
--更新下面的领地信息列表信息
---------------------------------------------------
function OnUpdateLandInfo(wnd, event)
	--API_Trace("OnUpdateLandInfo")

	--滚动的时候防止被点击到
	if mouseX ~= nil and math.abs(mouseX - XDesktop:GetInstance():GetMouseXY().x) > 10 then
		return
	end

	for i=1, #landWarInfoPanel do
		local mapID = landWarInfoPanel[i].mapID
		if wnd == landWarInfoPanel[i].panelWnd then
			--设置按钮为按下状态
			landWarInfoPanel[i].landwarLightbtn:DownButtonState()

			--获取领地信息数据
			local landWarInfo = GetLandInfo(mapID)
			if landWarInfo ~= nil then
				--更新下当前选中的地图
				curLandwarInfoPanelIndex = i

				landwarClanName:setText(landWarInfo.clanName)
				
				--local config = GetMapsConfig(mapID)
				landwarLandGain:Clear()
				landwarLandGain:ParseContext(FormatGainStr(landWarInfo))

				landwarClanLevel:setText(landWarInfo.clanLevel)
				--倒计时
				local timestr = FormatTimeStr(landWarInfo.timeLeft)
				if landWarInfo.bEnable == false then
					timestr = "暂未开放"
				end
				landwarTimeLeft:setText(timestr)
			end
		else
			--恢复按钮为弹起状态
			landWarInfoPanel[i].landwarLightbtn:RestoreButtonState()
		end
	end
end

----------------------------------------------------
--点击选择领地
----------------------------------------------------
function OnSelectLandwar()
	mouseX = XDesktop:GetInstance():GetMouseXY().x
end

----------------------------------------------------
--更新活动开始倒计时
----------------------------------------------------
function UpdateActTimeLeft()
	--API_Trace("UpdateActTimeLeft")
	for i =1, #landWarInfoPanel do

		local mapID 		= landWarInfoPanel[i].mapID
		local landwarInfo 	= GetLandInfo(mapID)
		if landwarInfo == nil then return end
		
		if landwarInfo.timeLeft ~= 0 then
			landwarInfo.timeLeft 	= landwarInfo.timeLeft - 60
		end

		if landwarInfo.timeLeft < 0 then
			landwarInfo.timeLeft = 0
		end
		
		if i == curLandwarInfoPanelIndex then
			local timestr 			= FormatTimeStr(landwarInfo.timeLeft)
			landwarTimeLeft:setText(timestr)
		end

		--火焰效果
		if landwarInfo.timeLeft == 0 then
			landWarInfoPanel[i].fireAnimate:PlayAni(true)
		else
			landWarInfoPanel[i].fireAnimate:PlayAni(false)
		end
	end
end


landwarFunc.updateLandInfoList 		= UpdateLandInfoList





