---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\pvp\pvp_act_main_wnd.lua
--版  权:	(C)盛游
--创建人:	djd
--日  期:	2013.9.26
--版  本:	1.0
--描  述:	pvp活动的主窗口.主要负责切页
--			1、领地争夺活动
--			2、王城争霸
----------------------------------------------------------------------------------------------------------------------

--**********************************************************--
------------------------一些变量------------------------------
local thisWnd  						--自己
local ctrlFlip 						--flip控件
local curPageIndex			= 2 	--当前所在的页
local subWndList			= {}	--子窗口列表
local funList	 			= {}	--函数列表

--**********************************************************--
------------------------函数列表------------------------------

--初始化
function pvpActMainWnd(wnd)
	thisWnd = wnd
	--注册显示回调事件
	thisWnd:SetLuaEvent(XWIN_EVENT_SHOW,'OnPvpActMainWndShow')

	--设置切页时的调用	
	ctrlFlip 			= thisWnd:GetFlipPage('pvpact_flipPage')
	local pageCount 	= ctrlFlip:GetPageNum()
	for k=1, pageCount do 
		local pagebtn 	= ctrlFlip:GetPageBtnx(k-1)
		pagebtn:SetLuaEvent(XWIN_EVENT_CLICK, 'OnFlipSwitch')
	end
	
	--关闭按钮
	local btn_close = thisWnd:GetButton('pvpact_btnClose')
	btn_close:SetLuaEvent(XWIN_EVENT_CLICK, 'OnPvpActMainWndClose')

	--发来显示某个子窗口的事件
	thisWnd:SetLuaEvent2(XWIN_EVENT_ON_EVENT,OnPvpActMainWndEvent)
	
	thisWnd:SetVisible(false)
end

--主窗口显示回调
function OnPvpActMainWndShow()
	--第一次显示的时候 切换到第一页
	PvpActMainWndFlipSwitch(1)
	
	--向仙界争霸的服务端请求发送界面需要的数据
	ZBClient.send_open_window()
end

--关闭事件
function OnPvpActMainWndClose()
	thisWnd:SetVisible(false)
end

--OnEvent事件
function OnPvpActMainWndEvent(pWnd,event,eventID,param1,param2)
	if eventID == 10280 then
		if not thisWnd:IsVisible() then
			thisWnd:SetVisible(true)
		end
		PvpActMainWndFlipSwitch(param1)
	end
end

--flip切换函数
--pageIndex 为第几页
function PvpActMainWndFlipSwitch(pageIndex)
	--检查
	--API_Trace(pageIndex.."PvpActMainWndFlipSwitch")
	if subWndList[pageIndex] == nil then
		API_Trace("PvpActMainWndFlipSwitch pageIndex nil ")
		return
	else
		subWndList[curPageIndex]:SetVisible(false)
		curPageIndex 			= pageIndex
		subWndList[pageIndex]:SetVisible(true)
		ctrlFlip:TurnPage(pageIndex-1)
	end
end

--添加子窗口
function PvpActMainWndSubWnd(tag, wnd)
	thisWnd:AddWindow(wnd)
	subWndList[tag] 	= wnd
	--API_Trace("tag"..tag)
end

--点击切页
function OnFlipSwitch(wnd)
	PvpActMainWndFlipSwitch(XButton:CastToButton(wnd):GetTag1())
end



---------------------------------------------------------------------
--仙界至尊 launch
---------------------------------------------------------------------
local pvpLaunch = {}
pvpLaunch.thisWnd 	= nil
pvpLaunch.ani 		= nil
function pvpLaunchInit()
	if pvpLaunch.thisWnd ~= nil then
		return
	end

	--创建各个窗口并初始化
	pvpLaunch.thisWnd = core.createWindow('Data/Scp/Windows/Windows_PvpActs.scp', 1031, false, g_pGlobal:GetMainUI():GetSystemIconSet(0, true))

	--按下按钮
	local btn = pvpLaunch.thisWnd:GetButton('pvpact_launch_btn')
	btn:SetClickEventHandler('OnPvpactLaunchBtnClick')	
	pvpLaunch.ani = pvpLaunch.thisWnd:GetAni("pvpact_ani")

	timer.setTimer("pvpLaunch_onTime", 1031, 60000) 
end

function IsInTable(t, value)
	for k, v in pairs(t) do
		if v == value then
			return true
		end
	end
	return false
end

function RemoveTableValue(t, value)
	for k, v in pairs(t) do
		if v == value then
			table.remove(t, k)
		end
	end
end

local pvpLaunchSel 	= {}
local pvpCurrentIndex 	= nil 
local flashTime = {
					{weekday = {2, 5}, beginHour = 19 ,beginMin = 55, endHour = 20, endMin = 30, mapID = {227} },
					{weekday = {3, 6}, beginHour = 20 ,beginMin = 00, endHour = 21, endMin = 00, mapID = {9,10,11,12,13} },
				}
function pvpLaunch_onTime()


	local currentWeekday 	= XDate:GetInstance():GetWeekDay()
	local currentTime 		= XDate:GetInstance():GetCurrentVTime()
	local currentStime 		= XDate:GetInstance():GetDateStruct()
	local currentMapID 		= API_GetHeroMapID()

	local bIsPlay			= false	
	for k, v in pairs(flashTime) do
		if IsInTable(v.mapID, currentMapID) == false then
			local beginStime 		= currentStime
			beginStime.hour 		= v.beginHour
			beginStime.min 			= v.beginMin
			beginStime.sec 			= 0
			local beginTime 		= XDate:GetTimeFromSTime(beginStime)
			
			local endStime 			= currentStime
			endStime.hour 			= v.endHour
			endStime.min 			= v.endMin
			endStime.sec 			= 0
			local endTime 			= XDate:GetTimeFromSTime(endStime)

			--API_Trace(cjson.encode(pvpLaunchSel))

			--活动时间期间内
			if IsInTable(v.weekday, currentWeekday) and currentTime >= beginTime and currentTime < endTime then
				if IsInTable(pvpLaunchSel, k) == false then
					bIsPlay 			= true
					pvpCurrentIndex 	= k
					--API_Trace("add"..k)
				end
			else
				--不在活动时间 取消已经点击的标志
				--API_Trace("remove"..k)
				RemoveTableValue(pvpLaunchSel, k)
			end
		end
	end
	if bIsPlay then
		if pvpLaunch.ani:IsPlaying() == false then
			pvpLaunch.ani:PlayAni(true)
		end
	else
		if pvpLaunch.ani:IsPlaying() == true then
			pvpLaunch.ani:PlayAni(false)
		end
	end
end

--点击
function OnPvpactLaunchBtnClick()
	if 	pvpLaunch.ani:IsPlaying() == true then
		pvpLaunch.ani:PlayAni(false)
		table.insert(pvpLaunchSel, pvpCurrentIndex)
	end
	thisWnd:SetVisible(not thisWnd:IsVisible())
end

--脚本初始化
pvpLaunchInit()