---------------------------------------------------------------------------------------------------------------------
--文件名:	Scp\Lua\window\reward_drop_box.lua
--版  权:	(C)盛游
--创建人:	林洪伟
--日  期:	2013.8.21
--版  本:	1.0
--描  述:	通用的副本掉落或奖励提示框。用于签到和副本提示
----------------------------------------------------------------------------------------------------------------------

RewardAndDropBox = {}

RewardAndDropBox.thiswnd = nil --自己
RewardAndDropBox.vbmgr = nil

RewardAndDropBox.module_name ="RewardAndDropBox"
RewardAndDropBox.mc_cxt = nil

local function reward_and_drop_box_init()
	--判断下如果已经初始化过就不用初始化了
	if RewardAndDropBox.thiswnd ~= nil then
		return
	end

	--创建各个窗口并初始化
	RewardAndDropBox.thiswnd = core.createWindow('Data/Scp/Windows/Windows_Goods2.scp',790)

	--设置显示时的调用
	RewardAndDropBox.thiswnd:SetLuaEvent(XWIN_EVENT_SHOW,'reward_and_drop_box_onshow')

	--设置失去焦点的时候的调用
	RewardAndDropBox.thiswnd:SetLuaEvent(XWIN_EVENT_DEACTIVATE,'reward_and_drop_box_deactivate')

	--关闭按钮
	local btn_close = RewardAndDropBox.thiswnd:GetButton('关闭按钮')
	btn_close:SetClickEventHandler('reward_and_drop_box_close')

	--监听按下
	RewardAndDropBox.vbmgr = RewardAndDropBox.thiswnd:GetViewBoxMgr('物品栏')
	for i = 1,RewardAndDropBox.vbmgr:GetSize() do
		local vb = RewardAndDropBox.vbmgr:GetViewBox(i-1)
		vb:SetLuaEvent(XWIN_EVENT_MOUSEDOWN, "reward_and_drop_box_vb_mousedown")
	end


	--注册网络消息
	api_reg_module_msg_handler(RewardAndDropBox.module_name,reward_and_drop_box_msg_handler)
end

--接收网络消息
function reward_and_drop_box_msg_handler(msg)
	if (msg.msg_code=="show_wnd") then
		RewardAndDropBox.cb_show_wnd(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

function reward_and_drop_box_onshow()

end

function reward_and_drop_box_deactivate()
	RewardAndDropBox.thiswnd:SetVisible(false)
end

function reward_and_drop_box_close()
	RewardAndDropBox.thiswnd:SetVisible(false)
end

local function cb_show_wnd(msg)
	RewardAndDropBox.mc_cxt = msg.cxt
	RewardAndDropBox.update_ui()
	RewardAndDropBox.thiswnd:SetVisible(true)
end

--显示这个窗口，参数一是上下文，要显示的描述的一类东西
function reward_and_drop_box_open(content)
	RewardAndDropBox.mc_cxt = content

	RewardAndDropBox.update_ui()

	RewardAndDropBox.thiswnd:SetVisible(true)
end

--[[上下文格式要求
	local cxt ={
		name = "签到" ,
		rewards =
		{
			{vb = {11101,1,2,},desc = "蓝色精致装备",},
			{vb = {29002,1,-1,},desc = "蓝色精致装备",},
		}
	}
--]]
local function update_ui()
	--清空先
	RewardAndDropBox.vbmgr = RewardAndDropBox.thiswnd:GetViewBoxMgr('物品栏')
	for i=1, RewardAndDropBox.vbmgr:GetSize() do
		local vb = RewardAndDropBox.vbmgr:GetViewBox(i-1)
		vb:SetAlwaysLight(false)
		vb:ClearItem()
		vb:SetShowToolTip(false)
		vb:SetVisible(false)
	end

	local desc_html = RewardAndDropBox.thiswnd:GetHtml('描述')
	desc_html:Clear()

	RewardAndDropBox.thiswnd:GetLabel('内容'):setText("")

	if RewardAndDropBox.mc_cxt == nil then
		return
	end

	--显示
	RewardAndDropBox.thiswnd:GetLabel('内容'):setText(RewardAndDropBox.mc_cxt.name)
	for i = 1,#RewardAndDropBox.mc_cxt.rewards do
		if i > RewardAndDropBox.vbmgr:GetSize() then
			break
		end
		local vb = RewardAndDropBox.vbmgr:GetViewBox(i-1)
		vb:SetVisible(true)

		local vbItem = RewardAndDropBox.mc_cxt.rewards[i].vb
		if vbItem[3] == -1 then
			vb:SetItem(vbItem[1],vbItem[2])
		else
			vb:SetItem(vbItem[1],vbItem[2],false,vbItem[3])
		end
	end

	--默认显示第一个
	reward_and_drop_box_vb_mousedown(RewardAndDropBox.vbmgr:GetViewBox(0))
end

function reward_and_drop_box_vb_mousedown(vb_sel)
	if	RewardAndDropBox.mc_cxt == nil then
		return
	end

	for i = 1,#RewardAndDropBox.mc_cxt.rewards do
		if i > RewardAndDropBox.vbmgr:GetSize() then
			break
		end
		local vb = RewardAndDropBox.vbmgr:GetViewBox(i-1)

		if vb == vb_sel then
			vb_sel:SetAlwaysLight(true)

			local desc_html = RewardAndDropBox.thiswnd:GetHtml('描述')
			desc_html:Clear()
			--如果没有奖励内容那么默认的显示对应物品的描述
			if RewardAndDropBox.mc_cxt.rewards[i].desc == nil or RewardAndDropBox.mc_cxt.rewards[i].desc == "" then
				local goods_cfg = core.getGoodsConfig(RewardAndDropBox.mc_cxt.rewards[i].vb[1])
				if goods_cfg ~= nil then
					desc_html:ParseContext(goods_cfg.strDescDetail)
				end
			else
				desc_html:ParseContext(RewardAndDropBox.mc_cxt.rewards[i].desc)
			end
		else
			vb:SetAlwaysLight(false)
		end
	end
end
-------读脚本时就执行
reward_and_drop_box_init()
RewardAndDropBox.update_ui = update_ui
RewardAndDropBox.cb_show_wnd = cb_show_wnd

--**********************************************************--
