---------------------------------------------------------------------------------------------------------------------
--文件名:	ColorfulGemMake.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.12
--版  本:	1.0
--描  述:	七彩宝石打造窗口
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("WorkskillSys.ColorfulGemMake",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "ColorfulGemMake"
local initOk = false
local cgmCfg = nil --Colorful Gem Make Config,配置表，由服务端发送
--*常量 end**********************************************************--


--*3 变量************************************************************--
thisWnd = nil
uidCurCutGoodsGem = nil --当前
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
function init()	

	--向炼器主模块注册
	local subMod = {}
	subMod.modName = modName 
	subMod.MsgHandler = MsgHandler
	WorkskillSys.AddSubMod(subMod)--将向炼器系统注册作为子系统，其实手动注册并不好，可以的话应该是在对象构造时就能自动注册,以后再改吧，Linhongwei
	
	--创建窗口
	thisWnd = core.createWindow('Data/Scp/Windows/Windows_ColorfulGemMake.scp',287)
	
	--关闭按钮
	thisWnd:GetButton('btnclose'):SetClickEventHandler2(function()
				thisWnd:SetVisible(false)
			end)
			
	--玩家创建的action
	g_pGlobal:GetEventServer():onAction(make_msgid(CIRCULTYPE_CSC, MSG_ACTION_HERO_BORN), 
		function(obj,msgid)
			--初始化容器控件，监听玩家背包
			thisWnd:GetPacketWnd("背包"):Init(XPacketFilter,XPacketSorter,XPacketTooltipTxt,XPacketTooltipClick);
			
			--请求配置
			local ret = {}
			ret.msg_code = "RequestCfg"
			WorkskillSys.MsgDispatch(ret,modName)
		end)
	
	--显示的时候
	thisWnd:SetShowEventHandler2(
		function()
			--检错下，正常不会
			if initOk == false then
				thisWnd:SetVisible(false)
			end
			
			ClearLeft()
		end
	)
	
	thisWnd:SetHideEventHandler2(ClearLeft)
	
	--点击打造的时候
	for i = 1,5 do
		local makeBtn = thisWnd:GetButton("打造"..i)
		if makeBtn ~= nil then
			makeBtn:SetLuaEvent2(XWIN_EVENT_MOUSEUP,Make)
		end
	end	
		
		
	--初始化小贴士
	local tips = "#(image,Data/UI/Common/Flip/btn_small.png)#(color,%%11,224,234%%)多彩碎片#(color,restore)#(color,%%255,241,0%%)获取#(color,restore)#(color,%%11,224,234%%):#(link,0,underlinetype=1,close=1,type=openwindow,winid=1034,optype=0,eventid=103401,param1=1,txt=荣誉商店)、#(link,0,underlinetype=1,close=0,type=openwindow,winid=1071,optype=0,txt=冰雪狂欢)#(color,restore)#(br,1)"
	tips = tips.."#(image,Data/UI/Common/Flip/btn_small.png)#(color,%%11,224,234%%)多彩元魂#(color,restore)#(color,%%255,241,0%%)获取#(color,restore)#(color,%%11,224,234%%):#(link,0,underlinetype=1,close=0,type=openwindow,winid=542,optype=0,txt=商城)购买#(color,restore)#(br,1)"
	tips = tips.."#(image,Data/UI/Common/Flip/btn_small.png)#(color,%%11,224,234%%)合成出来的多彩宝石是绑定的#(color,restore)#(br,1)"
	local  tipsHtml = thisWnd:GetHtml("提示")
	tipsHtml:Clear()
	tipsHtml:ParseContext(tips)
	
end

--背包控件的筛选器，背包要不要显示某个物品可以在这里决定，比如不希望显示30级的衣服（可以判断物品id返回false）
function XPacketFilter(goodsUid,goodsId,quality,startLevel)
	--API_Trace("1 goodsUid "..goodsUid:ToString().."  goodsId "..goodsId.."  quality "..quality.."  startLevel "..startLevel)
	--只要是宝石就显示
	local isGem = IsGem(goodsId)
	if isGem == true then
		return true
	end
	
	--材料也显示出来吧
	if cgmCfg ~= nil then
		for k,v in pairs(cgmCfg) do
			for k2,v2 in pairs(v.cutGoods) do
				if v2.goodsId == goodsId then
					return true
				end
			end
		end
	end
	
	return false
end

--是不是宝石
function IsGem(goodsId)
	local goodsCfg = core.getGoodsConfig(goodsId)
	if goodsCfg ~= nil and goodsCfg.lClass == enGoodsCategory_Common and  goodsCfg.lSubClass == enGoodsSub_Gem then
		return true,goodsCfg.lThirdSubClass
	end
	
	return false
end

--背包控件的排序器，返回负数的话goodsUid1会排前边，否则保留默认的排序顺序
function XPacketSorter(goodsUid1,goodsUid2)
	--API_Trace("2 goodsUid "..goodsUid1:ToString().." goodsUid "..goodsUid1:ToString())
	--宝石排前边
	local pGoods1 = g_pGlobal:GetClientWorld():GetGoods2(goodsUid1)
	local pGoods2 = g_pGlobal:GetClientWorld():GetGoods2(goodsUid2)
	local isGem1 = IsGem(pGoods1:GetGoodsID())
	local isGem2 = IsGem(pGoods2:GetGoodsID())
	if  isGem1 == true and  isGem2 ==false then
		return -1
	end
	
	return 1
end

--背包控件请求按钮定制,通过uid可以查到任意属性，通过goodsId可以查到任意配置表内容，不过还是把常用的暴露出来吧
function XPacketTooltipTxt(goodsUid,goodsId,quality,startLevel)
	--API_Trace("3 goodsUid "..goodsUid:ToString().."  goodsId "..goodsId.."  quality "..quality.."  startLevel "..startLevel)
	--宝石显示放入按钮，材料不显示放入按钮
	local isGem,thirdSubClass = IsGem(goodsId)
	if isGem == true and thirdSubClass <= 10 then
		return "放入","","" 
	else
		return "","","" 
	end
end



--背包控件点击按钮事件，btnType==1则是点击第一个按钮，以此类推
function XPacketTooltipClick(btnType,goodsUid,goodsId,quality,startLevel)
	--检错下
	if cgmCfg == nil or btnType ~= 1 or IsGem(goodsId) == false then
		API_Trace("btnType ~= 1 or IsGem(goodsId) == false")
		return true
	end
	
	--找到对应的等级，看有没有对应的可打造的东西
	local gemLv = goodsId%10
	local targetCfg = nil --普通宝石对应能打造的东西
	for k,v in pairs(cgmCfg) do
		if v.generalGemLv == gemLv then
			targetCfg = v
			break
		end
	end
	if targetCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该宝石不能打造多彩宝石")
		return true
	end
	
	--必须清空原来的
	ClearLeft()
	
	--设置当前材料宝石
	--local goods = g_pGlobal:GetClientWorld():GetGoods2(goodsUid)
	local cgoods = core.getHero():GetPacketPart():GetContainerGoods2(goodsUid)
	uidCurCutGoodsGem = goodsUid:ToString()
	local cutGoodsGemVb = thisWnd:GetItemViewBox("材料宝石vb")
	cutGoodsGemVb:SetItem(goodsUid)
	cgoods:SetLock(true)
	local cutGoodsGemTip = thisWnd:GetHtml("提示宝石等级")
	cutGoodsGemTip:Clear()
	
	--设置所需材料的数量
	for i = 1,5 do
		local cutGoodsVb = thisWnd:GetItemViewBox("材料"..i.."vb")
		local cutGoodsNumLabel = thisWnd:GetLabel("材料"..i.."数量")
		if cutGoodsVb ~= nil and cutGoodsNumLabel ~= nil then
			local cutGoods = targetCfg.cutGoods[i]
			if cutGoods ~= nil then
				--在背包中的数量
				local goodsCount = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(cutGoods.goodsId)
				cutGoodsVb:SetItem(cutGoods.goodsId,goodsCount)
				
				--需要的数量，不足则显示成绿色
				if goodsCount >= cutGoods.num then
					cutGoodsNumLabel:SetForeColor(14,239,72)
				else
					cutGoodsNumLabel:SetForeColor(255,0,0)
				end
				cutGoodsNumLabel:setText(tostring(cutGoods.num))
			end
		end
	end
	
	--能打造的七彩宝石
	for i = 1,5 do
		local colorfulGemVb = thisWnd:GetItemViewBox("多彩宝石vb"..i)
		local makeBtn = thisWnd:GetButton("打造"..i)
		if colorfulGemVb ~= nil and makeBtn ~= nil then
			local colorfunGem = targetCfg.colorfulGemId[i]
			if colorfunGem ~= nil then
				colorfulGemVb:SetItem(colorfunGem,1)
			end
		end
	end	
		
	
	
	return true
end

--清空左边界面
function ClearLeft()
	if uidCurCutGoodsGem ~= nil then
		local uid = core.strToUID(uidCurCutGoodsGem)
		local cgoods = core.getHero():GetPacketPart():GetContainerGoods2(uid)
		if cgoods ~=  nil then
			cgoods:SetLock(false)
		end
	end
	uidCurCutGoodsGem = nil
	
	local cutGoodsGemVb = thisWnd:GetItemViewBox("材料宝石vb")
	cutGoodsGemVb:ClearItem()
	
	local cutGoodsGemTip = thisWnd:GetHtml("提示宝石等级")
	cutGoodsGemTip:Clear()
	cutGoodsGemTip:ParseContext("#(color,%%11,224,234%%)请放入三级以上宝石#(color,restore)")
	
	for i = 1,5 do
		local cutGoodsVb = thisWnd:GetItemViewBox("材料"..i.."vb")
		local cutGoodsNumLabel = thisWnd:GetLabel("材料"..i.."数量")
		if cutGoodsVb ~= nil and cutGoodsNumLabel ~= nil then
			cutGoodsVb:ClearItem()
			cutGoodsNumLabel:SetForeColor(255,255,255)
			cutGoodsNumLabel:setText("0")
		end
	end
	
	for i = 1,5 do
		local colorfulGemVb = thisWnd:GetItemViewBox("多彩宝石vb"..i)
		local makeBtn = thisWnd:GetButton("打造"..i)
		if colorfulGemVb ~= nil and makeBtn ~= nil then
			colorfulGemVb:ClearItem()
			--makeBtn:SetEnabled(true)
		end
	end	
end

--收网络消息
function MsgHandler(msg)
	if(msg.msg_code=="RequestCfg") then --玩家请求配置
		RequestCfg(msg)
	elseif(msg.msg_code=="Finish") then --打造完成
		Finish(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

--刷新下配置在
function RequestCfg(msg)
	cgmCfg = msg.cgmCfg
	initOk = true
end

--炼器完的处理
function Finish(msg)
	if msg.success == true then
		ClearLeft()
	end
end

function Make(wnd)
	local index = XButton:CastToButton(wnd):GetTag1()
	
	if cgmCfg == nil then
		return
	end
	
	if uidCurCutGoodsGem == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先放入材料宝石")
		return
	end
	
	--对应配置
	local uid = core.strToUID(uidCurCutGoodsGem)
	local goods = g_pGlobal:GetClientWorld():GetGoods2(uid)
	if goods == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "材料宝石不存在，请重新放入")
		ClearLeft()
		return
	end
	local goodsId = goods:GetGoodsID()
	local gemLv = goodsId%10
	local targetCfg = nil --普通宝石对应能打造的东西
	for k,v in pairs(cgmCfg) do
		if v.generalGemLv == gemLv then
			targetCfg = v
			break
		end
	end
	if targetCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "材料出错")
		ClearLeft()
		return
	end
	
	--目标有没有
	if targetCfg.colorfulGemId[index] == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "没有可以打造的宝石")
		return
	end
	
	--材料够不够
	for k,v in pairs(targetCfg.cutGoods) do
		local goodsCount = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(v.goodsId)
		if goodsCount < v.num then
			local goodsCfg = core.getGoodsConfig(v.goodsId)
			local leftCount  = v.num-goodsCount
			API_ShowSystemMessage(enSysMsgDisplayType_Float, goodsCfg.szName.."数量不足,还缺少"..leftCount.."个")
			return
		end
	end

	local ret = {}
	ret.msg_code = "UseSkill"
	ret.cutGoods = {}
	ret.cutGoods[1] = {}
	ret.cutGoods[1].uidStr = uidCurCutGoodsGem
	ret.giveGoods = {}
	ret.giveGoods[1] = {}
	ret.giveGoods[1].goodsId = targetCfg.colorfulGemId[index]
	WorkskillSys.MsgDispatch(ret,modName)
	
end

--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
--*加载子模块 end****************************************************--


