---------------------------------------------------------------------------------------------------------------------
--文件名:	EquipDecompose.lua
--版  权:	(C)盛游
--创建人:	Linhongwei
--日  期:	2013.12.12
--版  本:	1.0
--描  述:	装备分解窗口
----------------------------------------------------------------------------------------------------------------------
--*1 定义模块名******************************************************--
module("WorkskillSys.EquipDecompose",package.seeall)
--*定义模块名 end****************************************************--


--*2 常量************************************************************--
local modName = "EquipDecompose"
local initOk = false
local config = nil 
--*常量 end**********************************************************--


--*3 变量************************************************************--
thisWnd = nil
uidCurGoods = nil --当前
--*变量 end**********************************************************--


--*4 函数实现********************************************************--
function init()	
	--向炼器主模块注册
	local subMod = {}
	subMod.modName = modName 
	subMod.MsgHandler = MsgHandler
	WorkskillSys.AddSubMod(subMod)--将向炼器系统注册作为子系统，其实手动注册并不好，可以的话应该是在对象构造时就能自动注册,以后再改吧，Linhongwei
	
	--创建窗口
	thisWnd = core.createWindow('Data/Scp/Windows/Windows_EquipDecompose.scp',280)
	
	--关闭按钮
	thisWnd:GetButton('btnclose'):SetClickEventHandler2(function()
				thisWnd:SetVisible(false)
			end)
			
	--玩家创建的action
	g_pGlobal:GetEventServer():onAction(make_msgid(CIRCULTYPE_CSC, MSG_ACTION_HERO_BORN), 
		function(obj,msgid)
			--初始化容器控件，监听玩家背包
			thisWnd:GetPacketWnd("背包"):Init(XPacketFilter,XPacketSorter,XPacketTooltipTxt,XPacketTooltipClick);
			
			--请求配置
			local ret = {}
			ret.msg_code = "RequestCfg"
			WorkskillSys.MsgDispatch(ret,modName)
		end)
	
	--显示的时候
	thisWnd:SetShowEventHandler2(
		function()
			--检错下，正常不会
			if initOk == false then
				thisWnd:SetVisible(false)
			end
			
			ClearLeft()
			
			local hero = core.getHero()
			if hero==nil  then return end
			thisWnd:GetMoneyLabel('游戏币'):SetMoney(hero:GetCrtProp(enProp_Actor_M_Silver))
			thisWnd:GetMoneyLabel('金币'):SetMoney(hero:GetCrtProp(enProp_Actor_M_Gold))
			thisWnd:GetMoneyLabel('元宝'):SetMoney(hero:GetCrtProp(enProp_Actor_M_GoldIngot))
			thisWnd:GetMoneyLabel('绑定元宝'):SetMoney(hero:GetCrtProp(enProp_Actor_SilverIngot))
		end
	)
	
	--监听玩家属性变化
	g_pGlobal:GetEventServer():onEvent(make_msgid(CIRCULTYPE_CC, MSG_ACTION_SYNC_PROP), 
		function(obj,msgid)
			--窗口不可见就忽略
			if( not thisWnd:IsVisible() ) then return end

			local hero = core.getHero()
			if hero==nil  then return end

			thisWnd:GetMoneyLabel('游戏币'):SetMoney(hero:GetCrtProp(enProp_Actor_M_Silver))
			thisWnd:GetMoneyLabel('金币'):SetMoney(hero:GetCrtProp(enProp_Actor_M_Gold))
			thisWnd:GetMoneyLabel('元宝'):SetMoney(hero:GetCrtProp(enProp_Actor_M_GoldIngot))
			thisWnd:GetMoneyLabel('绑定元宝'):SetMoney(hero:GetCrtProp(enProp_Actor_SilverIngot))
		end
	
	)
	
	--隐藏的时候要解锁物品
	thisWnd:SetHideEventHandler2(ClearLeft)
	
	--点击打造的时候
	thisWnd:GetButton("分解"):SetLuaEvent2(XWIN_EVENT_MOUSEUP,OnBtnStart)	
end

--背包控件的筛选器，背包要不要显示某个物品可以在这里决定，比如不希望显示30级的衣服（可以判断物品id返回false）
function XPacketFilter(goodsUid,goodsId,quality,startLevel)
	--API_Trace("1 goodsUid "..goodsUid:ToString().."  goodsId "..goodsId.."  quality "..quality.."  startLevel "..startLevel)
	--只要是装备就显示
	local equipCfg = core.getEquipConfig(goodsId)
	if equipCfg ~= nil and  ( equipCfg.lClass == enGoodsCategory_Equip_Actor or equipCfg.lClass == enGoodsCategory_Equip_Pet) and equipCfg.lNotUpgrade == 0 then
		return true
	end
	
	--材料也显示出来吧
	if config ~= nil then
		for k,v in pairs(config) do
			for k2,v2 in pairs(v.giveGoods) do
				if v2.goodsId == goodsId then
					return true
				end
			end
		end
	end
	
	return false
end

--背包控件的排序器，返回负数的话goodsUid1会排前边，否则保留默认的排序顺序
function XPacketSorter(goodsUid1,goodsUid2)
	--API_Trace("2 goodsUid "..goodsUid1:ToString().." goodsUid "..goodsUid1:ToString())
	--神工装备排前边
	local pGoods1 = g_pGlobal:GetClientWorld():GetGoods2(goodsUid1)
	local equipCfg = core.getEquipConfig(pGoods1:GetGoodsID())
	local pGoods2 = g_pGlobal:GetClientWorld():GetGoods2(goodsUid2)
	if equipCfg ~= nil and  ( equipCfg.lClass == enGoodsCategory_Equip_Actor or equipCfg.lClass == enGoodsCategory_Equip_Pet) then
		if pGoods1:GetPropNum(enProp_Goods_Quality) == 5 and pGoods2:GetPropNum(enProp_Goods_Quality) ~= 5 then
			return -1
		end
	end
	
	return 1
end

--背包控件请求按钮定制,通过uid可以查到任意属性，通过goodsId可以查到任意配置表内容，不过还是把常用的暴露出来吧
function XPacketTooltipTxt(goodsUid,goodsId,quality,startLevel)
	--API_Trace("3 goodsUid "..goodsUid:ToString().."  goodsId "..goodsId.."  quality "..quality.."  startLevel "..startLevel)
	--装备显示放入按钮
	local equipCfg = core.getEquipConfig(goodsId)
	if equipCfg ~= nil and  ( equipCfg.lClass == enGoodsCategory_Equip_Actor or equipCfg.lClass == enGoodsCategory_Equip_Pet) then
		return "放入","","" 
	else
		return "","","" 
	end
	
end



--背包控件点击按钮事件，btnType==1则是点击第一个按钮，以此类推
function XPacketTooltipClick(btnType,goodsUid,goodsId,quality,startLevel)
	--检错下
	if config == nil or btnType ~= 1  then
		API_Trace("btnType ~= 1 or uninit")
		return true
	end
	
	--找到对应的等级，看有没有对应的可打造的东西
	local goods = g_pGlobal:GetClientWorld():GetGoods2(goodsUid)
	local equipCfg = core.getEquipConfig(goodsId)
	if goods == nil or equipCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该装备不存在，请重新放入")
		ClearLeft()
		return true
	end
	
	local targetCfg = nil 
	local quality = goods:GetPropNum(enProp_Goods_Quality)
	local needLevel = equipCfg.lNeedLevel
	for k,v in pairs(config) do
		if v.equipLevel == needLevel and v.equipQuality == quality then
			targetCfg = v
			break
		end
	end
	if targetCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该装备不能分解")
		return true
	end
	
	
	--必须清空原来的
	ClearLeft()
	
	--设置当前材料宝石
	--local goods = g_pGlobal:GetClientWorld():GetGoods2(goodsUid)
	local cgoods = core.getHero():GetPacketPart():GetContainerGoods2(goodsUid)
	uidCurGoods = goodsUid:ToString()
	local cutGoodsVb = thisWnd:GetItemViewBox("消耗装备vb")
	cutGoodsVb:SetItem(goodsUid)
	cgoods:SetLock(true)
	local cutGoodsTip = thisWnd:GetHtml("消耗提示")
	cutGoodsTip:Clear()
	
	--设置所需材料的数量
	for i = 1,5 do
		local giveGoodsVb = thisWnd:GetItemViewBox("获得材料vb"..i)
		if giveGoodsVb ~= nil then
			local giveGoods = targetCfg.giveGoods[i]
			if giveGoods ~= nil then 
				giveGoodsVb:SetItem(giveGoods.goodsId,giveGoods.num)
			end
		end
	end	
	
	--消耗多少钱
	thisWnd:GetMoneyLabel('消耗游戏币'):SetMoney(targetCfg.cutRes[1].num)
	
	
	--如果有宝石或者有强化星级那么弹个消息框
	API_Trace(" "..goods:GetPropNum(enProp_Goods_StarLevel).." "..goods:GetPropNum(4034).." "..goods:GetPropNum(4035).." "..goods:GetPropNum(4036))
	local hasStarLevel = (goods:GetPropNum(enProp_Goods_StarLevel) > 0)
	local hasGem = (goods:GetPropNum(4034) or goods:GetPropNum(4035) or goods:GetPropNum(4036) ) > 0
	if hasStarLevel == true and hasGem == true then
		g_pGlobal:GetMainUI():ShowMessageBox(equipCfg.szName.."存在星级并镶嵌着宝石，确定要放入吗?","EquipDecomposeAskSureCb",0,0,"确定","取消");
	elseif hasStarLevel == true then
		g_pGlobal:GetMainUI():ShowMessageBox(equipCfg.szName.."存在星级，确定要放入吗?","EquipDecomposeAskSureCb",0,0,"确定","取消");
	elseif hasGem == true then
		g_pGlobal:GetMainUI():ShowMessageBox(equipCfg.szName.."镶嵌着宝石，确定要放入吗?","EquipDecomposeAskSureCb",0,0,"确定","取消");
	end

	return true
end

--询问有宝石和星级也要分解的回调
function AskSureCb(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then 
		ClearLeft()
	end
end

--清空左边界面
function ClearLeft()
	if uidCurGoods ~= nil then
		local uid = core.strToUID(uidCurGoods)
		local cgoods = core.getHero():GetPacketPart():GetContainerGoods2(uid)
		if cgoods ~=  nil then
			cgoods:SetLock(false)
		end
	end
	uidCurGoods = nil
	
	local cutGoodsVb = thisWnd:GetItemViewBox("消耗装备vb")
	cutGoodsVb:ClearItem()
	
	local cutGoodsTip = thisWnd:GetHtml("消耗提示")
	cutGoodsTip:Clear()
	cutGoodsTip:ParseContext("#(color,%%11,224,234%%)请放入一件不需要的神工装备#(color,restore)")
	
	local giveGoodsVb = thisWnd:GetItemViewBox("获得材料vb1")
	giveGoodsVb:ClearItem()
	
	--消耗多少钱
	thisWnd:GetMoneyLabel('消耗游戏币'):SetMoney(0)
end

--收网络消息
function MsgHandler(msg)
	if(msg.msg_code=="RequestCfg") then --玩家请求配置
		RequestCfg(msg)
	elseif(msg.msg_code=="Finish") then --完成
		Finish(msg)
	else
		API_TraceError("unknown cmd ".. msg.msg_code);
	end
end

--刷新下配置在
function RequestCfg(msg)
	config = msg.config
	initOk = true
end

--炼器完的处理
function Finish(msg)
	if msg.success == true then
		ClearLeft()
	end
end

function OnBtnStart(wnd)
	if config == nil then
		return
	end
	
	if uidCurGoods == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "请先放入想要分解的装备")
		return
	end
	
	--对应配置
	local uid = core.strToUID(uidCurGoods)
	local goods = g_pGlobal:GetClientWorld():GetGoods2(uid)
	local goodsId = goods:GetGoodsID()
	local equipCfg = core.getEquipConfig(goodsId)
	if goods == nil or equipCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该装备不存在，请重新放入")
		ClearLeft()
		return
	end
	
	local targetCfg = nil 
	local quality = goods:GetPropNum(enProp_Goods_Quality)
	local needLevel = equipCfg.lNeedLevel
	for k,v in pairs(config) do
		if v.equipLevel == needLevel and v.equipQuality == quality then
			targetCfg = v
			break
		end
	end
	if targetCfg == nil then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "该装备不能分解")
		ClearLeft()
		return
	end
	
	
	--材料够不够
	--[[for k,v in pairs(targetCfg.cutGoods) do
		local goodsCount = core.getHero():GetPacketPart():GetDestroyNumByGoodsID(v.goodsId)
		if goodsCount < v.num then
			local goodsCfg = core.getGoodsConfig(v.goodsId)
			local leftCount  = v.num-goodsCount
			API_ShowSystemMessage(enSysMsgDisplayType_Float, goodsCfg.szName.."数量不足,还缺少"..leftCount.."个")
			return
		end
	end
	--]]
	
	--游戏币够不够
	local hero = core.getHero()
	if hero==nil  then return end
	local silverMoney = hero:GetCrtProp(enProp_Actor_M_Silver)
	if silverMoney < targetCfg.cutRes[1].num then
		API_ShowSystemMessage(enSysMsgDisplayType_Float, "游戏币不足")
		return 
	end

	g_pGlobal:GetMainUI():ShowMessageBox("确定要分解"..equipCfg.szName.."吗?","EquipDecomposeOnBtnStartCb",0,0,"确定","取消");
end

function OnBtnStartCb(msgid,wparam,lparam)
	if(msgid ~= WE_AW_BTN1_CLICKED) then return end
	
	local hero = core.getHero()
	if hero == nil then return end 

	if thisWnd:IsVisible() == false then
		return
	end
	
	local ret = {}
	ret.msg_code = "UseSkill"
	ret.cutGoods = {}
	ret.cutGoods[1] = {}
	ret.cutGoods[1].uidStr = uidCurGoods
	WorkskillSys.MsgDispatch(ret,modName)
end


--*函数实现 end******************************************************--


--*5 加载脚本的时候执行**********************************************--
rawset(_G,"EquipDecomposeOnBtnStartCb",OnBtnStartCb)--把函数设置成全局的
rawset(_G,"EquipDecomposeAskSureCb",AskSureCb)--把函数设置成全局的
init()
--*加载脚本的时候执行 end********************************************--


--切记自己加载完才加载子模块。这样保证自己的功能加载完再把初始化的事情交给子模块自己，Linhongwei
--*6加载子模块*******************************************************--
--*加载子模块 end****************************************************--


