﻿-------------------------------------
-------- 窗口处理模块函数
-------------------------------------

--------------控件公共属性解析---------------
local function parse_pram(wnd,cfg) 	
	-- src
	if cfg.src ~= nil then 
		wnd:SetBitmap(cfg.src)
	end 	
	-- erect
	if cfg.erect ~= nil then
		local parent = wnd:GetParent()
		local rc = XRect:new(cfg.erect[1],cfg.erect[2],cfg.erect[3],cfg.erect[4])
		rc.right 	= rc.right+rc.left
		rc.bottom	= rc.bottom+rc.top
		if parent ~= nil then
			local rc_parent = parent:GetWindowXRect()
			if rc_parent~= nil then
				rc.left 	= rc.left+rc_parent.left
				rc.right 	= rc.right+rc_parent.left
				rc.top 		= rc.top+rc_parent.top
				rc.bottom 	= rc.bottom+rc_parent.top
			end
		end
		wnd:SetWindowRect(rc)
	end	
	
	if cfg.name ~= nil then
		wnd:SetName(cfg.name)
	end
	--split9_params
	if cfg.split9_params ~= nil then
		local rc = XRect:new(cfg.split9_params[1],cfg.split9_params[2],cfg.split9_params[3],cfg.split9_params[4])
		wnd:Set9SplitParam(true,rc)
	end	
	-- font
	if cfg.font ~= nil then
		wnd:SetFont(cfg.font)
	end	
	-- caption
	if cfg.caption ~= nil then
		wnd:setText(cfg.caption)
	end
	-- forecolor
	if cfg.forecolor ~= nil then
		wnd:SetForeColor(cfg.forecolor[1],cfg.forecolor[2],cfg.forecolor[3])
	end
	-- backcolor
	if cfg.backcolor ~= nil then
		wnd:SetBackColor(cfg.backcolor[1],cfg.backcolor[2],cfg.backcolor[3])
	end
	-- align
	if cfg.align ~= nil then
		wnd:SetAlign(cfg.align,AS_CENTERY)
	end
	-- visible
	if cfg.visible ~= nil then 
		wnd:SetVisible(cfg.visible)
	end
	-- movable
	if cfg.movable ~= nil then 
		wnd:SetMovable(cfg.movable)
	end
	-- topmost
	if cfg.topmost ~= nil then 
		wnd:SetTopmost(cfg.topmost)
	end
	if cfg.transparent ~= nil then
		wnd:SetTransparentOption(cfg.transparent)
	end
	-- subwnd
	if cfg.subwnd~= nil then
		create_window_item(wnd,cfg.subwnd) -- 子控件
	end
	
	--------------event-------------
	-- onclick
	if cfg.onclick~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_CLICK,cfg.onclick)
	end
	-- ondbclick
	if cfg.ondbclick~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_DBCLK,cfg.ondbclick)
	end
	-- onactive
	if cfg.onactive~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_ACTIVATE,cfg.onactive)
	end
	-- ondeactive
	if cfg.ondeactive~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_DEACTIVATE,cfg.ondeactive)
	end	
	-- onshow
	if cfg.onshow~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_SHOW,cfg.onshow)
	end
	-- onhide
	if cfg.onhide~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_HIDE,cfg.onhide)
	end
	-- onmousedown
	if cfg.onmousedown~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_MOUSEDOWN,cfg.onmousedown)
	end
	-- onmouseup
	if cfg.onmouseup~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_MOUSEUP,cfg.onmouseup)
	end
	-- onmousemove
	if cfg.onmousemove~= nil then
		wnd:SetLuaEvent(XWIN_EVENT_MOUSEMOVE,cfg.onmousemove)
	end
	--所有属性都存下来，备用
	for k,v in pairs(cfg) do
		
		if(type(k) =='string' and type(v)=="number") then
			wnd:SetPropertyInt32(k,v)
			--API_Trace( k.." "..v)
		end
	end
end

------------------- xwindow--------------------------------
local function create_xwindow(parent,id,cfg)
	local item = XWindow:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
end

------------------- XButton--------------------------------
local function create_xbutton(parent,id,cfg)
	local item = XButton:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	if cfg.upimg ~= nil then  -- upimg
		item:SetBitmapUp(cfg.upimg)
	end
	if cfg.downimg ~= nil then  -- downimg
		item:SetBitmapDown(cfg.downimg)
	end
	if cfg.hoverimg ~= nil then  -- hoverimg
		item:SetBitmapHover(cfg.hoverimg)
	end
	if cfg.disableimg ~= nil then  -- disableimg
		item:SetTag1(cfg.disableimg)
	end
	if cfg.tag1 ~= nil then  -- tag1
		item:SetTag1(cfg.tag1)
	end
	if cfg.tag2 ~= nil then  -- tag2
		item:SetTag2(cfg.tag2)
	end
end

------------------- WButton--------------------------------
local function create_wbutton(parent,id,cfg)
	local item = WButton:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	if cfg.tag1 ~= nil then -- tag1
		item:SetTag1(cfg.tag1)
	end
	if cfg.tag2 ~= nil then  -- tag2
		item:SetTag2(cfg.tag2)
	end
end

------------------- XLable --------------------------------
local function create_xlabel(parent,id,cfg)
	local item = XLabel:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
end

------------------- XEdit --------------------------------
local function create_xedit(parent,id,cfg)
	local item = XEdit:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
end

------------------- XAnimate --------------------------------
local function create_xanimate(parent,id,cfg)
	local item = XAnimate:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	if cfg.resID ~= nil then -- resID
		item:SetAni(cfg.resID)
	end
	if cfg.play ~= nil then -- play
		item:PlayAni(cfg.play)
	end
end

------------------- xhtml --------------------------------
local function create_xhtml(parent,id,cfg)
	local item = XHtmlControl:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	if cfg.caption ~= nil then
		item:ParseContext(cfg.caption)
	end
	if cfg.margin ~= nil then -- margin
		item:SetMargin(cfg.margin[1],cfg.margin[2])
	end
	if cfg.autowrap ~= nil then -- autowrap
		item:SetAutoWrap(cfg.autowrap)
	end	
end

------------------- xbitmap --------------------------------
local function create_xbitmap(parent,id,cfg)
	local item = XStaticBitmap:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
end

---------------------------FlipPage--------------------------
local function create_flip_page(parent,id,cfg)
	local item = XFlipPage:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	local count = item:GetChildWindowCount()
	
	for k=1,count do
		local child = item:GetChildWindowByIndex(k-1)
		local btn = XButton:CastToButton(child)
		if(btn ~= nil) then
			item:AddPage(btn)
		end
	end
end

---------------------------ScrollMgr--------------------------
local function create_scrollmgr(parent,id,cfg)
	local item = WndScrollMgr:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
end


---------------------------PanelWnd--------------------------
local function create_panel_wnd(parent,id,cfg)
	local item = CPanelWnd:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	return item
end

---------------------------itemviewbox--------------------------
local function create_itemviewbox(parent,id,cfg)
	local item = XItemViewBox:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	return item;
end

---------------------------PanelMgr--------------------------
local function create_panelmgr(parent,id,cfg)
	local item = XPanelMgr:new()
	item:SetID(id)
	parent:AddWindow(item)
	parse_pram(item,cfg)
	if(cfg.sub_panel ~= nil) then
		local id=0;
		for r=1,cfg.rowsize do
			for c=1,cfg.colsize do
				--API_Trace("create panel "..r.."x"..c);
				local panel = create_panel_wnd(item,id,cfg.sub_panel);		
				id = id+1
				--子面板需要特殊的布局处理
				item:AddPanel(panel)
			end
		end
			
		
	end
end

-------------------创建一个控件--------------------------------
function create_window_item(parent,cfg) 
	for k,v in pairs(cfg) do
		
		local id = k
		if(cfg[k].id ~= nil ) then
			id = cfg[k].id   -- id可以指定，liyong
		end
		--API_Trace("create wnd id "..id);
		if cfg[k].wndtype == 'xwindow' then -- xbutton
			create_xwindow(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xbutton' then -- xbutton
			create_xbutton(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'wbutton' then -- wbutton
			create_wbutton(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xlabel' then -- xlabel
			create_xlabel(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xedit' then -- xedit
			create_xedit(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xanimate' then -- xanimate
			create_xanimate(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xbitmap' then -- xbitmap
			create_xbitmap(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xhtml' then -- xbitmap
			create_xhtml(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xflip_page' then -- flippage
			create_flip_page(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xscrollmgr' then -- scrollmgr
			create_scrollmgr(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'xpanelmgr' then -- panelmgr
			create_panelmgr(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'itemviewbox' then -- itemviewbox
			create_itemviewbox(parent,id,cfg[k])
		
		elseif cfg[k].wndtype == 'panel_wnd' then -- panelwnd
			create_panel_wnd(parent,id,cfg[k])
		
		else
			API_TraceError("unknown wnd type ".. cfg[k].wndtype);
		end
		--API_Trace("create "..cfg[k].wndtype)
	end
end

---------------- create_mainwnd -----------------------
local function create_mainwnd(cfg) --main window
	if cfg.id == nil then
		API_TraceError("mainwnd id is nil")
		return
	end
	local wnd = XMainWnd:new()
	wnd:SetID(cfg.id)
	parse_pram(wnd,cfg)
	return wnd
end

--------------------窗口创建函数-----------------------
function api_create_wnd(cfg)
	local wnd = nil
	if cfg.wndtype == 'mainwnd' then
		wnd = create_mainwnd(cfg)
		if wnd ~= nil then  --- main窗口要加入到desktop中
			local desktop = wnd:GetDesktop()
			desktop:AddWindow(wnd) -- 加入desktop中
		end
	end
	
	if wnd ~= nil then
		if cfg.oncreate ~= nil then -- oncreate回调
			api_call_function(cfg.oncreate,wnd)
		end
	end
	return wnd
end